"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _AccordionContext = _interopRequireDefault(require("../contexts/AccordionContext"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _Collapse = _interopRequireDefault(require("./Collapse"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toArray(arr) { return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest(); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Accordion = function Accordion(props) {
  var childrenProp = props.children,
      classes = props.classes,
      defaultExpanded = props.defaultExpanded,
      disabled = props.disabled,
      other = _objectWithoutProperties(props, ["children", "classes", "defaultExpanded", "disabled"]);

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  var _React$useState = _react["default"].useState(defaultExpanded),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      expanded = _React$useState2[0],
      setExpanded = _React$useState2[1];

  _react["default"].useEffect(function () {
    setExpanded(defaultExpanded);
  }, [defaultExpanded]);

  var handleChange = _react["default"].useCallback(function () {
    setExpanded(!expanded);
  }, [expanded, setExpanded]);

  var _React$Children$toArr = _react["default"].Children.toArray(childrenProp),
      _React$Children$toArr2 = _toArray(_React$Children$toArr),
      summary = _React$Children$toArr2[0],
      children = _React$Children$toArr2.slice(1);

  var contextValue = _react["default"].useMemo(function () {
    return {
      disabled: disabled,
      expanded: expanded,
      toggle: handleChange
    };
  }, [expanded, disabled, handleChange]);

  return /*#__PURE__*/_react["default"].createElement("div", _extends({}, other, {
    className: _style["default"].dynamic([["209282601", [theme.transitions.create(["margin"]), theme.palette.divider, theme.transitions.create(["background-color", "opacity"])]]]) + " " + (other && other.className != null && other.className || (0, _clsx["default"])("root", {
      expanded: expanded,
      disabled: disabled
    }, classes) || "")
  }), /*#__PURE__*/_react["default"].createElement(_AccordionContext["default"].Provider, {
    value: contextValue
  }, summary, /*#__PURE__*/_react["default"].createElement(_Collapse["default"], {
    "in": expanded
  }, /*#__PURE__*/_react["default"].createElement("div", {
    "aria-labelledby": summary.props.id,
    id: summary.props["aria-controls"],
    className: _style["default"].dynamic([["209282601", [theme.transitions.create(["margin"]), theme.palette.divider, theme.transitions.create(["background-color", "opacity"])]]])
  }, children))), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "209282601",
    dynamic: [theme.transitions.create(["margin"]), theme.palette.divider, theme.transitions.create(["background-color", "opacity"])]
  }, ".root.__jsx-style-dynamic-selector{position:relative;-webkit-transition:".concat(theme.transitions.create(["margin"]), ";transition:").concat(theme.transitions.create(["margin"]), ";overflow-anchor:none;}.root.__jsx-style-dynamic-selector:before{position:absolute;left:0;top:-1;right:0;height:1;content:\"\";opacity:1;background-color:").concat(theme.palette.divider, ";-webkit-transition:").concat(theme.transitions.create(["background-color", "opacity"]), ";transition:").concat(theme.transitions.create(["background-color", "opacity"]), ";}.root.__jsx-style-dynamic-selector:first-child.__jsx-style-dynamic-selector:before{display:\"none\";}.root.expanded.__jsx-style-dynamic-selector:before{opacity:0;}")));
};

Accordion.propTypes = {
  /**
   * The content of the accordion.
   */
  children: _propTypes["default"].node.isRequired,

  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].array,

  /**
   * If `true`, expands the accordion by default.
   */
  defaultExpanded: _propTypes["default"].bool,

  /**
   * If `true`, the accordion will be displayed in a disabled state.
   */
  disabled: _propTypes["default"].bool
};
Accordion.defaultProps = {
  classes: [],
  defaultExpanded: false,
  disabled: false
};
Accordion.displayName = "Accordion";
var _default = Accordion;
exports["default"] = _default;