"use strict";

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _react = _interopRequireDefault(require("react"));

var _AccordionDetails = _interopRequireDefault(require("./AccordionDetails"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("AccordianDetails", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_AccordionDetails["default"], null));
    } catch (e) {
      error = e;
    }

    expect(error).toEqual(undefined);
  });
  it("renders correct snapshot", function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_AccordionDetails["default"], null));
    expect((0, _enzymeToJson["default"])(wrapper)).toMatchSnapshot();
  });
  describe("children prop", function () {
    it("displays children", function () {
      var child = /*#__PURE__*/_react["default"].createElement("h5", null, "Accordian Details");

      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_AccordionDetails["default"], null, child));
      expect(wrapper.contains(child)).toEqual(true);
    });
  });
  describe("classes prop", function () {
    it("applies classes to the root node of AccordianDetails", function () {
      var classes = ["classOne"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_AccordionDetails["default"], {
        classes: classes
      }));
      expect(wrapper.find("AccordionDetails").childAt(0).hasClass(classes[0])).toEqual(true);
    });
    it("gives an error when classes are provided as one string", function () {
      var classes = "classOne classTwo";
      var errors = jest.spyOn(console, "error").mockImplementation();
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_AccordionDetails["default"], {
        classes: classes
      }));
      expect(errors).toHaveBeenCalled();
    });
  });
});