"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _AccordionContext = _interopRequireDefault(require("../contexts/AccordionContext"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _ButtonIcon = _interopRequireDefault(require("./ButtonIcon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var AccordionSummary = function AccordionSummary(props) {
  var children = props.children,
      classes = props.classes,
      iconProps = props.iconProps,
      icon = props.icon,
      other = _objectWithoutProperties(props, ["children", "classes", "iconProps", "icon"]);

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  var getLinkedStyles = function getLinkedStyles() {
    return {
      styles: /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "1644211938",
        dynamic: [theme.transitions.create(["background-color", "min-height"]), theme.transitions.create(["margin"]), theme.transitions.create(["transform"])]
      }, ".root.__jsx-style-dynamic-selector{-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;cursor:pointer;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-transition:".concat(theme.transitions.create(["background-color", "min-height"]), ";transition:").concat(theme.transitions.create(["background-color", "min-height"]), ";-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;}.root.disabled.__jsx-style-dynamic-selector{cursor:initial;}.content.__jsx-style-dynamic-selector{-webkit-box-flex:1;-webkit-flex-grow:1;-ms-flex-positive:1;flex-grow:1;-webkit-transition:").concat(theme.transitions.create(["margin"]), ";transition:").concat(theme.transitions.create(["margin"]), ";}.icon.__jsx-style-dynamic-selector{-webkit-transform:rotate(0deg);-ms-transform:rotate(0deg);transform:rotate(0deg);-webkit-transition:").concat(theme.transitions.create(["transform"]), ";transition:").concat(theme.transitions.create(["transform"]), ";}.icon.expanded.__jsx-style-dynamic-selector{-webkit-transform:rotate(180deg);-ms-transform:rotate(180deg);transform:rotate(180deg);}")),
      className: _style["default"].dynamic([["1644211938", [theme.transitions.create(["background-color", "min-height"]), theme.transitions.create(["margin"]), theme.transitions.create(["transform"])]]])
    };
  };

  var _React$useContext = _react["default"].useContext(_AccordionContext["default"]),
      _React$useContext$dis = _React$useContext.disabled,
      disabled = _React$useContext$dis === void 0 ? false : _React$useContext$dis,
      expanded = _React$useContext.expanded,
      toggle = _React$useContext.toggle;

  var handleClick = function handleClick(event) {
    if (toggle && !disabled) {
      toggle(event);
    }
  };

  var linkedStyles = getLinkedStyles();
  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    disabled: disabled,
    "aria-expanded": expanded,
    className: (0, _clsx["default"])(linkedStyles.className, "root", {
      disabled: disabled,
      expanded: expanded
    }, classes),
    onClick: handleClick
  }, other), /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _clsx["default"])(linkedStyles.className, "content", {
      expanded: expanded
    })
  }, children), icon && /*#__PURE__*/_react["default"].createElement(_ButtonIcon["default"], _extends({
    component: "div"
  }, iconProps, {
    classes: [(0, _clsx["default"])(linkedStyles.className, "icon", {
      expanded: expanded
    }, iconProps.classes)],
    disabled: disabled
  }), icon), linkedStyles.styles);
};

AccordionSummary.propTypes = {
  /**
   * The content of the accordion summary.
   */
  children: _propTypes["default"].node,

  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].array,

  /**
   * The icon to display as the expand indicator.
   */
  icon: _propTypes["default"].node,

  /**
   * Props applied to the `ButtonIcon` element wrapping the expand icon.
   */
  iconProps: _propTypes["default"].object
};
AccordionSummary.defaultProps = {
  classes: [],
  iconProps: {}
};
AccordionSummary.displayName = "AccordionSummary";
var _default = AccordionSummary;
exports["default"] = _default;