"use strict";

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _react = _interopRequireDefault(require("react"));

var _reactFontawesome = require("@fortawesome/react-fontawesome");

var _freeSolidSvgIcons = require("@fortawesome/free-solid-svg-icons");

var _AccordionSummary = _interopRequireDefault(require("./AccordionSummary"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Icon = /*#__PURE__*/_react["default"].createElement(_reactFontawesome.FontAwesomeIcon, {
  icon: _freeSolidSvgIcons.faChevronDown
});

describe("<AccordionSummary>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_AccordionSummary["default"], null));
    } catch (theError) {
      error = theError;
    }

    expect(error).toEqual(undefined);
  });
  it("renders correct snapshot", function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_AccordionSummary["default"], null));
    expect((0, _enzymeToJson["default"])(wrapper)).toMatchSnapshot();
  });
  it("sets correct default props", function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_AccordionSummary["default"], null));
    expect(wrapper.find("AccordionSummary").props().classes).toEqual([]);
    expect(wrapper.find("AccordionSummary").props().iconProps).toEqual({});
  });
  describe("children prop", function () {
    it("displays given children", function () {
      var child = /*#__PURE__*/_react["default"].createElement("div", null, "A child");

      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_AccordionSummary["default"], null, child));
      expect(wrapper.containsMatchingElement(child)).toBeTruthy();
    });
  });
  describe("classes prop", function () {
    it("sets custom class", function () {
      var classes = ["newClass"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_AccordionSummary["default"], {
        classes: classes
      }));
      expect(wrapper.find("AccordionSummary").childAt(0).hasClass(classes[0])).toEqual(true);
    });
  });
  describe("icon prop", function () {
    it("renders icon given valid custom icon prop", function () {
      var icon = Icon;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_AccordionSummary["default"], {
        icon: icon
      }));
      expect(wrapper.find("AccordionSummary").containsMatchingElement(icon)).toEqual(true);
    });
  });
  describe("iconProps prop", function () {
    it("passes given iconProp attributes to icon prop", function () {
      var icon = Icon;
      var iconProps = {
        size: "small"
      };
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_AccordionSummary["default"], {
        icon: icon,
        iconProps: iconProps
      }));
      expect(wrapper.find("ButtonIcon").props().size).toEqual(iconProps.size);
    });
    it("passes iconProp classes to icon classes", function () {
      var icon = Icon;
      var iconProps = {
        classes: ["small"]
      };
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_AccordionSummary["default"], {
        icon: icon,
        iconProps: iconProps
      }));
      expect(wrapper.find("ButtonIcon").props().classes[2]).toContain(iconProps.classes);
    });
  });
});