"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Avatar = /*#__PURE__*/function (_React$Component) {
  _inherits(Avatar, _React$Component);

  var _super = _createSuper(Avatar);

  function Avatar() {
    _classCallCheck(this, Avatar);

    return _super.apply(this, arguments);
  }

  _createClass(Avatar, [{
    key: "getBorderSize",
    value: function getBorderSize() {
      var size = this.props.size; // Remove 'px' and get number of pixels

      var pixels = +size.substring(0, size.length - 2);

      switch (true) {
        case pixels < 70:
          return "2px";

        default:
          return "4px";
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          alt = _this$props.alt,
          backgroundColor = _this$props.backgroundColor,
          children = _this$props.children,
          classes = _this$props.classes,
          size = _this$props.size,
          src = _this$props.src,
          variant = _this$props.variant,
          other = _objectWithoutProperties(_this$props, ["alt", "backgroundColor", "children", "classes", "size", "src", "variant"]);

      var theme = this.context;
      var className = (0, _clsx["default"])("avatar", variant, classes, "background-".concat(backgroundColor));
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("span", {
        className: _style["default"].dynamic([["1174196656", [this.getBorderSize(), theme.palette.common.white, theme.typography.fontFamily, size, size, size, size, size, size, theme.palette.grey[200], theme.palette.common.white, theme.shape.borderRadius.md]]]) + " " + (className || "")
      }, src ? /*#__PURE__*/_react["default"].createElement("img", _extends({
        alt: alt,
        src: src
      }, other, {
        className: _style["default"].dynamic([["1174196656", [this.getBorderSize(), theme.palette.common.white, theme.typography.fontFamily, size, size, size, size, size, size, theme.palette.grey[200], theme.palette.common.white, theme.shape.borderRadius.md]]]) + " " + (other && other.className != null && other.className || "image")
      })) : /*#__PURE__*/_react["default"].createElement("span", _extends({}, other, {
        className: _style["default"].dynamic([["1174196656", [this.getBorderSize(), theme.palette.common.white, theme.typography.fontFamily, size, size, size, size, size, size, theme.palette.grey[200], theme.palette.common.white, theme.shape.borderRadius.md]]]) + " " + (other && other.className != null && other.className || "inner")
      }), children)), /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "1174196656",
        dynamic: [this.getBorderSize(), theme.palette.common.white, theme.typography.fontFamily, size, size, size, size, size, size, theme.palette.grey[200], theme.palette.common.white, theme.shape.borderRadius.md]
      }, ".avatar.__jsx-style-dynamic-selector{border:".concat(this.getBorderSize(), " solid ").concat(theme.palette.common.white, ";display:inline-block;font-family:").concat(theme.typography.fontFamily, ";font-size:calc(").concat(size, " * 0.4);height:").concat(size, ";line-height:1;max-height:").concat(size, ";max-width:").concat(size, ";min-height:").concat(size, ";min-width:").concat(size, ";overflow:hidden;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;}.background-grey200.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.grey[200], ";}.background-white.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.common.white, ";}.circle.__jsx-style-dynamic-selector{border-radius:50%;}.image.__jsx-style-dynamic-selector{height:100%;width:100%;}.inner.__jsx-style-dynamic-selector{-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-shrink:0;-ms-flex-negative:0;flex-shrink:0;height:100%;-webkit-box-pack:center;-webkit-justify-content:center;-ms-flex-pack:center;justify-content:center;width:100%;}.rounded.__jsx-style-dynamic-selector{border-radius:").concat(theme.shape.borderRadius.md, ";}.square.__jsx-style-dynamic-selector{border-radius:0px;}")));
    }
  }]);

  return Avatar;
}(_react["default"].Component);

_defineProperty(Avatar, "displayName", "Avatar");

_defineProperty(Avatar, "propTypes", {
  /**
   * Used to provide an alt attribute to the rendered img element.
   */
  alt: _propTypes["default"].string,

  /**
   * Used to render icon or text elements inside the Avatar if src is not set.
   */
  children: _propTypes["default"].node,

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * The color of the background for the Avatar
   */
  backgroundColor: _propTypes["default"].oneOf(["grey200", "white"]),

  /**
   * The height and width size to render the Avatar at.
   */
  size: _propTypes["default"].string.isRequired,

  /**
   * The src attribute for the img element.
   */
  src: _propTypes["default"].string,

  /**
   * The shape of the avatar.
   */
  variant: _propTypes["default"].oneOf(["circle", "rounded", "square"])
});

_defineProperty(Avatar, "defaultProps", {
  classes: [],
  backgroundColor: "grey200",
  size: "96px",
  variant: "circle"
});

_defineProperty(Avatar, "contextType", _ThemeContext["default"]);

var _default = (0, _withClasses["default"])(Avatar);

exports["default"] = _default;