"use strict";

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _react = _interopRequireDefault(require("react"));

var _Backdrop = _interopRequireDefault(require("./Backdrop"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<Backdrop>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Backdrop["default"], null));
    } catch (e) {
      error = e;
    }

    expect(error).toEqual(undefined);
  });
  it("renders correct snapshot", function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Backdrop["default"], null));
    expect((0, _enzymeToJson["default"])(wrapper)).toMatchSnapshot();
  });
  describe("children prop", function () {
    it("has given child", function () {
      var child = /*#__PURE__*/_react["default"].createElement("h1", null, "The children prop");

      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Backdrop["default"], null, child));
      expect(wrapper.find("Backdrop").children().contains(child)).toEqual(true);
    });
  });
  describe("classes prop", function () {
    it("applies classes to the root node of Backdrop", function () {
      var classes = ["classOne"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Backdrop["default"], {
        classes: classes
      }));
      expect(wrapper.find("Backdrop").childAt(0).hasClass(classes[0])).toEqual(true);
    });
    it("appends higher order values to classes prop with withClasses decorator", function () {
      var classes = ["riipen", "riipen-backdrop"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Backdrop["default"], null));
      expect(wrapper.find("Backdrop").props().classes.sort()).toEqual(classes.sort());
    });
    it("gives an error when classes are provided as one string", function () {
      var classes = "classOne classTwo";
      var errors = jest.spyOn(console, "error").mockImplementation();
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Backdrop["default"], {
        classes: classes
      }));
      expect(errors).toHaveBeenCalled();
    });
  });
});