"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var RADIUS_STANDARD = 10;
var RADIUS_DOT = 5;

var Badge = /*#__PURE__*/function (_React$Component) {
  _inherits(Badge, _React$Component);

  var _super = _createSuper(Badge);

  function Badge() {
    _classCallCheck(this, Badge);

    return _super.apply(this, arguments);
  }

  _createClass(Badge, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          anchor = _this$props.anchor,
          children = _this$props.children,
          classes = _this$props.classes,
          color = _this$props.color,
          Component = _this$props.component,
          content = _this$props.content,
          max = _this$props.max,
          overlap = _this$props.overlap,
          showZero = _this$props.showZero,
          size = _this$props.size,
          variant = _this$props.variant;
      var theme = this.context;
      var className = (0, _clsx["default"])("root");
      var value = "";

      if (variant === "standard") {
        value = content > max ? "".concat(max, "+") : content;
      }

      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(Component, {
        className: _style["default"].dynamic([["1582520044", [RADIUS_STANDARD, theme.palette.text.primary, theme.typography.fontFamily, theme.typography.fontWeight.medium, theme.typography.body3.fontSize, theme.typography.body3.lineHeight, theme.typography.body2.fontSize, RADIUS_STANDARD * 2, RADIUS_STANDARD * 2, RADIUS_DOT * 2, RADIUS_DOT * 2, theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.grey[400], theme.palette.negative.contrast, theme.breakpoints.sm, theme.typography.body2.mobile.fontSize, theme.typography.body2.mobile.lineHeight, theme.typography.body3.mobile.fontSize, theme.typography.body3.mobile.lineHeight]]]) + " " + (className || "")
      }, children, /*#__PURE__*/_react["default"].createElement("span", {
        className: _style["default"].dynamic([["1582520044", [RADIUS_STANDARD, theme.palette.text.primary, theme.typography.fontFamily, theme.typography.fontWeight.medium, theme.typography.body3.fontSize, theme.typography.body3.lineHeight, theme.typography.body2.fontSize, RADIUS_STANDARD * 2, RADIUS_STANDARD * 2, RADIUS_DOT * 2, RADIUS_DOT * 2, theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.grey[400], theme.palette.negative.contrast, theme.breakpoints.sm, theme.typography.body2.mobile.fontSize, theme.typography.body2.mobile.lineHeight, theme.typography.body3.mobile.fontSize, theme.typography.body3.mobile.lineHeight]]]) + " " + ((0, _clsx["default"])("badge", !content && !showZero ? "hidden" : null, "".concat(anchor.vertical, "-").concat(anchor.horizontal, "-").concat(overlap), color, variant, variant === "standard" && size, classes) || "")
      }, value)), /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "1582520044",
        dynamic: [RADIUS_STANDARD, theme.palette.text.primary, theme.typography.fontFamily, theme.typography.fontWeight.medium, theme.typography.body3.fontSize, theme.typography.body3.lineHeight, theme.typography.body2.fontSize, RADIUS_STANDARD * 2, RADIUS_STANDARD * 2, RADIUS_DOT * 2, RADIUS_DOT * 2, theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.grey[400], theme.palette.negative.contrast, theme.breakpoints.sm, theme.typography.body2.mobile.fontSize, theme.typography.body2.mobile.lineHeight, theme.typography.body3.mobile.fontSize, theme.typography.body3.mobile.lineHeight]
      }, ".root.__jsx-style-dynamic-selector{display:-webkit-inline-box;display:-webkit-inline-flex;display:-ms-inline-flexbox;display:inline-flex;-webkit-flex-shrink:0;-ms-flex-negative:0;flex-shrink:0;-webkit-box-pack:end;-webkit-justify-content:flex-end;-ms-flex-pack:end;justify-content:flex-end;position:relative;vertical-align:middle;}.badge.__jsx-style-dynamic-selector{-webkit-align-content:center;-ms-flex-line-pack:center;align-content:center;-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;border-radius:".concat(RADIUS_STANDARD, "px;box-sizing:border-box;color:").concat(theme.palette.text.primary, ";display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-direction:row;-ms-flex-direction:row;flex-direction:row;-webkit-flex-wrap:wrap;-ms-flex-wrap:wrap;flex-wrap:wrap;font-family:").concat(theme.typography.fontFamily, ";font-weight:").concat(theme.typography.fontWeight.medium, ";-webkit-box-pack:center;-webkit-justify-content:center;-ms-flex-pack:center;justify-content:center;position:absolute;}.hidden.__jsx-style-dynamic-selector{display:none;}.badge.small.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.body3.fontSize, ";height:14px;-webkit-letter-spacing:0;-moz-letter-spacing:0;-ms-letter-spacing:0;letter-spacing:0;line-height:").concat(theme.typography.body3.lineHeight, ";min-width:14px;padding:1px 2px;}.badge.medium.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.body2.fontSize, ";height:").concat(RADIUS_STANDARD * 2, "px;line-height:1;min-width:").concat(RADIUS_STANDARD * 2, "px;padding:0 6px;}.dot.__jsx-style-dynamic-selector{height:").concat(RADIUS_DOT * 2, "px;min-width:").concat(RADIUS_DOT * 2, "px;padding:0;}.primary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.primary.main, ";color:").concat(theme.palette.primary.contrast, ";}.secondary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.secondary.main, ";color:").concat(theme.palette.secondary.contrast, ";}.positive.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.positive.main, ";color:").concat(theme.palette.positive.contrast, ";}.negative.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.negative.main, ";color:").concat(theme.palette.negative.contrast, ";}.muted.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.grey[400], ";color:").concat(theme.palette.negative.contrast, ";}.top-right-rectangle.__jsx-style-dynamic-selector{top:0;right:0;-webkit-transform:scale(1) translate(50%,-50%);-ms-transform:scale(1) translate(50%,-50%);transform:scale(1) translate(50%,-50%);-webkit-transform-origin:100% 0%;-ms-transform-origin:100% 0%;transform-origin:100% 0%;}.bottom-right-rectangle.__jsx-style-dynamic-selector{bottom:0;right:0;-webkit-transform:scale(1) translate(50%,50%);-ms-transform:scale(1) translate(50%,50%);transform:scale(1) translate(50%,50%);-webkit-transform-origin:100% 100%;-ms-transform-origin:100% 100%;transform-origin:100% 100%;}.top-left-rectangle.__jsx-style-dynamic-selector{top:0;left:0;-webkit-transform:scale(1) translate(-50%,-50%);-ms-transform:scale(1) translate(-50%,-50%);transform:scale(1) translate(-50%,-50%);-webkit-transform-origin:0% 0%;-ms-transform-origin:0% 0%;transform-origin:0% 0%;}.bottom-left-rectangle.__jsx-style-dynamic-selector{bottom:0;left:0;-webkit-transform:scale(1) translate(-50%,50%);-ms-transform:scale(1) translate(-50%,50%);transform:scale(1) translate(-50%,50%);-webkit-transform-origin:0% 100%;-ms-transform-origin:0% 100%;transform-origin:0% 100%;}.top-right-circle.__jsx-style-dynamic-selector{top:14%;right:14%;-webkit-transform:scale(1) translate(50%,-50%);-ms-transform:scale(1) translate(50%,-50%);transform:scale(1) translate(50%,-50%);-webkit-transform-origin:100% 0%;-ms-transform-origin:100% 0%;transform-origin:100% 0%;}.bottom-right-circle.__jsx-style-dynamic-selector{bottom:14%;right:14%;-webkit-transform:scale(1) translate(50%,50%);-ms-transform:scale(1) translate(50%,50%);transform:scale(1) translate(50%,50%);-webkit-transform-origin:100% 100%;-ms-transform-origin:100% 100%;transform-origin:100% 100%;}.top-left-circle.__jsx-style-dynamic-selector{top:14%;left:14%;-webkit-transform:scale(1) translate(-50%,-50%);-ms-transform:scale(1) translate(-50%,-50%);transform:scale(1) translate(-50%,-50%);-webkit-transform-origin:0% 0%;-ms-transform-origin:0% 0%;transform-origin:0% 0%;}.bottom-left-circle.__jsx-style-dynamic-selector{bottom:14%;left:14%;-webkit-transform:scale(1) translate(-50%,50%);-ms-transform:scale(1) translate(-50%,50%);transform:scale(1) translate(-50%,50%);-webkit-transform-origin:0% 100%;-ms-transform-origin:0% 100%;transform-origin:0% 100%;}@media (max-width:").concat(theme.breakpoints.sm, "px){.badge.medium.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.body2.mobile.fontSize, ";line-height:").concat(theme.typography.body2.mobile.lineHeight, ";}.badge.small.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.body3.mobile.fontSize, ";line-height:").concat(theme.typography.body3.mobile.lineHeight, ";}}")));
    }
  }]);

  return Badge;
}(_react["default"].Component);

_defineProperty(Badge, "displayName", "Badge");

_defineProperty(Badge, "propTypes", {
  /**
   * The anchor of the badge.
   */
  anchor: _propTypes["default"].shape({
    horizontal: _propTypes["default"].oneOf(["left", "right"]).isRequired,
    vertical: _propTypes["default"].oneOf(["bottom", "top"]).isRequired
  }),

  /**
   * The badge will be added relative to this node.
   */
  children: _propTypes["default"].node,

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * The color of the component. It supports those theme colors that make sense for this component.
   */
  color: _propTypes["default"].oneOf(["negative", "positive", "primary", "secondary", "muted"]),

  /**
   * The component used for the root node.
   * Either a string to use a DOM element or a component.
   */
  component: _propTypes["default"].elementType,

  /**
   * The content rendered within the badge.
   */
  content: _propTypes["default"].node,

  /**
   * Max count to show.
   */
  max: _propTypes["default"].number,

  /**
   * Wrapped shape the badge should overlap.
   */
  overlap: _propTypes["default"].oneOf(["circle", "rectangle"]),

  /**
   * Controls whether the badge is hidden when `content` is zero.
   */
  showZero: _propTypes["default"].bool,

  /**
   * The size of the badge. Only applicable to 'standard' variant.
   */
  size: _propTypes["default"].oneOf(["small", "medium"]),

  /**
   * The variant to use.
   */
  variant: _propTypes["default"].oneOf(["dot", "standard"])
});

_defineProperty(Badge, "defaultProps", {
  anchor: {
    horizontal: "right",
    vertical: "top"
  },
  color: "primary",
  component: "span",
  max: 99,
  overlap: "rectangle",
  showZero: false,
  size: "medium",
  variant: "standard"
});

_defineProperty(Badge, "contextType", _ThemeContext["default"]);

var _default = (0, _withClasses["default"])(Badge);

exports["default"] = _default;