"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _utils = require("../utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Button = function Button(props) {
  var children = props.children,
      classes = props.classes,
      color = props.color,
      theme = props.theme,
      component = props.component,
      disabled = props.disabled,
      fullWidth = props.fullWidth,
      IconEnd = props.iconEnd,
      IconStart = props.iconStart,
      mobileBreakpoint = props.mobileBreakpoint,
      size = props.size,
      type = props.type,
      variant = props.variant,
      other = _objectWithoutProperties(props, ["children", "classes", "color", "theme", "component", "disabled", "fullWidth", "iconEnd", "iconStart", "mobileBreakpoint", "size", "type", "variant"]);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      focusVisible = _useState2[0],
      setFocusVisible = _useState2[1];

  var _useIsFocusVisible = (0, _utils.useIsFocusVisible)(),
      ref = _useIsFocusVisible.ref,
      isFocusVisible = _useIsFocusVisible.isFocusVisible,
      onBlurVisible = _useIsFocusVisible.onBlurVisible;

  var handleFocus = function handleFocus(e) {
    setFocusVisible(isFocusVisible(e));
  };

  var handleBlur = function handleBlur() {
    setFocusVisible(false);
    onBlurVisible();
  };

  var className = (0, _clsx["default"])("root", disabled ? "disabled" : null, focusVisible ? "focusVisible" : null, fullWidth ? "full-width" : null, size, variant, variant === "contained" ? "contained-".concat(color) : null, variant === "text" ? "text-".concat(color) : null, variant === "outlined" ? "outlined-".concat(color) : null, variant === "inverted" ? "inverted-".concat(color) : null, classes);
  var Component = component || other.href ? "a" : "button";
  if (component) Component = component;
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(Component, _extends({
    ref: ref,
    disabled: disabled,
    type: type,
    onFocus: handleFocus,
    onBlur: handleBlur
  }, other, {
    className: _style["default"].dynamic([["3894020684", [theme.palette.grey[300], theme.shape.borderRadius.md, theme.palette.text.primary, theme.spacing(2), theme.spacing(3), theme.transitions.duration.standard, theme.palette.grey[400], theme.spacing(2), theme.spacing(2), theme.spacing(1), theme.spacing(2), theme.spacing(3), theme.spacing(5), theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.primary.dark, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.secondary.dark, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.tertiary.dark, theme.palette.common.white, theme.palette.common.black, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.positive.dark, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.negative.dark, theme.palette.text.primary, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.common.white, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.primary.main, theme.palette.common.white, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.tertiary.main, theme.palette.positive.main, theme.palette.common.white, theme.palette.positive.main, theme.palette.negative.main, theme.palette.common.white, theme.palette.negative.main, theme.typography.fontFamily, theme.typography.button.fontSize, theme.typography.fontWeight.medium, theme.typography.button.lineHeight, theme.breakpoints[mobileBreakpoint], theme.typography.button.mobile.fontSize, theme.spacing(1), theme.spacing(1), theme.typography.button.mobile.fontSize, theme.typography.button.mobile.lineHeight]]]) + " " + (other && other.className != null && other.className || className || "")
  }), /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["3894020684", [theme.palette.grey[300], theme.shape.borderRadius.md, theme.palette.text.primary, theme.spacing(2), theme.spacing(3), theme.transitions.duration.standard, theme.palette.grey[400], theme.spacing(2), theme.spacing(2), theme.spacing(1), theme.spacing(2), theme.spacing(3), theme.spacing(5), theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.primary.dark, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.secondary.dark, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.tertiary.dark, theme.palette.common.white, theme.palette.common.black, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.positive.dark, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.negative.dark, theme.palette.text.primary, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.common.white, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.primary.main, theme.palette.common.white, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.tertiary.main, theme.palette.positive.main, theme.palette.common.white, theme.palette.positive.main, theme.palette.negative.main, theme.palette.common.white, theme.palette.negative.main, theme.typography.fontFamily, theme.typography.button.fontSize, theme.typography.fontWeight.medium, theme.typography.button.lineHeight, theme.breakpoints[mobileBreakpoint], theme.typography.button.mobile.fontSize, theme.spacing(1), theme.spacing(1), theme.typography.button.mobile.fontSize, theme.typography.button.mobile.lineHeight]]]) + " " + ((0, _clsx["default"])("label") || "")
  }, IconStart && /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["3894020684", [theme.palette.grey[300], theme.shape.borderRadius.md, theme.palette.text.primary, theme.spacing(2), theme.spacing(3), theme.transitions.duration.standard, theme.palette.grey[400], theme.spacing(2), theme.spacing(2), theme.spacing(1), theme.spacing(2), theme.spacing(3), theme.spacing(5), theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.primary.dark, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.secondary.dark, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.tertiary.dark, theme.palette.common.white, theme.palette.common.black, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.positive.dark, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.negative.dark, theme.palette.text.primary, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.common.white, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.primary.main, theme.palette.common.white, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.tertiary.main, theme.palette.positive.main, theme.palette.common.white, theme.palette.positive.main, theme.palette.negative.main, theme.palette.common.white, theme.palette.negative.main, theme.typography.fontFamily, theme.typography.button.fontSize, theme.typography.fontWeight.medium, theme.typography.button.lineHeight, theme.breakpoints[mobileBreakpoint], theme.typography.button.mobile.fontSize, theme.spacing(1), theme.spacing(1), theme.typography.button.mobile.fontSize, theme.typography.button.mobile.lineHeight]]]) + " " + ((0, _clsx["default"])("icon", "icon-start") || "")
  }, typeof IconStart === "function" ? /*#__PURE__*/_react["default"].createElement(IconStart, {
    className: _style["default"].dynamic([["3894020684", [theme.palette.grey[300], theme.shape.borderRadius.md, theme.palette.text.primary, theme.spacing(2), theme.spacing(3), theme.transitions.duration.standard, theme.palette.grey[400], theme.spacing(2), theme.spacing(2), theme.spacing(1), theme.spacing(2), theme.spacing(3), theme.spacing(5), theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.primary.dark, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.secondary.dark, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.tertiary.dark, theme.palette.common.white, theme.palette.common.black, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.positive.dark, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.negative.dark, theme.palette.text.primary, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.common.white, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.primary.main, theme.palette.common.white, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.tertiary.main, theme.palette.positive.main, theme.palette.common.white, theme.palette.positive.main, theme.palette.negative.main, theme.palette.common.white, theme.palette.negative.main, theme.typography.fontFamily, theme.typography.button.fontSize, theme.typography.fontWeight.medium, theme.typography.button.lineHeight, theme.breakpoints[mobileBreakpoint], theme.typography.button.mobile.fontSize, theme.spacing(1), theme.spacing(1), theme.typography.button.mobile.fontSize, theme.typography.button.mobile.lineHeight]]])
  }) : IconStart), children, IconEnd && /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["3894020684", [theme.palette.grey[300], theme.shape.borderRadius.md, theme.palette.text.primary, theme.spacing(2), theme.spacing(3), theme.transitions.duration.standard, theme.palette.grey[400], theme.spacing(2), theme.spacing(2), theme.spacing(1), theme.spacing(2), theme.spacing(3), theme.spacing(5), theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.primary.dark, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.secondary.dark, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.tertiary.dark, theme.palette.common.white, theme.palette.common.black, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.positive.dark, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.negative.dark, theme.palette.text.primary, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.common.white, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.primary.main, theme.palette.common.white, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.tertiary.main, theme.palette.positive.main, theme.palette.common.white, theme.palette.positive.main, theme.palette.negative.main, theme.palette.common.white, theme.palette.negative.main, theme.typography.fontFamily, theme.typography.button.fontSize, theme.typography.fontWeight.medium, theme.typography.button.lineHeight, theme.breakpoints[mobileBreakpoint], theme.typography.button.mobile.fontSize, theme.spacing(1), theme.spacing(1), theme.typography.button.mobile.fontSize, theme.typography.button.mobile.lineHeight]]]) + " " + ((0, _clsx["default"])("icon", "icon-end") || "")
  }, typeof IconEnd === "function" ? /*#__PURE__*/_react["default"].createElement(IconEnd, {
    className: _style["default"].dynamic([["3894020684", [theme.palette.grey[300], theme.shape.borderRadius.md, theme.palette.text.primary, theme.spacing(2), theme.spacing(3), theme.transitions.duration.standard, theme.palette.grey[400], theme.spacing(2), theme.spacing(2), theme.spacing(1), theme.spacing(2), theme.spacing(3), theme.spacing(5), theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.primary.dark, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.secondary.dark, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.tertiary.dark, theme.palette.common.white, theme.palette.common.black, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.positive.dark, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.negative.dark, theme.palette.text.primary, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.common.white, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.primary.main, theme.palette.common.white, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.tertiary.main, theme.palette.positive.main, theme.palette.common.white, theme.palette.positive.main, theme.palette.negative.main, theme.palette.common.white, theme.palette.negative.main, theme.typography.fontFamily, theme.typography.button.fontSize, theme.typography.fontWeight.medium, theme.typography.button.lineHeight, theme.breakpoints[mobileBreakpoint], theme.typography.button.mobile.fontSize, theme.spacing(1), theme.spacing(1), theme.typography.button.mobile.fontSize, theme.typography.button.mobile.lineHeight]]])
  }) : IconEnd))), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "3894020684",
    dynamic: [theme.palette.grey[300], theme.shape.borderRadius.md, theme.palette.text.primary, theme.spacing(2), theme.spacing(3), theme.transitions.duration.standard, theme.palette.grey[400], theme.spacing(2), theme.spacing(2), theme.spacing(1), theme.spacing(2), theme.spacing(3), theme.spacing(5), theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.primary.dark, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.secondary.dark, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.tertiary.dark, theme.palette.common.white, theme.palette.common.black, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.positive.dark, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.negative.dark, theme.palette.text.primary, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.grey[600], theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.grey[100], theme.palette.common.white, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.text.primary, theme.shape.borderRadius.md, theme.palette.primary.main, theme.palette.common.white, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.tertiary.main, theme.palette.positive.main, theme.palette.common.white, theme.palette.positive.main, theme.palette.negative.main, theme.palette.common.white, theme.palette.negative.main, theme.typography.fontFamily, theme.typography.button.fontSize, theme.typography.fontWeight.medium, theme.typography.button.lineHeight, theme.breakpoints[mobileBreakpoint], theme.typography.button.mobile.fontSize, theme.spacing(1), theme.spacing(1), theme.typography.button.mobile.fontSize, theme.typography.button.mobile.lineHeight]
  }, ".root.__jsx-style-dynamic-selector{background-color:".concat(theme.palette.grey[300], ";border:0;border-radius:").concat(theme.shape.borderRadius.md, ";color:").concat(theme.palette.text.primary, ";cursor:pointer;display:-webkit-inline-box;display:-webkit-inline-flex;display:-ms-inline-flexbox;display:inline-flex;min-width:130px;padding:").concat(theme.spacing(2), "px ").concat(theme.spacing(3), "px;outline:0;-webkit-transition:all ").concat(theme.transitions.duration.standard, "ms;transition:all ").concat(theme.transitions.duration.standard, "ms;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;}.root.focusVisible.__jsx-style-dynamic-selector{outline:5px auto -webkit-focus-ring-color;}.root.__jsx-style-dynamic-selector:active,.root.__jsx-style-dynamic-selector:focus,.root.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.grey[400], ";}a.root.__jsx-style-dynamic-selector{min-width:100px;-webkit-text-decoration:none;text-decoration:none;}.icon.__jsx-style-dynamic-selector{font-size:15px;}.icon.__jsx-style-dynamic-selector>svg.__jsx-style-dynamic-selector{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;}.icon-start.__jsx-style-dynamic-selector{margin-right:").concat(theme.spacing(2), "px;}.icon-end.__jsx-style-dynamic-selector{margin-left:").concat(theme.spacing(2), "px;}.full-width.__jsx-style-dynamic-selector{display:block;width:100%;}.disabled.__jsx-style-dynamic-selector{opacity:0.5;pointer-events:none;}.small.__jsx-style-dynamic-selector{padding:").concat(theme.spacing(1), "px ").concat(theme.spacing(2), "px;min-width:60px;}.large.__jsx-style-dynamic-selector{padding:").concat(theme.spacing(3), "px ").concat(theme.spacing(5), "px;}.contained-primary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.primary.main, ";color:").concat(theme.palette.primary.contrast, ";}.contained-primary.__jsx-style-dynamic-selector:active,.contained-primary.__jsx-style-dynamic-selector:focus,.contained-primary.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.primary.dark, ";}.contained-secondary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.secondary.main, ";color:").concat(theme.palette.secondary.contrast, ";}.contained-secondary.__jsx-style-dynamic-selector:active,.contained-secondary.__jsx-style-dynamic-selector:focus,.contained-secondary.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.secondary.dark, ";}.contained-tertiary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.tertiary.main, ";color:").concat(theme.palette.tertiary.contrast, ";}.contained-tertiary.__jsx-style-dynamic-selector:active,.contained-tertiary.__jsx-style-dynamic-selector:focus,.contained-tertiary.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.tertiary.dark, ";}.contained-white.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.common.white, ";color:").concat(theme.palette.common.black, ";}.contained-white.__jsx-style-dynamic-selector:active,.contained-white.__jsx-style-dynamic-selector:focus,.contained-white.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.grey[100], ";}.contained-positive.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.positive.main, ";color:").concat(theme.palette.positive.contrast, ";}.contained-positive.__jsx-style-dynamic-selector:active,.contained-positive.__jsx-style-dynamic-selector:focus,.contained-positive.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.positive.dark, ";}.contained-negative.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.negative.main, ";color:").concat(theme.palette.negative.contrast, ";}.contained-negative.__jsx-style-dynamic-selector:active,.contained-negative.__jsx-style-dynamic-selector:focus,.contained-negative.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.negative.dark, ";}.text.__jsx-style-dynamic-selector{background-color:transparent;color:").concat(theme.palette.text.primary, ";overflow:hidden;position:relative;}.text.__jsx-style-dynamic-selector:hover{background-color:transparent;}.text.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.grey[600], ";bottom:0;content:\"\";left:0;opacity:0.1;position:absolute;right:0;top:0;}.text-primary.__jsx-style-dynamic-selector{color:").concat(theme.palette.primary.main, ";}.text-primary.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.primary.main, ";}.text-secondary.__jsx-style-dynamic-selector{color:").concat(theme.palette.secondary.main, ";}.text-secondary.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.secondary.main, ";}.text-tertiary.__jsx-style-dynamic-selector{color:").concat(theme.palette.tertiary.main, ";}.text-tertiary.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.tertiary.main, ";}.text-white.__jsx-style-dynamic-selector{color:").concat(theme.palette.common.white, ";}.text-white.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.grey[100], ";}.text-positive.__jsx-style-dynamic-selector{color:").concat(theme.palette.positive.main, ";}.text-positive.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.positive.main, ";}.text-negative.__jsx-style-dynamic-selector{color:").concat(theme.palette.negative.main, ";}.text-negative.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.negative.main, ";}.outlined.__jsx-style-dynamic-selector{background-color:transparent;color:").concat(theme.palette.text.primary, ";overflow:hidden;position:relative;}.outlined.__jsx-style-dynamic-selector::after{border-radius:").concat(theme.shape.borderRadius.md, ";border:1px solid rgba(0,0,0,0.23);bottom:0;content:\"\";left:0;position:absolute;right:0;top:0;}.outlined.__jsx-style-dynamic-selector:hover{background-color:transparent;}.outlined.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.grey[600], ";bottom:0;content:\"\";left:0;opacity:0.1;position:absolute;right:0;top:0;}.outlined-primary.__jsx-style-dynamic-selector{color:").concat(theme.palette.primary.main, ";}.outlined-primary.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.primary.main, ";}.outlined-primary.__jsx-style-dynamic-selector::after{border-color:").concat(theme.palette.primary.main, ";}.outlined-secondary.__jsx-style-dynamic-selector{color:").concat(theme.palette.secondary.main, ";}.outlined-secondary.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.secondary.main, ";}.outlined-secondary.__jsx-style-dynamic-selector::after{border-color:").concat(theme.palette.secondary.main, ";}.outlined-tertiary.__jsx-style-dynamic-selector{color:").concat(theme.palette.tertiary.main, ";}.outlined-tertiary.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.tertiary.main, ";}.outlined-tertiary.__jsx-style-dynamic-selector::after{border-color:").concat(theme.palette.tertiary.main, ";}.outlined-white.__jsx-style-dynamic-selector{color:").concat(theme.palette.common.white, ";}.outlined-white.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.grey[100], ";}.outlined-white.__jsx-style-dynamic-selector::after{border-color:").concat(theme.palette.common.white, ";}.outlined-positive.__jsx-style-dynamic-selector{color:").concat(theme.palette.positive.main, ";}.outlined-positive.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.positive.main, ";}.outlined-positive.__jsx-style-dynamic-selector::after{border-color:").concat(theme.palette.positive.main, ";}.outlined-negative.__jsx-style-dynamic-selector{color:").concat(theme.palette.negative.main, ";}.outlined-negative.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.negative.main, ";}.outlined-negative.__jsx-style-dynamic-selector::after{border-color:").concat(theme.palette.negative.main, ";}.inverted.__jsx-style-dynamic-selector{background-color:white;color:").concat(theme.palette.text.primary, ";overflow:hidden;position:relative;}.inverted.__jsx-style-dynamic-selector::after{border-radius:").concat(theme.shape.borderRadius.md, ";border:1px solid transparent;bottom:0;content:\"\";left:0;position:absolute;right:0;top:0;}.inverted.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{bottom:0;content:\"\";left:0;opacity:1;position:absolute;right:0;top:0;}.inverted-primary.__jsx-style-dynamic-selector{color:").concat(theme.palette.primary.main, ";}.inverted-primary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.common.white, ";background-color:").concat(theme.palette.primary.main, ";}.inverted-secondary.__jsx-style-dynamic-selector{color:").concat(theme.palette.secondary.main, ";}.inverted-secondary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.common.white, ";background-color:").concat(theme.palette.secondary.main, ";}.inverted-tertiary.__jsx-style-dynamic-selector{color:").concat(theme.palette.tertiary.main, ";}.inverted-tertiary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.common.white, ";background-color:").concat(theme.palette.tertiary.main, ";}.inverted-positive.__jsx-style-dynamic-selector{color:").concat(theme.palette.positive.main, ";}.inverted-positive.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.common.white, ";background-color:").concat(theme.palette.positive.main, ";}.inverted-negative.__jsx-style-dynamic-selector{color:").concat(theme.palette.negative.main, ";}.inverted-negative.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.common.white, ";background-color:").concat(theme.palette.negative.main, ";}.label.__jsx-style-dynamic-selector{-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;font-family:").concat(theme.typography.fontFamily, ";font-size:").concat(theme.typography.button.fontSize, ";font-weight:").concat(theme.typography.fontWeight.medium, ";-webkit-box-pack:center;-webkit-justify-content:center;-ms-flex-pack:center;justify-content:center;-webkit-letter-spacing:1px;-moz-letter-spacing:1px;-ms-letter-spacing:1px;letter-spacing:1px;line-height:").concat(theme.typography.button.lineHeight, ";text-align:center;text-transform:uppercase;width:100%;word-break:normal;}@media (max-width:").concat(theme.breakpoints[mobileBreakpoint], "px){.icon.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.button.mobile.fontSize, ";}.icon-end.__jsx-style-dynamic-selector{margin-left:").concat(theme.spacing(1), "px;}.icon-start.__jsx-style-dynamic-selector{margin-right:").concat(theme.spacing(1), "px;}.label.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.button.mobile.fontSize, ";line-height:").concat(theme.typography.button.mobile.lineHeight, ";}}")));
};

Button.propTypes = {
  /**
   * The content of the button.
   */
  children: _propTypes["default"].node,

  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].array,

  /**
   * The color to use.
   */
  color: _propTypes["default"].oneOf(["default", "negative", "positive", "primary", "secondary", "tertiary", "white"]),

  /**
   * The component used for the root node.
   * Either a string to use a DOM element or a component.
   */
  component: _propTypes["default"].elementType,

  /**
   * If `true`, the button will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If `true`, the button will take up the full width of its container.
   */
  fullWidth: _propTypes["default"].bool,

  /**
   * The URL to link to when the button is clicked.
   * If defined, an `a` element will be used as the root node.
   */
  href: _propTypes["default"].string,

  /**
   * Element placed after the children.
   */
  iconEnd: _propTypes["default"].oneOfType([_propTypes["default"].elementType, _propTypes["default"].node]),

  /**
   * Element placed before the children.
   */
  iconStart: _propTypes["default"].oneOfType([_propTypes["default"].elementType, _propTypes["default"].node]),

  /**
   * The breakpoint to display the mobile button styling.
   */
  mobileBreakpoint: _propTypes["default"].oneOf(["xs", "sm", "md", "lg", "xl"]),

  /**
   * The size of the chip.
   */
  size: _propTypes["default"].oneOf(["small", "medium", "large"]),

  /**
   * @ignore
   * The theme context object
   */
  theme: _propTypes["default"].object,

  /**
   * The type of button, determining functionality.
   */
  type: _propTypes["default"].oneOf(["button", "reset", "submit"]),

  /**
   * The variant to use.
   */
  variant: _propTypes["default"].oneOf(["text", "outlined", "contained", "inverted"])
};
Button.defaultProps = {
  classes: [],
  color: "default",
  disabled: false,
  fullWidth: false,
  mobileBreakpoint: "sm",
  size: "medium",
  type: "button",
  variant: "text"
};
Button.displayName = "Button";

var _default = (0, _utils.withThemeContext)(Button);

exports["default"] = _default;