"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ButtonBase = function ButtonBase(_ref) {
  var ariaLabel = _ref.ariaLabel,
      children = _ref.children,
      classes = _ref.classes,
      type = _ref.type,
      variant = _ref.variant,
      other = _objectWithoutProperties(_ref, ["ariaLabel", "children", "classes", "type", "variant"]);

  var className = (0, _clsx["default"])("button", variant, classes);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("button", _extends({
    "aria-label": ariaLabel,
    type: type
  }, other, {
    className: "jsx-509404678" + " " + (other && other.className != null && other.className || className || "")
  }), children), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "509404678"
  }, ".button.jsx-509404678{cursor:pointer;}.button.jsx-509404678:focus{outline:5px auto -webkit-focus-ring-color;}.default.jsx-509404678{background-color:transparent;border:none;-webkit-text-decoration:none;text-decoration:none;}"));
};

ButtonBase.propTypes = {
  // external

  /**
   * The aria-label to provide to the button
   */
  ariaLabel: _propTypes["default"].string.isRequired,

  /**
   * The children to render within the button
   */
  children: _propTypes["default"].node.isRequired,

  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].oneOfType([_propTypes["default"].array, _propTypes["default"].string]),

  /**
   * The variant for the button. Default clears normal html button styles.
   */
  variant: _propTypes["default"].oneOf(["default"]),

  /**
   * Whether traditional button styles (border, background) should be cleared
   */
  type: _propTypes["default"].oneOf(["button", "submit", "reset"])
};
ButtonBase.defaultProps = {
  classes: [],
  variant: "default",
  type: "button"
};
ButtonBase.displayName = "ButtonBase";
var _default = ButtonBase;
exports["default"] = _default;