"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _utils = require("../utils");

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ButtonIcon = function ButtonIcon(props) {
  var children = props.children,
      classes = props.classes,
      color = props.color,
      component = props.component,
      disabled = props.disabled,
      size = props.size,
      theme = props.theme,
      variant = props.variant,
      other = _objectWithoutProperties(props, ["children", "classes", "color", "component", "disabled", "size", "theme", "variant"]);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      focusVisible = _useState2[0],
      setFocusVisible = _useState2[1];

  var _useIsFocusVisible = (0, _utils.useIsFocusVisible)(),
      ref = _useIsFocusVisible.ref,
      isFocusVisible = _useIsFocusVisible.isFocusVisible,
      onBlurVisible = _useIsFocusVisible.onBlurVisible;

  var handleFocus = function handleFocus(e) {
    setFocusVisible(isFocusVisible(e));
  };

  var handleBlur = function handleBlur() {
    setFocusVisible(false);
    onBlurVisible();
  };

  var className = (0, _clsx["default"])("root", disabled ? "disabled" : null, focusVisible ? "focusVisible" : null, size, variant, "".concat(variant, "-").concat(color), classes);
  var Component = other.href ? "a" : "button";
  if (component) Component = component;
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(Component, _extends({
    ref: ref,
    onFocus: handleFocus,
    onBlur: handleBlur,
    disabled: disabled
  }, other, {
    className: _style["default"].dynamic([["879142339", [theme.spacing(2), theme.transitions.duration.standard, theme.palette.text.secondary, theme.palette.text.secondary, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.common.white, theme.palette.text.secondary, theme.palette.text.secondary, theme.palette.text.secondary, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.common.white, theme.palette.common.white]]]) + " " + (other && other.className != null && other.className || className || "")
  }), /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["879142339", [theme.spacing(2), theme.transitions.duration.standard, theme.palette.text.secondary, theme.palette.text.secondary, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.common.white, theme.palette.text.secondary, theme.palette.text.secondary, theme.palette.text.secondary, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.common.white, theme.palette.common.white]]]) + " " + ((0, _clsx["default"])("label", "icon-".concat(size), "font-".concat(size)) || "")
  }, children)), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "879142339",
    dynamic: [theme.spacing(2), theme.transitions.duration.standard, theme.palette.text.secondary, theme.palette.text.secondary, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.common.white, theme.palette.text.secondary, theme.palette.text.secondary, theme.palette.text.secondary, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.common.white, theme.palette.common.white]
  }, ".root.__jsx-style-dynamic-selector{background-color:transparent;border:0;cursor:pointer;display:-webkit-inline-box;display:-webkit-inline-flex;display:-ms-inline-flexbox;display:inline-flex;padding:".concat(theme.spacing(2), "px;position:relative;outline:0;-webkit-transition:all ").concat(theme.transitions.duration.standard, "ms;transition:all ").concat(theme.transitions.duration.standard, "ms;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;}a.root.__jsx-style-dynamic-selector{border:none;-webkit-text-decoration:none;text-decoration:none;}.icon.__jsx-style-dynamic-selector:active.__jsx-style-dynamic-selector::before,.icon.focusVisible.__jsx-style-dynamic-selector::before,.icon.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{border-radius:50%;bottom:0;content:\"\";left:0;opacity:0.1;position:absolute;right:0;top:0;}.icon-default.__jsx-style-dynamic-selector,.icon-default.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.text.secondary, ";}.icon-default.__jsx-style-dynamic-selector:active.__jsx-style-dynamic-selector::before,.icon-default.focusVisible.__jsx-style-dynamic-selector::before,.icon-default.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.text.secondary, ";}.icon-primary.__jsx-style-dynamic-selector,.icon-primary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.primary.main, ";}.icon-primary.__jsx-style-dynamic-selector:active.__jsx-style-dynamic-selector::before,.icon-primary.focusVisible.__jsx-style-dynamic-selector::before,.icon-primary.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.primary.main, ";}.icon-secondary.__jsx-style-dynamic-selector,.icon-secondary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.secondary.main, ";}.icon-secondary.__jsx-style-dynamic-selector:active.__jsx-style-dynamic-selector::before,.icon-secondary.focusVisible.__jsx-style-dynamic-selector::before,.icon-secondary.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.secondary.main, ";}.icon-tertiary.__jsx-style-dynamic-selector,.icon-tertiary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.tertiary.main, ";}.icon-tertiary.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{.icon-tertiary:active::before, .icon-tertiary.focusVisible::before, background-color:").concat(theme.palette.tertiary.main, ";}.icon-white.__jsx-style-dynamic-selector,.icon-white.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.common.white, ";}.icon-white.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{.icon-white:active::before,.icon-white.focusVisible::before, background-color:").concat(theme.palette.common.white, ";}.outlined.__jsx-style-dynamic-selector{background-color:transparent;overflow:hidden;position:relative;}.outlined.__jsx-style-dynamic-selector::after{border:1px solid rgba(0,0,0,0.23);border-radius:50%;bottom:0;content:\"\";left:0;position:absolute;right:0;top:0;}.outlined.__jsx-style-dynamic-selector:active.__jsx-style-dynamic-selector::before,.outlined.focusVisible.__jsx-style-dynamic-selector::before,.outlined.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{border-radius:50%;bottom:0;content:\"\";left:0;opacity:0.1;position:absolute;right:0;top:0;}.outlined-default.__jsx-style-dynamic-selector::after{border-color:").concat(theme.palette.text.secondary, ";}.outlined-default.__jsx-style-dynamic-selector,.outlined-default.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.text.secondary, ";}.outlined-default.__jsx-style-dynamic-selector:active.__jsx-style-dynamic-selector::before,.outlined-default.focusVisible.__jsx-style-dynamic-selector::before,.outlined-default.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.text.secondary, ";}.outlined-primary.__jsx-style-dynamic-selector::after{border-color:").concat(theme.palette.primary.main, ";}.outlined-primary.__jsx-style-dynamic-selector,.outlined-primary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.primary.main, ";}.outlined-primary.__jsx-style-dynamic-selector:active.__jsx-style-dynamic-selector::before,.outlined-primary.focusVisible.__jsx-style-dynamic-selector::before,.outlined-primary.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.primary.main, ";}.outlined-secondary.__jsx-style-dynamic-selector::after{border-color:").concat(theme.palette.secondary.main, ";}.outlined-secondary.__jsx-style-dynamic-selector,.outlined-secondary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.secondary.main, ";}.outlined-secondary.__jsx-style-dynamic-selector:active.__jsx-style-dynamic-selector::before,.outlined-secondary.focusVisible.__jsx-style-dynamic-selector::before,.outlined-secondary.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{background-color:").concat(theme.palette.secondary.main, ";}.outlined-tertiary.__jsx-style-dynamic-selector::after{border-color:").concat(theme.palette.tertiary.main, ";}.outlined-tertiary.__jsx-style-dynamic-selector,.outlined-tertiary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.tertiary.main, ";}.outlined-tertiary.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{.outlined-tertiary:active::before, .outlined-tertiary.focusVisible::before, background-color:").concat(theme.palette.tertiary.main, ";}.outlined-white.__jsx-style-dynamic-selector::after{border-color:").concat(theme.palette.common.white, ";}.outlined-white.__jsx-style-dynamic-selector,.outlined-white.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.common.white, ";}.outlined-white.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector::before{.outlined-white:active::before, .outlined-white.focusVisible::before, background-color:").concat(theme.palette.common.white, ";}.disabled.__jsx-style-dynamic-selector{opacity:0.5;pointer-events:none;}.label.__jsx-style-dynamic-selector{-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;font-size:18px;-webkit-box-pack:center;-webkit-justify-content:center;-ms-flex-pack:center;justify-content:center;text-align:center;width:100%;}.icon-small.__jsx-style-dynamic-selector{height:16px;width:16px;}.icon-medium.__jsx-style-dynamic-selector{height:18px;width:18px;}.icon-large.__jsx-style-dynamic-selector{height:20px;width:20px;}.font-small.__jsx-style-dynamic-selector{font-size:16px;}.font-large.__jsx-style-dynamic-selector{font-size:20px;}")));
};

ButtonIcon.propTypes = {
  /**
   * The icon element.
   */
  children: _propTypes["default"].node.isRequired,

  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].array,

  /**
   * The color to use.
   */
  color: _propTypes["default"].oneOf(["default", "primary", "secondary", "tertiary", "white"]),

  /**
   * The component used for the root node.
   * Either a string to use a DOM element or a component.
   */
  component: _propTypes["default"].elementType,

  /**
   * If `true`, the button will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * The size of the chip.
   */
  size: _propTypes["default"].oneOf(["small", "medium", "large"]),

  /**
   * @ignore
   * The theme context object
   */
  theme: _propTypes["default"].object,

  /**
   * The variant to use.
   */
  variant: _propTypes["default"].oneOf(["icon", "outlined"])
};
ButtonIcon.defaultProps = {
  classes: [],
  color: "default",
  disabled: false,
  size: "medium",
  variant: "icon"
};
ButtonIcon.displayName = "ButtonIcon";

var _default = (0, _utils.withThemeContext)((0, _withClasses["default"])(ButtonIcon));

exports["default"] = _default;