"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _utils = require("../utils");

var _Typography = _interopRequireDefault(require("./Typography"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Checkbox = function Checkbox(props) {
  var checked = props.checked,
      classes = props.classes,
      color = props.color,
      disabled = props.disabled,
      error = props.error,
      label = props.label,
      required = props.required,
      theme = props.theme,
      warning = props.warning,
      other = _objectWithoutProperties(props, ["checked", "classes", "color", "disabled", "error", "label", "required", "theme", "warning"]);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      focusVisible = _useState2[0],
      setFocusVisible = _useState2[1];

  var _useIsFocusVisible = (0, _utils.useIsFocusVisible)(),
      ref = _useIsFocusVisible.ref,
      isFocusVisible = _useIsFocusVisible.isFocusVisible,
      onBlurVisible = _useIsFocusVisible.onBlurVisible;

  var handleFocus = function handleFocus(e) {
    setFocusVisible(isFocusVisible(e));
  };

  var handleBlur = function handleBlur() {
    setFocusVisible(false);
    onBlurVisible();
  };

  var handleKeyDown = function handleKeyDown(e) {
    if (e.key === "Enter") {
      e.target.checked = !checked;
      if (other.onChange) other.onChange(e);
    }
  };

  var className = (0, _clsx["default"])("checkbox", focusVisible ? "focusVisible" : null);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _style["default"].dynamic([["1863449125", [theme.palette.common.white, theme.shape.borderRadius.md, theme.palette.grey[400], theme.palette.grey[400], theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.grey[300], theme.palette.grey[300], theme.spacing(2)]]]) + " " + ((0, _clsx["default"])(classes) || "")
  }, /*#__PURE__*/_react["default"].createElement("label", {
    htmlFor: other.id,
    className: _style["default"].dynamic([["1863449125", [theme.palette.common.white, theme.shape.borderRadius.md, theme.palette.grey[400], theme.palette.grey[400], theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.grey[300], theme.palette.grey[300], theme.spacing(2)]]])
  }, /*#__PURE__*/_react["default"].createElement(_Typography["default"], null, label, required && " *"), /*#__PURE__*/_react["default"].createElement("input", _extends({
    ref: ref,
    checked: checked,
    disabled: disabled,
    type: "checkbox",
    onFocus: handleFocus,
    onBlur: handleBlur,
    onKeyDown: handleKeyDown
  }, other, {
    className: _style["default"].dynamic([["1863449125", [theme.palette.common.white, theme.shape.borderRadius.md, theme.palette.grey[400], theme.palette.grey[400], theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.grey[300], theme.palette.grey[300], theme.spacing(2)]]]) + " " + (other && other.className != null && other.className || className || "")
  })), /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["1863449125", [theme.palette.common.white, theme.shape.borderRadius.md, theme.palette.grey[400], theme.palette.grey[400], theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.grey[300], theme.palette.grey[300], theme.spacing(2)]]]) + " " + ((0, _clsx["default"])("checkmark", disabled ? "disabled" : null, color) || "")
  })), error && /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    classes: [(0, _clsx["default"])("error")],
    color: "negative",
    variant: "body2"
  }, error), warning && /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    classes: [(0, _clsx["default"])("error")],
    color: "secondary",
    variant: "body2"
  }, warning), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "1863449125",
    dynamic: [theme.palette.common.white, theme.shape.borderRadius.md, theme.palette.grey[400], theme.palette.grey[400], theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.grey[300], theme.palette.grey[300], theme.spacing(2)]
  }, "div.__jsx-style-dynamic-selector{min-height:20px;}label.__jsx-style-dynamic-selector{cursor:pointer;display:block;padding-left:35px;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;}label.__jsx-style-dynamic-selector input.__jsx-style-dynamic-selector{cursor:pointer;height:100%;left:0;opacity:0;position:absolute;top:0;width:100%;}.checkmark.__jsx-style-dynamic-selector{background-color:".concat(theme.palette.common.white, ";border:1px solid rgba(0,0,0,0.23);border-radius:").concat(theme.shape.borderRadius.md, ";height:20px;left:0;position:absolute;top:0;width:20px;}label.__jsx-style-dynamic-selector input.focusVisible.__jsx-style-dynamic-selector~.checkmark.__jsx-style-dynamic-selector{outline:auto 5px;}label.__jsx-style-dynamic-selector input.__jsx-style-dynamic-selector:checked~.checkmark.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.grey[400], ";border-color:").concat(theme.palette.grey[400], ";}label.__jsx-style-dynamic-selector input.__jsx-style-dynamic-selector:checked~.primary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.primary.main, ";border-color:").concat(theme.palette.primary.main, ";}label.__jsx-style-dynamic-selector input.__jsx-style-dynamic-selector:checked~.secondary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.secondary.main, ";border-color:").concat(theme.palette.secondary.main, ";}.checkmark.__jsx-style-dynamic-selector:after{content:\"\";display:none;position:absolute;}label.__jsx-style-dynamic-selector input.__jsx-style-dynamic-selector:checked~.checkmark.__jsx-style-dynamic-selector:after{display:block;}label.__jsx-style-dynamic-selector .checkmark.__jsx-style-dynamic-selector:after{border:solid white;border-width:0 2px 2px 0;height:11px;left:7px;top:2px;-webkit-transform:rotate(45deg);-ms-transform:rotate(45deg);transform:rotate(45deg);width:5px;}label.__jsx-style-dynamic-selector input.__jsx-style-dynamic-selector:checked~.disabled.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.grey[300], ";border-color:").concat(theme.palette.grey[300], ";pointer-events:none;}label.__jsx-style-dynamic-selector+.error{margin-left:35px !important;margin-top:").concat(theme.spacing(2), "px;}")));
};

Checkbox.propTypes = {
  /**
   * If `true`, the component is checked.
   */
  checked: _propTypes["default"].bool,

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * The color of the component. It supports those theme colors that make sense for this component.
   */
  color: _propTypes["default"].oneOf(["primary", "secondary", "default"]),

  /**
   * If `true`, the checkbox will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * An error to display below the checkbox.
   */
  error: _propTypes["default"].node,

  /**
   * Label text to display for the checkbox.
   */
  label: _propTypes["default"].node,

  /**
   * If true, an asterisk will be appended to the end of the label.
   */
  required: _propTypes["default"].bool,

  /**
   * @ignore
   * The theme context object
   */
  theme: _propTypes["default"].object,

  /**
   * A warning to display below the checkbox.
   */
  warning: _propTypes["default"].node
};
Checkbox.defaultProps = {
  checked: false,
  disabled: false,
  required: false
};
Checkbox.displayName = "Checkbox";

var _default = (0, _utils.withThemeContext)(Checkbox);

exports["default"] = _default;