"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _useIsFocusVisible2 = _interopRequireDefault(require("../utils/useIsFocusVisible"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _withThemeContext = _interopRequireDefault(require("../utils/withThemeContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Chip = function Chip(_ref) {
  var children = _ref.children,
      classes = _ref.classes,
      color = _ref.color,
      Component = _ref.component,
      disabled = _ref.disabled,
      hover = _ref.hover,
      icon = _ref.icon,
      label = _ref.label,
      onClick = _ref.onClick,
      size = _ref.size,
      theme = _ref.theme,
      variant = _ref.variant,
      other = _objectWithoutProperties(_ref, ["children", "classes", "color", "component", "disabled", "hover", "icon", "label", "onClick", "size", "theme", "variant"]);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      focusVisible = _useState2[0],
      setFocusVisible = _useState2[1];

  var _useIsFocusVisible = (0, _useIsFocusVisible2["default"])(),
      ref = _useIsFocusVisible.ref,
      isFocusVisible = _useIsFocusVisible.isFocusVisible,
      onBlurVisible = _useIsFocusVisible.onBlurVisible;

  var clickable = !!onClick;
  var className = (0, _clsx["default"])("root", color, disabled ? "disabled" : null, size, variant, classes, {
    clickable: clickable
  }, {
    focusVisible: focusVisible
  }, hover ? "hover" : null);

  var handleBlur = function handleBlur() {
    setFocusVisible(false);
    onBlurVisible();
  };

  var handleFocus = function handleFocus(e) {
    setFocusVisible(isFocusVisible(e));
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(Component, _extends({
    onBlur: handleBlur,
    onClick: onClick,
    onFocus: handleFocus,
    ref: ref,
    tabIndex: clickable ? "0" : undefined
  }, other, {
    className: _style["default"].dynamic([["3610061240", [theme.palette.grey[300], theme.palette.text.secondary, theme.typography.fontFamily, theme.typography.body1.fontSize, theme.spacing(1), theme.spacing(1), theme.spacing(2), theme.spacing(2), theme.spacing(3), theme.palette.text.primary, theme.spacing(2), theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.contrast, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.contrast, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.grey[600], theme.palette.grey[600], theme.palette.common.white, theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.common.white, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.common.white, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.common.white, theme.palette.grey[300], theme.palette.text.hint, theme.palette.grey[300], theme.palette.grey[300], theme.palette.text.secondary]]]) + " " + (other && other.className != null && other.className || className || "")
  }), icon && /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["3610061240", [theme.palette.grey[300], theme.palette.text.secondary, theme.typography.fontFamily, theme.typography.body1.fontSize, theme.spacing(1), theme.spacing(1), theme.spacing(2), theme.spacing(2), theme.spacing(3), theme.palette.text.primary, theme.spacing(2), theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.contrast, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.contrast, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.grey[600], theme.palette.grey[600], theme.palette.common.white, theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.common.white, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.common.white, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.common.white, theme.palette.grey[300], theme.palette.text.hint, theme.palette.grey[300], theme.palette.grey[300], theme.palette.text.secondary]]]) + " " + "icon"
  }, icon), /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["3610061240", [theme.palette.grey[300], theme.palette.text.secondary, theme.typography.fontFamily, theme.typography.body1.fontSize, theme.spacing(1), theme.spacing(1), theme.spacing(2), theme.spacing(2), theme.spacing(3), theme.palette.text.primary, theme.spacing(2), theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.contrast, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.contrast, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.grey[600], theme.palette.grey[600], theme.palette.common.white, theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.common.white, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.common.white, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.common.white, theme.palette.grey[300], theme.palette.text.hint, theme.palette.grey[300], theme.palette.grey[300], theme.palette.text.secondary]]]) + " " + ((0, _clsx["default"])("label") || "")
  }, label || children)), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "3610061240",
    dynamic: [theme.palette.grey[300], theme.palette.text.secondary, theme.typography.fontFamily, theme.typography.body1.fontSize, theme.spacing(1), theme.spacing(1), theme.spacing(2), theme.spacing(2), theme.spacing(3), theme.palette.text.primary, theme.spacing(2), theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.contrast, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.contrast, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.tertiary.contrast, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.contrast, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.contrast, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.contrast, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.contrast, theme.palette.grey[600], theme.palette.grey[600], theme.palette.common.white, theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.common.white, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.common.white, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.grey.A400, theme.palette.common.white, theme.palette.grey[300], theme.palette.text.hint, theme.palette.grey[300], theme.palette.grey[300], theme.palette.text.secondary]
  }, ".root.__jsx-style-dynamic-selector{background-color:".concat(theme.palette.grey[300], ";border-radius:50px;border:1px solid;border-color:transparent;box-sizing:border-box;color:").concat(theme.palette.text.secondary, ";cursor:default;display:-webkit-inline-box;display:-webkit-inline-flex;display:-ms-inline-flexbox;display:inline-flex;font-family:").concat(theme.typography.fontFamily, ";font-size:").concat(theme.typography.body1.fontSize, ";-webkit-box-pack:center;-webkit-justify-content:center;-ms-flex-pack:center;justify-content:center;outline:0;vertical-align:middle;white-space:nowrap;}.root.xsmall.__jsx-style-dynamic-selector{padding:1px ").concat(theme.spacing(1), "px;}.root.small.__jsx-style-dynamic-selector{padding:").concat(theme.spacing(1), "px ").concat(theme.spacing(2), "px;}.root.medium.__jsx-style-dynamic-selector{padding:").concat(theme.spacing(2), "px ").concat(theme.spacing(3), "px;}.root.disabled.__jsx-style-dynamic-selector{opacity:0.6;pointer-events:none;}.root.clickable.__jsx-style-dynamic-selector{cursor:pointer;}.root.clickable.__jsx-style-dynamic-selector:hover,.root.focusVisible.__jsx-style-dynamic-selector,.root.hover.__jsx-style-dynamic-selector:hover{background-color:transparent;border:1px solid ").concat(theme.palette.text.primary, ";}.icon.__jsx-style-dynamic-selector{-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;padding-right:").concat(theme.spacing(2), "px;white-space:nowrap;}.label.__jsx-style-dynamic-selector{-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;white-space:nowrap;}.primary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.primary.main, ";border-color:").concat(theme.palette.primary.main, ";color:").concat(theme.palette.primary.contrast, ";}.primary.clickable.__jsx-style-dynamic-selector:hover,.primary.focusVisible.__jsx-style-dynamic-selector,.primary.hover.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.primary.main, ";color:").concat(theme.palette.primary.main, ";}.primary.outlined.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.primary.main, ";color:").concat(theme.palette.primary.main, ";}.primary.outlined.clickable.__jsx-style-dynamic-selector:hover,.primary.outlined.focusVisible.__jsx-style-dynamic-selector,.primary.outlined.hover.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.primary.main, ";border-color:").concat(theme.palette.primary.main, ";color:").concat(theme.palette.primary.contrast, ";}.secondary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.secondary.main, ";border-color:").concat(theme.palette.secondary.main, ";color:").concat(theme.palette.secondary.contrast, ";}.secondary.clickable.__jsx-style-dynamic-selector:hover,.secondary.focusVisible.__jsx-style-dynamic-selector,.secondary.hover.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.secondary.main, ";color:").concat(theme.palette.secondary.main, ";}.secondary.outlined.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.secondary.main, ";color:").concat(theme.palette.secondary.main, ";}.secondary.outlined.clickable.__jsx-style-dynamic-selector:hover,.secondary.outlined.focusVisible.__jsx-style-dynamic-selector,.secondary.outlined.hover.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.secondary.main, ";border-color:").concat(theme.palette.secondary.main, ";color:").concat(theme.palette.secondary.contrast, ";}.tertiary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.tertiary.main, ";border-color:").concat(theme.palette.tertiary.main, ";color:").concat(theme.palette.tertiary.contrast, ";}.tertiary.clickable.__jsx-style-dynamic-selector:hover,.tertiary.focusVisible.__jsx-style-dynamic-selector,.tertiary.hover.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.tertiary.main, ";color:").concat(theme.palette.tertiary.main, ";}.tertiary.outlined.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.tertiary.main, ";color:").concat(theme.palette.tertiary.main, ";}.tertiary.outlined.clickable.__jsx-style-dynamic-selector:hover,.tertiary.outlined.focusVisible.__jsx-style-dynamic-selector,.tertiary.outlined.hover.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.tertiary.main, ";border-color:").concat(theme.palette.tertiary.main, ";color:").concat(theme.palette.tertiary.contrast, ";}.negative.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.negative.main, ";border-color:").concat(theme.palette.negative.main, ";color:").concat(theme.palette.negative.contrast, ";}.negative.clickable.__jsx-style-dynamic-selector:hover,.negative.focusVisible.__jsx-style-dynamic-selector,.negative.hover.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.negative.main, ";color:").concat(theme.palette.negative.main, ";}.negative.outlined.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.negative.main, ";color:").concat(theme.palette.negative.main, ";}.negative.outlined.clickable.__jsx-style-dynamic-selector:hover,.negative.outlined.focusVisible.__jsx-style-dynamic-selector,.negative.outlined.hover.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.negative.main, ";border-color:").concat(theme.palette.negative.main, ";color:").concat(theme.palette.negative.contrast, ";}.warning.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.warning.main, ";border-color:").concat(theme.palette.warning.main, ";color:").concat(theme.palette.warning.contrast, ";}.warning.clickable.__jsx-style-dynamic-selector:hover,.warning.focusVisible.__jsx-style-dynamic-selector,.warning.hover.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.warning.main, ";color:").concat(theme.palette.warning.main, ";}.warning.outlined.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.warning.main, ";color:").concat(theme.palette.warning.main, ";}.warning.outlined.clickable.__jsx-style-dynamic-selector:hover,.warning.outlined.focusVisible.__jsx-style-dynamic-selector,.warning.outlined.hover.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.warning.main, ";border-color:").concat(theme.palette.warning.main, ";color:").concat(theme.palette.warning.contrast, ";}.positive.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.positive.main, ";border-color:").concat(theme.palette.positive.main, ";color:").concat(theme.palette.positive.contrast, ";}.positive.clickable.__jsx-style-dynamic-selector:hover,.positive.focusVisible.__jsx-style-dynamic-selector,.positive.hover.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.positive.main, ";color:").concat(theme.palette.positive.main, ";}.positive.outlined.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.positive.main, ";color:").concat(theme.palette.positive.main, ";}.positive.outlined.clickable.__jsx-style-dynamic-selector:hover,.positive.outlined.focusVisible.__jsx-style-dynamic-selector,.positive.outlined.hover.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.positive.main, ";border-color:").concat(theme.palette.positive.main, ";color:").concat(theme.palette.positive.contrast, ";}.grey600.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.grey[600], ";border-color:").concat(theme.palette.grey[600], ";color:").concat(theme.palette.common.white, ";}.grey600.clickable.__jsx-style-dynamic-selector:hover,.grey600.focusVisible.__jsx-style-dynamic-selector,.grey600.hover.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.grey[600], ";color:").concat(theme.palette.grey[600], ";}.grey600.outlined.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.grey[600], ";color:").concat(theme.palette.grey[600], ";}.grey600.outlined.clickable.__jsx-style-dynamic-selector:hover,.grey600.outlined.focusVisible.__jsx-style-dynamic-selector,.grey600.outlined.hover.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.grey[600], ";border-color:").concat(theme.palette.grey[600], ";color:").concat(theme.palette.common.white, ";}.greyA400.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.grey.A400, ";border-color:").concat(theme.palette.grey.A400, ";color:").concat(theme.palette.common.white, ";}.greyA400.clickable.__jsx-style-dynamic-selector:hover,.greyA400.focusVisible.__jsx-style-dynamic-selector,.greyA400.hover.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.grey.A400, ";color:").concat(theme.palette.grey.A400, ";}.greyA400.outlined.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.grey.A400, ";color:").concat(theme.palette.grey.A400, ";}.greyA400.outlined.clickable.__jsx-style-dynamic-selector:hover,.greyA400.outlined.focusVisible.__jsx-style-dynamic-selector,.greyA400.outlined.hover.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.grey.A400, ";border-color:").concat(theme.palette.grey.A400, ";color:").concat(theme.palette.common.white, ";}.outlined.__jsx-style-dynamic-selector{background-color:transparent;border:1px solid ").concat(theme.palette.grey[300], ";color:").concat(theme.palette.text.hint, ";}.outlined.default.clickable.__jsx-style-dynamic-selector:hover,.outlined.default.focusVisible.__jsx-style-dynamic-selector,.outlined.default.hover.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.grey[300], ";border-color:").concat(theme.palette.grey[300], ";color:").concat(theme.palette.text.secondary, ";}")));
};

Chip.displayName = "Chip";
Chip.propTypes = {
  /**
   * The elements to render inside the pill.
   */
  children: _propTypes["default"].node,

  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].array,

  /**
   * The color to use.
   */
  color: _propTypes["default"].oneOf(["default", "grey600", "greyA400", "primary", "secondary", "tertiary", "positive", "warning", "negative"]),

  /**
   * The component used for the root node.
   * Either a string to use a DOM element or a component.
   */
  component: _propTypes["default"].elementType,

  /**
   * If `true`, the chip should be displayed in a disabled state.
   */
  disabled: _propTypes["default"].bool,

  /**
   * Whether the chip should invert its variant on hover.
   */
  hover: _propTypes["default"].bool,

  /**
   * Icon to display at start of chip.
   */
  icon: _propTypes["default"].node,

  /**
   * The content of the label.
   */
  label: _propTypes["default"].node,

  /**
   * Action to perform when clicked.
   */
  onClick: _propTypes["default"].func,

  /**
   * The size of the chip.
   */
  size: _propTypes["default"].oneOf(["medium", "small", "xsmall"]),

  /**
   * @ignore
   * The theme context object
   */
  theme: _propTypes["default"].object,

  /**
   * The variant to use.
   */
  variant: _propTypes["default"].oneOf(["default", "outlined"])
};
Chip.defaultProps = {
  classes: [],
  color: "default",
  component: "div",
  disabled: false,
  hover: false,
  size: "medium",
  variant: "default"
};

var _default = (0, _withThemeContext["default"])((0, _withClasses["default"])(Chip));

exports["default"] = _default;