"use strict";

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _react = _interopRequireDefault(require("react"));

var _ClickAway = _interopRequireDefault(require("./ClickAway"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<ClickAway>", function () {
  it("renders without errors", function () {
    var error;
    var onClickAway = jest.fn();

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_ClickAway["default"], {
        onClickAway: onClickAway
      }));
    } catch (e) {
      error = e;
    }

    expect(error).toEqual(undefined);
  });
  it("renders correct snapshot", function () {
    var onClickAway = jest.fn();
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_ClickAway["default"], {
      onClickAway: onClickAway
    }));
    expect((0, _enzymeToJson["default"])(wrapper)).toMatchSnapshot();
  });
  describe("children prop", function () {
    it("renders given non null children nodes", function () {
      var child = /*#__PURE__*/_react["default"].createElement("span", null, "cheesecakes");

      var onClickAway = jest.fn();
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_ClickAway["default"], {
        onClickAway: onClickAway
      }, null, child));
      var childrenNodes = wrapper.find("ClickAway").childAt(0).children();
      expect(childrenNodes.at(0).containsMatchingElement(child)).toEqual(true);
    });
    it("sets onClick prop of children node", function () {
      var child = /*#__PURE__*/_react["default"].createElement("span", null, "cheesecakes");

      var onClickAway = jest.fn();
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_ClickAway["default"], {
        onClickAway: onClickAway
      }, child));
      expect(wrapper.find("ClickAway").find("span").props().onClick).toBeDefined();
    });
  });
  describe("onClickAway prop", function () {
    it("invokes onClickAway when div node is clicked", function () {
      var child = /*#__PURE__*/_react["default"].createElement("span", null, "cheesecakes");

      var onClickAway = jest.fn();
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_ClickAway["default"], {
        onClickAway: onClickAway
      }, child));
      wrapper.find("ClickAway").find("div").invoke("onClick")();
      expect(onClickAway).toHaveBeenCalledTimes(1);
    });
    it("does not invoke onClickAway when children node is clicked", function () {
      var child = /*#__PURE__*/_react["default"].createElement("span", null, "cheesecakes");

      var onClickAway = jest.fn();
      var event = {
        preventDefault: jest.fn(),
        stopPropagation: jest.fn()
      };
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_ClickAway["default"], {
        onClickAway: onClickAway
      }, child));
      wrapper.find("ClickAway").find("span").invoke("onClick")(event);
      expect(onClickAway).not.toHaveBeenCalled();
      expect(event.stopPropagation).toHaveBeenCalledTimes(1);
    });
  });
});