"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _reactTransitionGroup = require("react-transition-group");

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Collapse = function Collapse(props) {
  var children = props.children,
      classes = props.classes,
      Component = props.component,
      inProp = props["in"],
      other = _objectWithoutProperties(props, ["children", "classes", "component", "in"]);

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  var wrapperRef = _react["default"].useRef(null);

  var getLinkedStyles = function getLinkedStyles() {
    return {
      styles: /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "4123931595",
        dynamic: [theme.transitions.create(["height"])]
      }, ".root.__jsx-style-dynamic-selector{height:0;min-height:0;overflow:hidden;-webkit-transition:".concat(theme.transitions.create(["height"]), ";transition:").concat(theme.transitions.create(["height"]), ";}.entered.__jsx-style-dynamic-selector{height:auto;overflow:visible;}.exited.__jsx-style-dynamic-selector{height:0;}")),
      className: _style["default"].dynamic([["4123931595", [theme.transitions.create(["height"])]]])
    };
  };

  var getWrapperSize = function getWrapperSize() {
    return wrapperRef.current ? wrapperRef.current.clientHeight : 0;
  };

  var handleEnter = function handleEnter(node) {
    if (wrapperRef.current) {
      // Set absolute position to get the size of collapsed content
      wrapperRef.current.style.position = "absolute";
    }

    node.style.height = "0";
  };

  var handleEntering = function handleEntering(node) {
    var wrapperSize = getWrapperSize();

    if (wrapperRef.current) {
      // After the size is read reset the position back to default
      wrapperRef.current.style.position = "";
    }

    node.style.transitionDuration = "".concat(theme.transitions.duration.standard, "ms");
    node.style.height = "".concat(wrapperSize, "px");
  };

  var handleEntered = function handleEntered(node) {
    node.style.height = "auto";
  };

  var handleExit = function handleExit(node) {
    node.style.height = "".concat(getWrapperSize(), "px");
  };

  var handleExiting = function handleExiting(node) {
    // For some reason smooth collapse doesn't work unless we call this here
    getWrapperSize();
    node.style.transitionDuration = "".concat(theme.transitions.duration.standard, "ms");
    node.style.height = "0";
  };

  var linkedStyles = getLinkedStyles();
  return /*#__PURE__*/_react["default"].createElement(_reactTransitionGroup.Transition, _extends({
    "in": inProp,
    onEnter: handleEnter,
    onEntered: handleEntered,
    onEntering: handleEntering,
    onExit: handleExit,
    onExiting: handleExiting,
    timeout: theme.transitions.duration.standard
  }, other), function (state, childProps) {
    return /*#__PURE__*/_react["default"].createElement(Component, _extends({
      className: (0, _clsx["default"])(linkedStyles.className, "root", {
        entered: state === "entered",
        exited: state === "exited" && !inProp
      }, classes)
    }, childProps), /*#__PURE__*/_react["default"].createElement("div", {
      ref: wrapperRef
    }, children), linkedStyles.styles);
  });
};

Collapse.propTypes = {
  /**
   * The content node to be collapsed.
   */
  children: _propTypes["default"].node,

  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].array,

  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: _propTypes["default"].elementType,

  /**
   * If `true`, the component will transition in.
   */
  "in": _propTypes["default"].bool
};
Collapse.defaultProps = {
  classes: [],
  component: "div"
};
Collapse.displayName = "Collapse";
var _default = Collapse;
exports["default"] = _default;