"use strict";

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _react = _interopRequireDefault(require("react"));

var _Collapse = _interopRequireDefault(require("./Collapse"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<Collapse>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Collapse["default"], null));
    } catch (e) {
      error = e;
    }

    expect(error).toEqual(undefined);
  });
  it("renders correct snapshot", function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Collapse["default"], null));
    expect((0, _enzymeToJson["default"])(wrapper)).toMatchSnapshot();
  });
  describe("default props", function () {
    it("sets correct default props", function () {
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Collapse["default"], null));
      expect(wrapper.find("Collapse").props().component).toEqual("div");
    });
  });
  describe("children prop", function () {
    it("renders given childen", function () {
      var child = /*#__PURE__*/_react["default"].createElement("div", null, "child");

      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Collapse["default"], null, child));
      expect(wrapper.find("Collapse").contains(child)).toEqual(true);
    });
  });
  describe("classes prop", function () {
    it("applies given classes", function () {
      var classes = ["classOne"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Collapse["default"], {
        classes: classes
      }));
      expect(wrapper.find("Collapse").childAt(0).childAt(0).hasClass(classes[0])).toEqual(true);
    });
    it("gives an error when classes are provided as one string", function () {
      var classes = "classOne classTwo";
      var errors = jest.spyOn(console, "error").mockImplementation();
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Collapse["default"], {
        classes: classes
      }));
      expect(errors).toHaveBeenCalled();
    });
  });
  describe("component prop", function () {
    it("sets component type as span", function () {
      var component = "span";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Collapse["default"], {
        component: component
      }));
      expect(wrapper.find("Collapse").childAt(0).childAt(0).type()).toEqual(component);
    });
  });
  describe("in prop", function () {
    it("sets class name as entered when in prop is true", function () {
      var isTransition = true;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Collapse["default"], {
        "in": isTransition
      }));
      expect(wrapper.find("Collapse").childAt(0).childAt(0).hasClass("entered")).toEqual(true);
    });
    it("sets class name as exited when in prop is false", function () {
      var isTransition = false;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Collapse["default"], {
        "in": isTransition
      }));
      expect(wrapper.find("Collapse").childAt(0).childAt(0).hasClass("exited")).toEqual(true);
    });
  });
});