"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Container = function Container(_ref) {
  var classes = _ref.classes,
      children = _ref.children,
      maxWidth = _ref.maxWidth;

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  var className = (0, _clsx["default"])("root", classes);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _style["default"].dynamic([["578709594", [maxWidth ? "".concat(theme.breakpoints[maxWidth], "px") : "100%", theme.spacing(6), theme.breakpoints.lg, theme.spacing(5), theme.breakpoints.md, theme.spacing(3)]]]) + " " + (className || "")
  }, children, /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "578709594",
    dynamic: [maxWidth ? "".concat(theme.breakpoints[maxWidth], "px") : "100%", theme.spacing(6), theme.breakpoints.lg, theme.spacing(5), theme.breakpoints.md, theme.spacing(3)]
  }, ".root.__jsx-style-dynamic-selector{box-sizing:border-box;margin:0 auto;max-width:".concat(maxWidth ? "".concat(theme.breakpoints[maxWidth], "px") : "100%", ";padding:0 ").concat(theme.spacing(6), "px;position:relative;}@media (max-width:").concat(theme.breakpoints.lg, "px){.root.__jsx-style-dynamic-selector{padding:0 ").concat(theme.spacing(5), "px;}}@media (max-width:").concat(theme.breakpoints.md, "px){.root.__jsx-style-dynamic-selector{padding:0 ").concat(theme.spacing(3), "px;}}")));
};

Container.propTypes = {
  /**
   * The content inside the container.
   */
  children: _propTypes["default"].any,

  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].array,

  /**
   * Determine the max-width of the container.
   * The container width grows with the size of the screen.
   */
  maxWidth: _propTypes["default"].oneOf(["sm", "md", "lg", "xl", false])
};
Container.defaultProps = {
  classes: [],
  maxWidth: "lg"
};
Container.displayName = "Container";

var _default = (0, _withClasses["default"])(Container);

exports["default"] = _default;