"use strict";

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _react = _interopRequireDefault(require("react"));

var _Divider = _interopRequireDefault(require("./Divider"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<Divider>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Divider["default"], null));
    } catch (e) {
      error = e;
    }

    expect(error).toEqual(undefined);
  });
  it("renders correct snapshot", function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Divider["default"], null));
    expect((0, _enzymeToJson["default"])(wrapper)).toMatchSnapshot();
  });
  describe("default props", function () {
    it("sets correct default props", function () {
      var defaultProps = new _Divider["default"]().type.defaultProps;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Divider["default"], null));
      var component = wrapper.find("Divider");
      expect(component.props().variant).toEqual(defaultProps.variant);
    });
  });
  describe("classes prop", function () {
    it("applies all classes to the root node of Divider", function () {
      var classes = ["classOne"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Divider["default"], {
        classes: classes
      }));
      expect(wrapper.find("Divider").childAt(0).hasClass(classes[0])).toEqual(true);
    });
    it("appends higher order values to classes prop with withClasses decorator", function () {
      var classes = ["riipen", "riipen-divider"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Divider["default"], null));
      expect(wrapper.find("Divider").props().classes.sort()).toEqual(classes.sort());
    });
    it("gives an error when classes are provided as one string", function () {
      var classes = "classOne classTwo";
      var errors = jest.spyOn(console, "error").mockImplementation();
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Divider["default"], {
        classes: classes
      }));
      expect(errors).toHaveBeenCalled();
    });
  });
  describe("variant prop", function () {
    it("sets variant class name with a valid variant", function () {
      var variant = "middle";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Divider["default"], {
        variant: variant
      }));
      expect(wrapper.find("Divider").childAt(0).hasClass(variant)).toEqual(true);
    });
    it("gives an error when given an invalid variant", function () {
      var errors = jest.spyOn(console, "error").mockImplementation();
      var variant = "somethingInvalid";
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Divider["default"], {
        variant: variant
      }));
      expect(errors).toHaveBeenCalledTimes(1);
    });
  });
});