"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _Backdrop = _interopRequireDefault(require("./Backdrop"));

var _ClickAway = _interopRequireDefault(require("./ClickAway"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Drawer = /*#__PURE__*/function (_React$Component) {
  _inherits(Drawer, _React$Component);

  var _super = _createSuper(Drawer);

  function Drawer() {
    _classCallCheck(this, Drawer);

    return _super.apply(this, arguments);
  }

  _createClass(Drawer, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          anchor = _this$props.anchor,
          children = _this$props.children,
          classes = _this$props.classes,
          onClose = _this$props.onClose,
          open = _this$props.open;
      if (!open) return null;
      var theme = this.context;
      var className = (0, _clsx["default"])("drawer", anchor, classes);
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Backdrop["default"], null), /*#__PURE__*/_react["default"].createElement(_ClickAway["default"], {
        onClickAway: onClose
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: _style["default"].dynamic([["3412078254", [theme.palette.common.white, theme.zIndex.middle]]]) + " " + (className || "")
      }, children)), /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "3412078254",
        dynamic: [theme.palette.common.white, theme.zIndex.middle]
      }, ".drawer.__jsx-style-dynamic-selector{background-color:".concat(theme.palette.common.white, ";display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-direction:column;-ms-flex-direction:column;flex-direction:column;-webkit-flex:1 0 auto;-ms-flex:1 0 auto;flex:1 0 auto;height:100%;overflow-y:auto;position:fixed;top:0;z-index:").concat(theme.zIndex.middle, ";}.left.__jsx-style-dynamic-selector{left:0;right:auto;}.right.__jsx-style-dynamic-selector{left:auto;right:0;}.top.__jsx-style-dynamic-selector{top:0;left:0;bottom:auto;right:0;height:auto;max-height:100%;}.bottom.__jsx-style-dynamic-selector{top:auto;left:0;bottom:0;right:0;height:auto;max-height:100%;}")));
    }
  }]);

  return Drawer;
}(_react["default"].Component);

_defineProperty(Drawer, "displayName", "Drawer");

_defineProperty(Drawer, "propTypes", {
  /**
   * Side from which the drawer will appear.
   */
  anchor: _propTypes["default"].oneOf(["left", "top", "right", "bottom"]),

  /**
   * The content of the component.
   */
  children: _propTypes["default"].node,

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * Callback fired when the component requests to be closed.
   *
   * @param {object} event The event source of the callback.
   */
  onClose: _propTypes["default"].func.isRequired,

  /**
   * If `true`, the drawer is open.
   */
  open: _propTypes["default"].bool.isRequired
});

_defineProperty(Drawer, "defaultProps", {
  anchor: "left",
  open: false
});

_defineProperty(Drawer, "contextType", _ThemeContext["default"]);

var _default = (0, _withClasses["default"])(Drawer);

exports["default"] = _default;