"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _clsx = _interopRequireDefault(require("clsx"));

var _draftJs = require("draft-js");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _EditorBlockStyleControls = _interopRequireDefault(require("./EditorBlockStyleControls"));

var _EditorInlineStyleControls = _interopRequireDefault(require("./EditorInlineStyleControls"));

var _EditorImage = _interopRequireDefault(require("./EditorImage"));

var _EditorUtils = _interopRequireDefault(require("./EditorUtils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// draft-js map of inline style types to the corresponding style displayed in the editor.
var styleMap = {
  CODE: {
    backgroundColor: "rgba(0, 0, 0, 0.05)",
    fontFamily: '"Inconsolata", "Menlo", "Consolas", monospace',
    padding: 2
  }
};

var getBlockComponent = function getBlockComponent(block) {
  switch (block.getType()) {
    case "atomic":
      return {
        component: _EditorImage["default"],
        editable: false
      };

    default:
      return null;
  }
};

var Editor = /*#__PURE__*/function (_React$Component) {
  _inherits(Editor, _React$Component);

  var _super = _createSuper(Editor);

  function Editor(props) {
    var _this;

    _classCallCheck(this, Editor);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "onChange", function (editorState) {
      var propagate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      _this.setState({
        editorState: editorState
      }, function () {
        var html = _this.getHtml();

        if (_this.props.onChange && propagate) {
          _this.props.onChange(html);
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getLinkedStyles", function () {
      var theme = _this.context;
      var _this$props = _this.props,
          controlPosition = _this$props.controlPosition,
          maxHeight = _this$props.maxHeight;
      return {
        styles: /*#__PURE__*/_react["default"].createElement(_style["default"], {
          id: "763509029",
          dynamic: [theme.palette.common.white, theme.palette.grey[500], theme.shape.borderRadius.md, theme.typography.body1.fontFamily, theme.typography.body1.fontSize, theme.typography.body1.lineHeight, theme.transitions.duration.standard, theme.palette.grey[400], theme.palette.tertiary.main, theme.palette.negative.main, theme.shape.borderRadius.md, theme.shape.borderRadius.md, controlPosition === "bottom" ? "1px solid ".concat(theme.palette.grey[400]) : "none", controlPosition === "top" ? "1px solid ".concat(theme.palette.grey[400]) : "none", theme.shape.borderRadius.md, theme.shape.borderRadius.md, theme.palette.common.white, theme.palette.grey[600], theme.typography.body1.fontSize, maxHeight, theme.spacing(3), theme.transitions.duration.standard, theme.palette.common.white, theme.palette.text.primary, theme.palette.grey[100], theme.spacing(2), theme.shape.borderRadius.md, theme.shape.borderRadius.md, theme.palette.divider, theme.breakpoints.sm, theme.shape.borderRadius.md, theme.spacing(1), theme.palette.grey[400], theme.palette.text.secondary, theme.spacing(2), theme.spacing(4), theme.palette.grey[400], theme.spacing(4)]
        }, ".wrapper.__jsx-style-dynamic-selector{background-color:".concat(theme.palette.common.white, ";border:1px solid ").concat(theme.palette.grey[500], ";border-radius:").concat(theme.shape.borderRadius.md, ";font-family:").concat(theme.typography.body1.fontFamily, ";font-size:").concat(theme.typography.body1.fontSize, ";line-height:").concat(theme.typography.body1.lineHeight, ";min-height:115px;position:relative;-webkit-transition:").concat(theme.transitions.duration.standard, "ms all;transition:").concat(theme.transitions.duration.standard, "ms all;width:100%;word-break:break-word;}.wrapper.disabled.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.grey[400], ";opacity:0.5;pointer-events:none;}.wrapper.focus.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.tertiary.main, ";outline:0;}.wrapper.error.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.negative.main, ";}.editor.top.__jsx-style-dynamic-selector{border-bottom-left-radius:").concat(theme.shape.borderRadius.md, ";border-bottom-right-radius:").concat(theme.shape.borderRadius.md, ";border-top:").concat(controlPosition === "bottom" ? "1px solid ".concat(theme.palette.grey[400]) : "none", ";}.editor.bottom.__jsx-style-dynamic-selector{border-bottom:").concat(controlPosition === "top" ? "1px solid ".concat(theme.palette.grey[400]) : "none", ";border-top-left-radius:").concat(theme.shape.borderRadius.md, ";border-top-right-radius:").concat(theme.shape.borderRadius.md, ";}.editor.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.common.white, ";color:").concat(theme.palette.grey[600], ";cursor:text;font-size:").concat(theme.typography.body1.fontSize, ";max-height:").concat(maxHeight, ";min-height:78px;overflow-y:auto;padding:").concat(theme.spacing(3), "px;-webkit-transition:").concat(theme.transitions.duration.standard, "ms all;transition:").concat(theme.transitions.duration.standard, "ms all;}.focus.__jsx-style-dynamic-selector .editor.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.common.white, ";color:").concat(theme.palette.text.primary, ";}.controlContainer.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.grey[100], ";display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex:1 1 auto;-ms-flex:1 1 auto;flex:1 1 auto;-webkit-flex-direction:row;-ms-flex-direction:row;flex-direction:row;-webkit-box-pack:justify;-webkit-justify-content:space-between;-ms-flex-pack:justify;justify-content:space-between;-webkit-align-items:flex-end;-webkit-box-align:flex-end;-ms-flex-align:flex-end;align-items:flex-end;padding-left:").concat(theme.spacing(2), "px;border-bottom-left-radius:").concat(theme.shape.borderRadius.md, ";border-bottom-right-radius:").concat(theme.shape.borderRadius.md, ";}.stylingControls.__jsx-style-dynamic-selector>div.__jsx-style-dynamic-selector:not(:last-child){border-right:1px solid ").concat(theme.palette.divider, ";}@media (max-width:").concat(theme.breakpoints.sm, "px){.controlContainer.__jsx-style-dynamic-selector{display:none;}.controlContainer.mobileControlRow.__jsx-style-dynamic-selector{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;}.wrapper.__jsx-style-dynamic-selector{min-height:0;}.editor.bottom.__jsx-style-dynamic-selector,.editor.top.__jsx-style-dynamic-selector{border-bottom:0;border-radius:").concat(theme.shape.borderRadius.md, ";}}.controlRow.__jsx-style-dynamic-selector{display:inline-block;margin:").concat(theme.spacing(1), "px 0;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;}.blockquote.__jsx-style-dynamic-selector{border-left:5px solid ").concat(theme.palette.grey[400], ";color:").concat(theme.palette.text.secondary, ";font-style:italic;margin:16px 0;padding:").concat(theme.spacing(2), "px ").concat(theme.spacing(4), "px;}.DraftEditor-root{position:relative;}.public-DraftEditorPlaceholder-inner{color:").concat(theme.palette.grey[400], ";}.public-DraftEditorPlaceholder-root{position:absolute;}.richTextEditor-hidePlaceholder .public-DraftEditorPlaceholder-root{display:none;}.public-DraftEditorPlaceholder-hasFocus{display:none;}.public-DraftStyleDefault-pre{background-color:rgba(0,0,0,0.05);font-family:\"Inconsolata\",\"Menlo\",\"Consolas\",monospace;font-size:16px;padding:").concat(theme.spacing(4), "px;}.public-DraftStyleDefault-block{margin-bottom:1em;}")),
        className: _style["default"].dynamic([["763509029", [theme.palette.common.white, theme.palette.grey[500], theme.shape.borderRadius.md, theme.typography.body1.fontFamily, theme.typography.body1.fontSize, theme.typography.body1.lineHeight, theme.transitions.duration.standard, theme.palette.grey[400], theme.palette.tertiary.main, theme.palette.negative.main, theme.shape.borderRadius.md, theme.shape.borderRadius.md, controlPosition === "bottom" ? "1px solid ".concat(theme.palette.grey[400]) : "none", controlPosition === "top" ? "1px solid ".concat(theme.palette.grey[400]) : "none", theme.shape.borderRadius.md, theme.shape.borderRadius.md, theme.palette.common.white, theme.palette.grey[600], theme.typography.body1.fontSize, maxHeight, theme.spacing(3), theme.transitions.duration.standard, theme.palette.common.white, theme.palette.text.primary, theme.palette.grey[100], theme.spacing(2), theme.shape.borderRadius.md, theme.shape.borderRadius.md, theme.palette.divider, theme.breakpoints.sm, theme.shape.borderRadius.md, theme.spacing(1), theme.palette.grey[400], theme.palette.text.secondary, theme.spacing(2), theme.spacing(4), theme.palette.grey[400], theme.spacing(4)]]])
      };
    });

    _defineProperty(_assertThisInitialized(_this), "setHtml", /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(html) {
        var _this$props2, decorator, autoFocus, contentState, editorState;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this$props2 = _this.props, decorator = _this$props2.decorator, autoFocus = _this$props2.autoFocus;
                contentState = _EditorUtils["default"].fromHtml(html || "");
                editorState = _draftJs.EditorState.createWithContent(contentState, decorator);
                _context.next = 5;
                return _this.onChange(editorState);

              case 5:
                if (autoFocus) {
                  _this.focus();
                }

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());

    _defineProperty(_assertThisInitialized(_this), "getHtml", function () {
      var html = _EditorUtils["default"].toHtml(_this.state.editorState.getCurrentContent());

      return _this.hasContent() ? html : "";
    });

    _defineProperty(_assertThisInitialized(_this), "getBlockStyle", function (block) {
      var linkedStyles = _this.getLinkedStyles();

      switch (block.getType()) {
        case "blockquote":
          return (0, _clsx["default"])(linkedStyles.className, "blockquote");

        default:
          return null;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "hasContent", function () {
      return _this.state.editorState.getCurrentContent().hasText();
    });

    _defineProperty(_assertThisInitialized(_this), "handleKeyCommand", function (command, editorState) {
      var newState = _draftJs.RichUtils.handleKeyCommand(editorState, command);

      if (newState) {
        _this.onChange(newState);

        return true;
      }

      return false;
    });

    _defineProperty(_assertThisInitialized(_this), "myKeyBindingFn", function (e) {
      if (e.key === "Enter") e.stopPropagation();
      return (0, _draftJs.getDefaultKeyBinding)(e);
    });

    _defineProperty(_assertThisInitialized(_this), "focus", function (force) {
      var _this$props3 = _this.props,
          autoFocus = _this$props3.autoFocus,
          forceFocus = _this$props3.forceFocus;

      if (_this.editor && _this.editor.current && autoFocus || forceFocus && force) {
        _this.editor.current.focus();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "forceFocus", function () {
      return _this.focus(true);
    });

    _defineProperty(_assertThisInitialized(_this), "toggleBlockType", function (blockType) {
      _this.onChange(_draftJs.RichUtils.toggleBlockType(_this.state.editorState, blockType));
    });

    _defineProperty(_assertThisInitialized(_this), "toggleInlineStyle", function (inlineStyle) {
      _this.onChange(_draftJs.RichUtils.toggleInlineStyle(_this.state.editorState, inlineStyle));
    });

    _defineProperty(_assertThisInitialized(_this), "addText", function (text) {
      var editorState = _this.state.editorState;
      var contentState = editorState.getCurrentContent();
      var selectionState = editorState.getSelection();
      var newContentState; // Checks if text is highlighted to either insert/replace

      if (selectionState.isCollapsed()) {
        newContentState = _draftJs.Modifier.insertText(contentState, selectionState, text);
      } else {
        newContentState = _draftJs.Modifier.replaceText(contentState, selectionState, text);
      }

      var newEditorState = _draftJs.EditorState.push(editorState, newContentState, "insert-characters");

      _this.onChange(newEditorState);
    });

    _defineProperty(_assertThisInitialized(_this), "addLink", function (_ref2) {
      var text = _ref2.text,
          url = _ref2.url;
      var editorState = _this.state.editorState;
      var contentState = editorState.getCurrentContent();
      var selectionState = editorState.getSelection(); // replace the current selection with the provided text

      var newContentState = _draftJs.Modifier.replaceText(contentState, selectionState, text);

      var contentStateWithEntity = newContentState.createEntity(_EditorUtils["default"].EDITOR_ENTITY_TYPES.LINK, "MUTABLE", {
        url: url
      }); // Get the first block key in the selection and force selection of inserted text

      var blockKey = selectionState.getIsBackward() ? selectionState.getFocusKey() : selectionState.getAnchorKey();
      var anchorOffset = selectionState.getStartOffset();
      var focusOffset = anchorOffset + text.length;
      var newSelectionState = new _draftJs.SelectionState({
        anchorKey: blockKey,
        anchorOffset: anchorOffset,
        focusKey: blockKey,
        focusOffset: focusOffset
      });

      var editorStateWithSelection = _draftJs.EditorState.forceSelection(editorState, newSelectionState); // Add the newly created link


      var editorStateWithEntity = _draftJs.EditorState.set(editorStateWithSelection, {
        currentContent: contentStateWithEntity
      }); // Make the new link entity active.


      var entityKey = contentStateWithEntity.getLastCreatedEntityKey();

      var editorStateWithLink = _draftJs.RichUtils.toggleLink(editorStateWithEntity, editorStateWithEntity.getSelection(), entityKey);

      _this.onChange(editorStateWithLink);
    });

    _defineProperty(_assertThisInitialized(_this), "removeLinks", function (ranges) {
      var blocks = Object.keys(ranges);
      var newEditorState = _this.state.editorState;
      blocks.forEach(function (key) {
        var block = ranges[key];
        block.forEach(function (_ref3) {
          var start = _ref3.start,
              end = _ref3.end;
          var selectionState = new _draftJs.SelectionState({
            anchorKey: key,
            anchorOffset: start,
            focusKey: key,
            focusOffset: end
          });
          var contentState = newEditorState.getCurrentContent();

          var newContentState = _draftJs.Modifier.applyEntity(contentState, selectionState, null);

          newEditorState = _draftJs.EditorState.set(newEditorState, {
            currentContent: newContentState
          });
        });
      });

      _this.onChange(newEditorState);
    });

    _defineProperty(_assertThisInitialized(_this), "addImage", function (_ref4) {
      var url = _ref4.url,
          altText = _ref4.altText;
      var editorState = _this.state.editorState;
      var contentState = editorState.getCurrentContent();
      var contentStateWithEntity = contentState.createEntity(_EditorUtils["default"].EDITOR_ENTITY_TYPES.IMAGE, "IMMUTABLE", {
        alt: altText,
        src: url
      });
      var entityKey = contentStateWithEntity.getLastCreatedEntityKey();

      var editorStateWithEntity = _draftJs.EditorState.set(editorState, {
        currentContent: contentStateWithEntity
      });

      var newEditorState = _draftJs.AtomicBlockUtils.insertAtomicBlock(editorStateWithEntity, entityKey, " ");

      _this.onChange(newEditorState);
    });

    _defineProperty(_assertThisInitialized(_this), "renderControls", function () {
      var _this$props4 = _this.props,
          stylingControls = _this$props4.stylingControls,
          actionControls = _this$props4.actionControls,
          mobileControlRow = _this$props4.mobileControlRow;
      var editorState = _this.state.editorState;

      var linkedStyles = _this.getLinkedStyles();

      var controlContainerClasses = mobileControlRow ? ["controlContainer", "mobileControlRow"] : "controlContainer";
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _clsx["default"])(linkedStyles.className, controlContainerClasses)
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _clsx["default"])(linkedStyles.className, "stylingControls")
      }, /*#__PURE__*/_react["default"].createElement(_EditorBlockStyleControls["default"], {
        classes: [linkedStyles.className, "controlRow"],
        editorState: editorState,
        toggle: _this.toggleBlockType,
        whitelist: _this.props.controlWhitelist
      }), /*#__PURE__*/_react["default"].createElement(_EditorInlineStyleControls["default"], {
        classes: [linkedStyles.className, "controlRow"],
        editorState: editorState,
        toggle: _this.toggleInlineStyle,
        whitelist: _this.props.controlWhitelist
      }), stylingControls && stylingControls.map(function (control, index) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: "control-".concat(index),
          className: (0, _clsx["default"])([linkedStyles.className, "controlRow"])
        }, control);
      })), /*#__PURE__*/_react["default"].createElement("div", null, actionControls && actionControls.map(function (control, index) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: "control-".concat(index)
        }, control);
      }))));
    });

    _this.editor = /*#__PURE__*/_react["default"].createRef();
    _this.state = {
      editorState: undefined
    };
    return _this;
  }

  _createClass(Editor, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props5 = this.props,
          decorator = _this$props5.decorator,
          initialValue = _this$props5.initialValue; // Sets editor state after mount (because SSR)

      var editorState = initialValue ? _draftJs.EditorState.createWithContent(_EditorUtils["default"].fromHtml(initialValue || ""), decorator) : _draftJs.EditorState.createEmpty(decorator);
      this.onChange(editorState, false);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props6 = this.props,
          ariaLabelledBy = _this$props6.ariaLabelledBy,
          controlPosition = _this$props6.controlPosition,
          forceFocus = _this$props6.forceFocus,
          disabled = _this$props6.disabled,
          error = _this$props6.error,
          onBlur = _this$props6.onBlur,
          placeholder = _this$props6.placeholder,
          style = _this$props6.style;
      var editorState = this.state.editorState;
      if (!editorState) return null;
      var linkedStyles = this.getLinkedStyles();
      var wrapperClasses = (0, _clsx["default"])(linkedStyles.className, "wrapper", disabled && "disabled", editorState.getSelection().getHasFocus() && "focus", error && "error");
      var content = editorState.getCurrentContent();
      var hidePlaceholder = !content.hasText() && content.getBlockMap().first().getType() !== "unstyled";
      var editorClasses = (0, _clsx["default"])(linkedStyles.className, "editor", disabled && "disabled", controlPosition, hidePlaceholder && "richTextEditor-hidePlaceholder");
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        className: wrapperClasses,
        onClick: forceFocus ? this.forceFocus : null
      }, controlPosition === "top" && this.renderControls(), /*#__PURE__*/_react["default"].createElement("div", {
        className: editorClasses,
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_draftJs.Editor, {
        ariaLabelledBy: ariaLabelledBy,
        blockRendererFn: getBlockComponent,
        blockStyleFn: this.getBlockStyle,
        customStyleMap: styleMap,
        editorState: editorState,
        handleKeyCommand: this.handleKeyCommand,
        keyBindingFn: this.myKeyBindingFn,
        onBlur: onBlur,
        onChange: this.onChange,
        placeholder: placeholder,
        ref: this.editor,
        spellCheck: true,
        readOnly: disabled
      })), controlPosition === "bottom" && this.renderControls()), linkedStyles.styles);
    }
  }]);

  return Editor;
}(_react["default"].Component);

_defineProperty(Editor, "displayName", "Editor");

_defineProperty(Editor, "propTypes", {
  /**
   * Whether or not to move focus the Editor on first render.
   */
  autoFocus: _propTypes["default"].bool,

  /**
   * Action controls to display on the right side of the editor control bar.
   */
  actionControls: _propTypes["default"].arrayOf(_propTypes["default"].node),

  /**
   * The id of the element to use as the aria-label for the Editor.
   */
  ariaLabelledBy: _propTypes["default"].string,

  /**
   * Optional array of whitelisted styles.
   * ex. ['code-block', 'BOLD', 'LINK']
   */
  controlWhitelist: _propTypes["default"].arrayOf(_propTypes["default"].string),

  /**
   * Position of controls for the editor.
   */
  controlPosition: _propTypes["default"].oneOf(["top", "bottom"]),

  /**
   * Disable the editor or not
   */
  disabled: _propTypes["default"].bool,

  /**
   * The decorator for the editor.
   */
  decorator: _propTypes["default"].shape({
    type: _propTypes["default"].oneOf([_draftJs.CompositeDecorator])
  }),

  /**
   * If the error style should be shown or not.
   */
  error: _propTypes["default"].any,

  /**
   * Whether or not to force the editor focus on click.
   */
  forceFocus: _propTypes["default"].bool,

  /**
   * Whether or not to hide the controls + control row when on smaller screens.
   */
  mobileControlRow: _propTypes["default"].bool,

  /**
   * Initial content to set in the editor.
   */
  initialValue: _propTypes["default"].any,

  /**
   * Function to execute when editor content changes, gets html value of editor.
   */
  onChange: _propTypes["default"].func,

  /**
   * Function to execute when editor is out of focus.
   */
  onBlur: _propTypes["default"].func,

  /**
   * The max height of the Editor text area.
   */
  maxHeight: _propTypes["default"].string,

  /**
   * Optional placeholder. Shows when there is no text.
   */
  placeholder: _propTypes["default"].node,

  /**
   * Optional style applied to parent div of editor.
   * Used to set a minimum height.
   */
  style: _propTypes["default"].object,

  /**
   * Additional action controls to display on the left side of the editor control bar.
   */
  stylingControls: _propTypes["default"].arrayOf(_propTypes["default"].node)
});

_defineProperty(Editor, "defaultProps", {
  actionControls: [],
  controlPosition: "top",
  forceFocus: true,
  maxHeight: "auto",
  mobileControlRow: false,
  stylingControls: []
});

_defineProperty(Editor, "contextType", _ThemeContext["default"]);

var _default = Editor;
exports["default"] = _default;