"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _reactFontawesome = require("@fortawesome/react-fontawesome");

var _faListOl = require("@fortawesome/free-solid-svg-icons/faListOl");

var _faListUl = require("@fortawesome/free-solid-svg-icons/faListUl");

var _faQuoteLeft = require("@fortawesome/free-solid-svg-icons/faQuoteLeft");

var _EditorControlButton = _interopRequireDefault(require("./EditorControlButton"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BLOCK_TYPES = [{
  label: /*#__PURE__*/_react["default"].createElement(_reactFontawesome.FontAwesomeIcon, {
    icon: _faListUl.faListUl
  }),
  style: "unordered-list-item",
  size: "small"
}, {
  label: /*#__PURE__*/_react["default"].createElement(_reactFontawesome.FontAwesomeIcon, {
    icon: _faListOl.faListOl
  }),
  style: "ordered-list-item",
  size: "small"
}, {
  label: "H1",
  style: "header-one",
  width: "small"
}, {
  label: "H2",
  style: "header-two",
  width: "small"
}, {
  label: "H3",
  style: "header-three",
  width: "small"
}, {
  label: "H4",
  style: "header-four",
  width: "small"
}, {
  label: /*#__PURE__*/_react["default"].createElement(_reactFontawesome.FontAwesomeIcon, {
    icon: _faQuoteLeft.faQuoteLeft
  }),
  style: "blockquote",
  size: "small"
}];

var EditorBlockStyleControls = /*#__PURE__*/function (_React$Component) {
  _inherits(EditorBlockStyleControls, _React$Component);

  var _super = _createSuper(EditorBlockStyleControls);

  function EditorBlockStyleControls() {
    var _this;

    _classCallCheck(this, EditorBlockStyleControls);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "onControlClick", function (style) {
      return function () {
        return _this.props.toggle(style);
      };
    });

    return _this;
  }

  _createClass(EditorBlockStyleControls, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          classes = _this$props.classes,
          editorState = _this$props.editorState,
          whitelist = _this$props.whitelist;
      var selection = editorState.getSelection();
      var blockType = editorState.getCurrentContent().getBlockForKey(selection.getStartKey()).getType();
      var controlButtons = BLOCK_TYPES;

      if (whitelist) {
        controlButtons = BLOCK_TYPES.filter(function (_ref) {
          var style = _ref.style;
          return whitelist.includes(style);
        });
      }

      if (controlButtons.length === 0) {
        return null;
      }

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _clsx["default"])(classes)
      }, controlButtons.map(function (_ref2) {
        var label = _ref2.label,
            style = _ref2.style,
            size = _ref2.size;
        return /*#__PURE__*/_react["default"].createElement(_EditorControlButton["default"], {
          key: style,
          active: style === blockType,
          label: label,
          onClick: _this2.onControlClick(style),
          size: size
        });
      }));
    }
  }]);

  return EditorBlockStyleControls;
}(_react["default"].Component);

_defineProperty(EditorBlockStyleControls, "displayName", "EditorBlockStyleControls");

_defineProperty(EditorBlockStyleControls, "propTypes", {
  /**
   * The additional css classes to style the controls with.
   *
   */
  classes: _propTypes["default"].arrayOf(_propTypes["default"].string),

  /**
   * The draftjs editor state immutable record.
   *
   */
  editorState: _propTypes["default"].any.isRequired,

  /**
   * Function to toggle block type.
   *
   */
  toggle: _propTypes["default"].func.isRequired,

  /**
   * Optional array of whitelisted block styles
   * ex. ['header-one', 'code-block']
   *
   */
  whitelist: _propTypes["default"].arrayOf(_propTypes["default"].string)
});

_defineProperty(EditorBlockStyleControls, "defaultProps", {
  classes: []
});

var _default = EditorBlockStyleControls;
exports["default"] = _default;