"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var EditorControlButton = /*#__PURE__*/function (_React$Component) {
  _inherits(EditorControlButton, _React$Component);

  var _super = _createSuper(EditorControlButton);

  function EditorControlButton() {
    var _this;

    _classCallCheck(this, EditorControlButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "onClick", function (e) {
      e.preventDefault();

      _this.props.onClick();
    });

    return _this;
  }

  _createClass(EditorControlButton, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          active = _this$props.active,
          size = _this$props.size;
      var classNames = ["controlButton", size, active && "activeButton"].filter(Boolean);
      var theme = this.context;
      return /*#__PURE__*/_react["default"].createElement("span", {
        onMouseDown: this.onClick,
        className: _style["default"].dynamic([["2700112169", [theme.palette.text.secondary, theme.spacing(2), theme.palette.background["default"], theme.palette.text.secondary, theme.palette.background["default"], theme.palette.common.black]]]) + " " + ((0, _clsx["default"])(classNames) || "")
      }, this.props.label, /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "2700112169",
        dynamic: [theme.palette.text.secondary, theme.spacing(2), theme.palette.background["default"], theme.palette.text.secondary, theme.palette.background["default"], theme.palette.common.black]
      }, ".controlButton.__jsx-style-dynamic-selector{color:".concat(theme.palette.text.secondary, ";cursor:pointer;display:inline-block;font-size:16px;padding:3px ").concat(theme.spacing(2), "px;text-align:center;}.small.__jsx-style-dynamic-selector{width:41px;}.medium.__jsx-style-dynamic-selector{width:82px;}.large.__jsx-style-dynamic-selector{width:123px;}.controlButton.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.background["default"], ";color:").concat(theme.palette.text.secondary, ";}.activeButton.__jsx-style-dynamic-selector,.activeButton.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.background["default"], ";color:").concat(theme.palette.common.black, ";}")));
    }
  }]);

  return EditorControlButton;
}(_react["default"].Component);

_defineProperty(EditorControlButton, "displayName", "EditorControlButton");

_defineProperty(EditorControlButton, "propTypes", {
  /**
   * If the control is active.
   *
   */
  active: _propTypes["default"].bool.isRequired,

  /**
   * The display for the button. We use a string or <Icon />.
   *
   */
  label: _propTypes["default"].node.isRequired,

  /**
   * Function to execute on control button click.
   *
   */
  onClick: _propTypes["default"].func.isRequired,

  /**
   * The width of the control button.
   *
   */
  size: _propTypes["default"].oneOf(["small", "medium", "large"])
});

_defineProperty(EditorControlButton, "defaultProps", {
  size: "small"
});

_defineProperty(EditorControlButton, "contextType", _ThemeContext["default"]);

var _default = (0, _withClasses["default"])(EditorControlButton);

exports["default"] = _default;