"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _draftJs = require("draft-js");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var EditorLink = /*#__PURE__*/function (_React$Component) {
  _inherits(EditorLink, _React$Component);

  var _super = _createSuper(EditorLink);

  function EditorLink() {
    _classCallCheck(this, EditorLink);

    return _super.apply(this, arguments);
  }

  _createClass(EditorLink, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          contentState = _this$props.contentState,
          entityKey = _this$props.entityKey;

      var _contentState$getEnti = contentState.getEntity(entityKey).getData(),
          url = _contentState$getEnti.url;

      var theme = this.context;
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("a", {
        href: url,
        className: _style["default"].dynamic([["604366142", [theme.palette.primary.light]]]) + " " + "link"
      }, children), /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "604366142",
        dynamic: [theme.palette.primary.light]
      }, ".link.__jsx-style-dynamic-selector{color:".concat(theme.palette.primary.light, ";cursor:text;-webkit-text-decoration:none;text-decoration:none;}")));
    }
  }]);

  return EditorLink;
}(_react["default"].Component);

_defineProperty(EditorLink, "displayName", "EditorLink");

_defineProperty(EditorLink, "propTypes", {
  /**
   * The draft-js ContentState to render with.
   */
  contentState: _propTypes["default"].instanceOf(_draftJs.ContentState).isRequired,

  /**
   * The key to access the entity instance.
   */
  entityKey: _propTypes["default"].string.isRequired,

  /**
   * The content/text to render.
   */
  children: _propTypes["default"].node
});

_defineProperty(EditorLink, "contextType", _ThemeContext["default"]);

var _default = (0, _withClasses["default"])(EditorLink);

exports["default"] = _default;