"use strict";

var _EditorUtils = _interopRequireDefault(require("./EditorUtils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<EditorUtils>", function () {
  describe("fromHtml", function () {
    it("removes tags", function () {
      var result = _EditorUtils["default"].fromHtml("<p>test</p>").getPlainText();

      expect(result).toEqual("test");
    });
    it("decodes html codes", function () {
      var result = _EditorUtils["default"].fromHtml("test &amp; &#39;").getPlainText();

      expect(result).toEqual("test & '");
    });
    it("returns empty string with undefined value", function () {
      var result = _EditorUtils["default"].fromHtml().getPlainText();

      expect(result).toEqual("");
    });
  });
});