"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _Notice = _interopRequireDefault(require("./Notice"));

var _Typography = _interopRequireDefault(require("./Typography"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var isEmpty = function isEmpty(value) {
  return !value || !Object.keys(value).length;
};

var Form = function Form(_ref) {
  var children = _ref.children,
      classes = _ref.classes,
      enter = _ref.enter,
      error = _ref.error,
      errors = _ref.errors,
      errorScroll = _ref.errorScroll,
      other = _objectWithoutProperties(_ref, ["children", "classes", "enter", "error", "errors", "errorScroll"]);

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  var errorRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    if ((error || !isEmpty(errors)) && errorScroll) {
      var padding = theme.spacing(20);
      var rect = errorRef.current.getBoundingClientRect(); // Only scroll if it's not already visible

      if (rect.y - padding < 0 || rect.y - padding > window.innerHeight) {
        window.scrollTo(0, rect.top + window.pageYOffset - padding);
      }
    }
  }, [errorScroll, error, errors]);

  var getLinkedStyles = function getLinkedStyles() {
    return {
      styles: /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "3642758217",
        dynamic: [theme.spacing(5), theme.spacing(3), theme.spacing(2)]
      }, ".errorContainer.__jsx-style-dynamic-selector{margin-bottom:".concat(theme.spacing(5), "px;}.errors.__jsx-style-dynamic-selector{margin:0 ").concat(theme.spacing(3), "px;padding:0;}.errorContainer.__jsx-style-dynamic-selector>div.__jsx-style-dynamic-selector>.error.__jsx-style-dynamic-selector+.errors.__jsx-style-dynamic-selector{margin-top:").concat(theme.spacing(2), "px;}")),
      className: _style["default"].dynamic([["3642758217", [theme.spacing(5), theme.spacing(3), theme.spacing(2)]]])
    };
  };

  var handleKeyPress = function handleKeyPress(e) {
    if (e.key === "Enter" && !enter) {
      e.stopPropagation();
      e.preventDefault();
    }
  };

  var renderErrorsString = function renderErrorsString(values) {
    return values.map(function (e, i) {
      return /*#__PURE__*/_react["default"].createElement("li", {
        key: i
      }, /*#__PURE__*/_react["default"].createElement(_Typography["default"], null, e));
    });
  };

  var renderErrorsNode = function renderErrorsNode(values) {
    return values.map(function (e, i) {
      return /*#__PURE__*/_react["default"].createElement("li", {
        key: i
      }, e);
    });
  };

  var renderErrorsObject = function renderErrorsObject() {
    var renderEntry = function renderEntry(key, message) {
      return /*#__PURE__*/_react["default"].createElement("li", {
        key: key
      }, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
        component: "span"
      }, key, ": ", message));
    };

    var renderObject = function renderObject(obj, key) {
      if (!obj) return [];
      var newError;

      if (Array.isArray(obj)) {
        newError = obj.map(function (e, i) {
          var newKey = key ? "".concat(key, " ").concat(i) : i;
          return renderObject(e, newKey);
        });
      } else if (_typeof(obj) === "object" && ! /*#__PURE__*/_react["default"].isValidElement(obj)) {
        newError = Object.entries(obj).map(function (_ref2) {
          var _ref3 = _slicedToArray(_ref2, 2),
              k = _ref3[0],
              e = _ref3[1];

          var newKey = key ? "".concat(key, " ").concat(k) : k;
          return renderObject(e, newKey);
        });
      } else {
        newError = renderEntry(key, obj);
      }

      return newError;
    };

    return renderObject(errors);
  };

  var renderErrorNode = function renderErrorNode(val) {
    return val;
  };

  var renderErrorString = function renderErrorString(val) {
    return /*#__PURE__*/_react["default"].createElement(_Typography["default"], null, val);
  };

  var linkedStyles = getLinkedStyles();
  var errorRenderer;
  var errorsRenderer;

  if (error) {
    if (typeof error === "string") {
      errorRenderer = renderErrorString;
    } else if ( /*#__PURE__*/_react["default"].isValidElement(error)) {
      errorRenderer = renderErrorNode;
    }
  }

  if (!isEmpty(errors)) {
    if (Array.isArray(errors) && typeof errors[0] === "string") {
      errorsRenderer = renderErrorsString;
    } else if (Array.isArray(errors) && /*#__PURE__*/_react["default"].isValidElement(errors[0])) {
      errorsRenderer = renderErrorsNode;
    } else if (_typeof(errors) === "object") {
      errorsRenderer = renderErrorsObject;
    }
  }

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, (errorRenderer || errorsRenderer) && /*#__PURE__*/_react["default"].createElement("div", {
    ref: errorRef,
    className: "jsx-846642530" + " " + ((0, _clsx["default"])(linkedStyles.className, "errorContainer") || "")
  }, /*#__PURE__*/_react["default"].createElement(_Notice["default"], {
    classes: [linkedStyles.className],
    color: "negative"
  }, errorRenderer && /*#__PURE__*/_react["default"].createElement("span", {
    className: "jsx-846642530" + " " + ((0, _clsx["default"])(linkedStyles.className, "error") || "")
  }, errorRenderer(error)), errorsRenderer && /*#__PURE__*/_react["default"].createElement("ul", {
    className: "jsx-846642530" + " " + ((0, _clsx["default"])(linkedStyles.className, "errors") || "")
  }, errorsRenderer(errors)))), /*#__PURE__*/_react["default"].createElement("form", _extends({
    onKeyPress: handleKeyPress
  }, other, {
    className: "jsx-846642530" + " " + (other && other.className != null && other.className || (0, _clsx["default"])(classes) || "")
  }), children), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "846642530"
  }, "form.jsx-846642530{width:100%;}"), linkedStyles.styles);
};

Form.displayName = "Form";
Form.propTypes = {
  /**
   * The content of the component.
   */
  children: _propTypes["default"].node,

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * Top level form error to display. One of either string or react node.
   */
  error: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node]),

  /**
   * A list of form errors to display. One of an object consisting of key value errors,
   * an array of strings, or an array of react nodes.
   */
  errors: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].string), _propTypes["default"].arrayOf(_propTypes["default"].element), _propTypes["default"].object]),

  /**
   * If `false`, error will not be scrolled to when it is passed to the form.
   */
  errorScroll: _propTypes["default"].bool,

  /**
   * If `false`, pressing enter to submit the form will be disabled.
   */
  enter: _propTypes["default"].bool
};
Form.defaultProps = {
  classes: [],
  enter: true,
  errorScroll: true
};

var _default = (0, _withClasses["default"])(Form);

exports["default"] = _default;