"use strict";

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _react = _interopRequireDefault(require("react"));

var _FormGroup = _interopRequireDefault(require("./FormGroup"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<FormGroup>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], null));
    } catch (theError) {
      error = theError;
    }

    expect(error).toEqual(undefined);
  });
  it("renders correct snapshot", function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], null));
    expect((0, _enzymeToJson["default"])(wrapper)).toMatchSnapshot();
  });
  describe("children prop", function () {
    it("displays given children", function () {
      var child = /*#__PURE__*/_react["default"].createElement("div", null, "child");

      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], null, child));
      expect(wrapper.containsMatchingElement(child)).toBeTruthy();
    });
  });
  describe("classes prop", function () {
    it("sets custom class", function () {
      var classes = ["newClass"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], {
        classes: classes
      }));
      expect(wrapper.find("FormGroup").childAt(0).hasClass(classes[0])).toEqual(true);
    });
    it("appends higher order values to classes prop with withClass decorator", function () {
      var classes = ["riipen", "riipen-formgroup"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], null));
      expect(wrapper.find("FormGroup").props().classes).toEqual(classes.sort());
    });
  });
  describe("title prop", function () {
    it("renders given title", function () {
      var title = "Title";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], {
        title: title
      }));
      expect(wrapper.containsMatchingElement(title)).toBeTruthy();
    });
  });
  describe("subtitle prop", function () {
    it("renders given subtitle", function () {
      var subtitle = "Subtitle";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], {
        subtitle: subtitle
      }));
      expect(wrapper.containsMatchingElement(subtitle)).toBeTruthy();
    });
  });
});