"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SPACINGS = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10];

var Grid = /*#__PURE__*/function (_React$Component) {
  _inherits(Grid, _React$Component);

  var _super = _createSuper(Grid);

  function Grid(props) {
    var _this;

    _classCallCheck(this, Grid);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "componentDidMount", function () {
      // If the user has support for the ResizeObserver use that, if not use the window resize event
      if (typeof ResizeObserver !== "undefined") {
        _this.resizeObserver = new ResizeObserver(_this.onResize);

        if (_this.resizeObserver && _this.resizeRef.current) {
          _this.resizeObserver.observe(_this.resizeRef.current);
        }
      } else {
        window.addEventListener("resize", _this.onResize);
      }

      _this.onResize();
    });

    _defineProperty(_assertThisInitialized(_this), "componentWillUnmount", function () {
      if (_this.resizeObserver) {
        _this.resizeObserver.disconnect();
      } else {
        window.removeEventListener("resize", _this.onResize);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onResize", function () {
      var size = _this.getComponentSize();

      _this.setState({
        size: size
      });

      _this.props.onResize(size);
    });

    _defineProperty(_assertThisInitialized(_this), "getComponentSize", function () {
      var _this$resizeRef$curre;

      var width = ((_this$resizeRef$curre = _this.resizeRef.current) === null || _this$resizeRef$curre === void 0 ? void 0 : _this$resizeRef$curre.clientWidth) || 1080;
      return width >= _this.context.breakpoints.lg && "lg" || width >= _this.context.breakpoints.md && "md" || width >= _this.context.breakpoints.sm && "sm" || "xs";
    });

    _this.state = {
      size: "lg"
    };
    _this.resizeRef = /*#__PURE__*/_react["default"].createRef();
    return _this;
  }

  _createClass(Grid, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          alignItems = _this$props.alignItems,
          children = _this$props.children,
          classes = _this$props.classes,
          justifyContent = _this$props.justifyContent,
          spacing = _this$props.spacing,
          flexDirection = _this$props.flexDirection,
          flexGrow = _this$props.flexGrow,
          flexShrink = _this$props.flexShrink,
          flexWrap = _this$props.flexWrap;
      var size = this.state.size;
      var theme = this.context;
      var className = (0, _clsx["default"])(classes, size);

      var childrenWithProps = _react["default"].Children.map(children, function (child) {
        if (!child) return null;
        return /*#__PURE__*/_react["default"].cloneElement(child, {
          spacing: spacing,
          size: size
        });
      });

      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.resizeRef,
        className: _style["default"].dynamic([["3466573101", [alignItems, flexDirection, flexGrow, flexShrink, flexWrap, justifyContent, theme.spacing(spacing), theme.spacing(spacing)]]]) + " " + (className || "")
      }, childrenWithProps), /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "3466573101",
        dynamic: [alignItems, flexDirection, flexGrow, flexShrink, flexWrap, justifyContent, theme.spacing(spacing), theme.spacing(spacing)]
      }, "div.__jsx-style-dynamic-selector{-webkit-align-items:".concat(alignItems, ";-webkit-box-align:").concat(alignItems, ";-ms-flex-align:").concat(alignItems, ";align-items:").concat(alignItems, ";display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-direction:").concat(flexDirection, ";-ms-flex-direction:").concat(flexDirection, ";flex-direction:").concat(flexDirection, ";-webkit-box-flex:").concat(flexGrow, ";-webkit-flex-grow:").concat(flexGrow, ";-ms-flex-positive:").concat(flexGrow, ";flex-grow:").concat(flexGrow, ";-webkit-flex-shrink:").concat(flexShrink, ";-ms-flex-negative:").concat(flexShrink, ";flex-shrink:").concat(flexShrink, ";-webkit-flex-wrap:").concat(flexWrap, ";-ms-flex-wrap:").concat(flexWrap, ";flex-wrap:").concat(flexWrap, ";-webkit-box-pack:").concat(justifyContent, ";-webkit-justify-content:").concat(justifyContent, ";-ms-flex-pack:").concat(justifyContent, ";justify-content:").concat(justifyContent, ";margin-bottom:-").concat(theme.spacing(spacing), "px;margin-left:-").concat(theme.spacing(spacing), "px;min-height:0;position:relative;}")));
    }
  }]);

  return Grid;
}(_react["default"].Component);

_defineProperty(Grid, "displayName", "Grid");

_defineProperty(Grid, "propTypes", {
  /**
   * A whitelisted set of align items options for the grid.
   */
  alignItems: _propTypes["default"].oneOf(["flex-start", "center", "flex-end", "stretch", "baseline"]),

  /**
   * The content of the grid.
   */
  children: _propTypes["default"].any,

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * The styling to pass into the flex-direction of the grid.
   */
  flexDirection: _propTypes["default"].oneOf(["row", "row-reverse", "column", "column-reverse", "initial", "inherit"]),

  /**
   * Defines if the grid should grow to fill the space available
   */
  flexGrow: _propTypes["default"].number,

  /**
   * Defines if the grid should shrink to allow more space available
   */
  flexShrink: _propTypes["default"].number,

  /**
   * The styling to pass into the flex-wrap of the grid.
   */
  flexWrap: _propTypes["default"].oneOf(["nowrap", "wrap", "wrap-reverse", "inherit", "initial", "unset"]),

  /**
   * A whitelisted set of justify content options for the grid.
   */
  justifyContent: _propTypes["default"].oneOf(["flex-start", "center", "flex-end", "space-between", "space-around", "space-evenly"]),

  /**
   * Defines the space between grid items in the grid.
   */
  spacing: _propTypes["default"].oneOf(SPACINGS),

  /**
   * The function to callback to when the grid changes sizes
   * The callback includes the current size of the grid.
   */
  onResize: _propTypes["default"].func
});

_defineProperty(Grid, "defaultProps", {
  alignItems: "flex-start",
  classes: [],
  justifyContent: "flex-start",
  spacing: 3,
  flexGrow: 1,
  flexShrink: 1,
  flexDirection: "row",
  flexWrap: "wrap",
  onResize: function onResize() {}
});

_defineProperty(Grid, "contextType", _ThemeContext["default"]);

var _default = (0, _withClasses["default"])(Grid);

exports["default"] = _default;