"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var COLUMNS = 24;
var SPACINGS = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10];

var GridItem = /*#__PURE__*/function (_React$Component) {
  _inherits(GridItem, _React$Component);

  var _super = _createSuper(GridItem);

  function GridItem() {
    _classCallCheck(this, GridItem);

    return _super.apply(this, arguments);
  }

  _createClass(GridItem, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          alignItems = _this$props.alignItems,
          children = _this$props.children,
          classes = _this$props.classes,
          spacing = _this$props.spacing,
          flexGrow = _this$props.flexGrow,
          flexShrink = _this$props.flexShrink,
          flexWrap = _this$props.flexWrap,
          flexDirection = _this$props.flexDirection,
          justifyContent = _this$props.justifyContent,
          size = _this$props.size;
      var theme = this.context;
      var _this$props2 = this.props,
          lg = _this$props2.lg,
          md = _this$props2.md,
          sm = _this$props2.sm,
          xs = _this$props2.xs; // determine size of component

      var itemColumns = size === "md" && (md || lg) || size === "sm" && (sm || md || lg) || size === "xs" && (xs || sm || md || lg) || lg; // add class to component based on size it is rendering

      var itemSize = itemColumns === lg && "lg" || itemColumns === md && "md" || itemColumns === sm && "sm" || itemColumns === xs && "xs";
      var hidden = false;
      var flexBasis = 0;

      if (itemColumns === "hidden") {
        hidden = true;
      } else if (itemColumns === "auto") {
        flexBasis = itemColumns;
      } else {
        flexBasis = "".concat(itemColumns / COLUMNS * 100, "%");
      }

      var className = (0, _clsx["default"])(classes, itemSize);
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        className: _style["default"].dynamic([["1025619962", [alignItems, hidden ? "none" : "flex", flexBasis, flexDirection, flexGrow, flexShrink, flexWrap, justifyContent, theme.spacing(spacing), theme.spacing(spacing)]]]) + " " + (className || "")
      }, children), /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "1025619962",
        dynamic: [alignItems, hidden ? "none" : "flex", flexBasis, flexDirection, flexGrow, flexShrink, flexWrap, justifyContent, theme.spacing(spacing), theme.spacing(spacing)]
      }, "div.__jsx-style-dynamic-selector{-webkit-align-items:".concat(alignItems, ";-webkit-box-align:").concat(alignItems, ";-ms-flex-align:").concat(alignItems, ";align-items:").concat(alignItems, ";box-sizing:border-box;display:").concat(hidden ? "none" : "flex", ";-webkit-flex-basis:").concat(flexBasis, ";-ms-flex-preferred-size:").concat(flexBasis, ";flex-basis:").concat(flexBasis, ";-webkit-flex-direction:").concat(flexDirection, ";-ms-flex-direction:").concat(flexDirection, ";flex-direction:").concat(flexDirection, ";-webkit-box-flex:").concat(flexGrow, ";-webkit-flex-grow:").concat(flexGrow, ";-ms-flex-positive:").concat(flexGrow, ";flex-grow:").concat(flexGrow, ";-webkit-flex-shrink:").concat(flexShrink, ";-ms-flex-negative:").concat(flexShrink, ";flex-shrink:").concat(flexShrink, ";-webkit-flex-wrap:").concat(flexWrap, ";-ms-flex-wrap:").concat(flexWrap, ";flex-wrap:").concat(flexWrap, ";-webkit-box-pack:").concat(justifyContent, ";-webkit-justify-content:").concat(justifyContent, ";-ms-flex-pack:").concat(justifyContent, ";justify-content:").concat(justifyContent, ";margin-bottom:").concat(theme.spacing(spacing), "px;padding-left:").concat(theme.spacing(spacing), "px;}")));
    }
  }]);

  return GridItem;
}(_react["default"].Component);

_defineProperty(GridItem, "displayName", "GridItem");

_defineProperty(GridItem, "propTypes", {
  /**
   * A whitelisted set of align items options for the grid item.
   */
  alignItems: _propTypes["default"].oneOf(["flex-start", "center", "flex-end", "stretch", "baseline"]),

  /**
   * The content of the grid item.
   */
  children: _propTypes["default"].any,

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * The styling to pass into the flex-direction of the grid.
   */
  flexDirection: _propTypes["default"].oneOf(["column", "column-reverse", "initial", "inherit", "row", "row-reverse"]),

  /**
   * Defines if the grid item should grow to fill extra space in the row
   */
  flexGrow: _propTypes["default"].number,

  /**
   * Defines if the grid item should shrink to allow more space in the row
   */
  flexShrink: _propTypes["default"].number,

  /**
   * The styling to pass into the flex-wrap of the grid item.
   */
  flexWrap: _propTypes["default"].oneOf(["inherit", "initial", "nowrap", "unset", "wrap", "wrap-reverse"]),

  /**
   * A whitelisted set of justify content options for the grid item.
   */
  justifyContent: _propTypes["default"].oneOf(["center", "flex-end", "flex-start", "space-around", "space-between", "space-evenly"]),

  /**
   * The columns use at the large resolution. Can also be 'hidden'. Can also be 'hidden' or 'auto'.
   */
  lg: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].oneOf(["auto", "hidden"])]),

  /**
   * The columns use at the medium resolution. Can also be 'hidden'. Can also be 'hidden' or 'auto'.
   */
  md: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].oneOf(["auto", "hidden"])]),

  /**
   * The columns use at the small resolution. Can also be 'hidden'. Can also be 'hidden' or 'auto'.
   */
  sm: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].oneOf(["auto", "hidden"])]),

  /**
   * Defines the space between this grid item and other items.
   */
  spacing: _propTypes["default"].oneOf(SPACINGS),

  /**
   * The size of the component to render.
   * Passed in by the Grid.
   */
  size: _propTypes["default"].oneOf(["xs", "sm", "md", "lg"]),

  /**
   * The columns use at the extra small resolution. Can also be 'hidden' or 'auto'.
   */
  xs: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].oneOf(["auto", "hidden"])])
});

_defineProperty(GridItem, "defaultProps", {
  alignItems: "stretch",
  classes: [],
  lg: 24,
  spacing: 3,
  flexGrow: 0,
  flexShrink: 0,
  flexDirection: "column",
  flexWrap: "wrap",
  justifyContent: "flex-start",
  size: "lg"
});

_defineProperty(GridItem, "contextType", _ThemeContext["default"]);

var _default = (0, _withClasses["default"])(GridItem);

exports["default"] = _default;