"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Hidden = /*#__PURE__*/function (_React$Component) {
  _inherits(Hidden, _React$Component);

  var _super = _createSuper(Hidden);

  function Hidden() {
    _classCallCheck(this, Hidden);

    return _super.apply(this, arguments);
  }

  _createClass(Hidden, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          direction = _this$props.direction,
          size = _this$props.size;
      var theme = this.context;
      var className = (0, _clsx["default"])("".concat(size, "-").concat(direction));
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        className: _style["default"].dynamic([["1718998684", [theme.breakpoints.xs, theme.breakpoints.xs, theme.breakpoints.sm, theme.breakpoints.sm, theme.breakpoints.md, theme.breakpoints.md, theme.breakpoints.lg, theme.breakpoints.lg, theme.breakpoints.xl, theme.breakpoints.xl]]]) + " " + (className || "")
      }, children), /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "1718998684",
        dynamic: [theme.breakpoints.xs, theme.breakpoints.xs, theme.breakpoints.sm, theme.breakpoints.sm, theme.breakpoints.md, theme.breakpoints.md, theme.breakpoints.lg, theme.breakpoints.lg, theme.breakpoints.xl, theme.breakpoints.xl]
      }, "@media (min-width:".concat(theme.breakpoints.xs, "px){.xs-up.__jsx-style-dynamic-selector{display:none;}}@media (max-width:").concat(theme.breakpoints.xs, "px){.xs-down.__jsx-style-dynamic-selector{display:none;}}@media (min-width:").concat(theme.breakpoints.sm, "px){.sm-up.__jsx-style-dynamic-selector{display:none;}}@media (max-width:").concat(theme.breakpoints.sm, "px){.sm-down.__jsx-style-dynamic-selector{display:none;}}@media (min-width:").concat(theme.breakpoints.md, "px){.md-up.__jsx-style-dynamic-selector{display:none;}}@media (max-width:").concat(theme.breakpoints.md, "px){.md-down.__jsx-style-dynamic-selector{display:none;}}@media (min-width:").concat(theme.breakpoints.lg, "px){.lg-up.__jsx-style-dynamic-selector{display:none;}}@media (max-width:").concat(theme.breakpoints.lg, "px){.lg-down.__jsx-style-dynamic-selector{display:none;}}@media (min-width:").concat(theme.breakpoints.xl, "px){.xl-up.__jsx-style-dynamic-selector{display:none;}}@media (max-width:").concat(theme.breakpoints.xl, "px){.xl-down.__jsx-style-dynamic-selector{display:none;}}")));
    }
  }]);

  return Hidden;
}(_react["default"].Component);

_defineProperty(Hidden, "displayName", "Hidden");

_defineProperty(Hidden, "propTypes", {
  /**
   * The content of the component.
   */
  children: _propTypes["default"].node,

  /**
   * Given some size, will hide content at size larger than min (up) or smaller than max (down).
   */
  direction: _propTypes["default"].oneOf(["down", "up"]),

  /**
   * The size at which to hide content in tandum with a direction.
   */
  size: _propTypes["default"].oneOf(["xs", "sm", "md", "lg", "xl"]).isRequired
});

_defineProperty(Hidden, "defaultProps", {
  direction: "down"
});

_defineProperty(Hidden, "contextType", _ThemeContext["default"]);

var _default = (0, _withClasses["default"])(Hidden);

exports["default"] = _default;