"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _utils = require("../utils");

var _InputLabel = _interopRequireDefault(require("./InputLabel"));

var _Typography = _interopRequireDefault(require("./Typography"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Input = function Input(_ref) {
  var classes = _ref.classes,
      disabled = _ref.disabled,
      endAdornment = _ref.endAdornment,
      error = _ref.error,
      hint = _ref.hint,
      label = _ref.label,
      labelProps = _ref.labelProps,
      meta = _ref.meta,
      multiline = _ref.multiline,
      onBlur = _ref.onBlur,
      onFocus = _ref.onFocus,
      required = _ref.required,
      size = _ref.size,
      startAdornment = _ref.startAdornment,
      theme = _ref.theme,
      variant = _ref.variant,
      warning = _ref.warning,
      other = _objectWithoutProperties(_ref, ["classes", "disabled", "endAdornment", "error", "hint", "label", "labelProps", "meta", "multiline", "onBlur", "onFocus", "required", "size", "startAdornment", "theme", "variant", "warning"]);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      focusVisible = _useState2[0],
      setFocusVisible = _useState2[1];

  var _useIsFocusVisible = (0, _utils.useIsFocusVisible)(),
      ref = _useIsFocusVisible.ref,
      isFocusVisible = _useIsFocusVisible.isFocusVisible,
      onBlurVisible = _useIsFocusVisible.onBlurVisible;

  var handleFocus = function handleFocus(e) {
    if (onFocus) onFocus(e);
    setFocusVisible(isFocusVisible(e));
  };

  var handleBlur = function handleBlur(e) {
    if (onBlur) onBlur(e);
    setFocusVisible(false);
    onBlurVisible();
  };

  var className = (0, _clsx["default"])(classes, "wrapper");
  var Component = "input";

  if (multiline) {
    Component = "textarea";
  }

  var componentClassName = (0, _clsx["default"])(endAdornment ? "endPadding" : null, error ? "error" : null, disabled ? "disabled" : null, startAdornment ? "startPadding" : null, warning ? "warning" : null, focusVisible ? "focusVisible" : null, variant, size);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _style["default"].dynamic([["3742724510", [theme.typography.h4.fontSize, theme.typography.h5.fontSize, theme.typography.body2.fontSize, theme.palette.common.white, theme.shape.borderRadius.md, theme.typography.h2.fontSize, theme.spacing(2), theme.spacing(1), theme.spacing(1), theme.palette.negative.main, theme.palette.text.primary, theme.typography.fontFamily, theme.typography.body1.fontSize, theme.typography.body1.lineHeight, theme.spacing(2), theme.transitions.duration.standard, theme.palette.tertiary.main, theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.palette.warning.main, theme.breakpoints.sm, theme.typography.body1.mobile.fontSize, theme.typography.body1.mobile.lineHeight]]]) + " " + (className || "")
  }, (label || hint) && /*#__PURE__*/_react["default"].createElement(_InputLabel["default"], _extends({
    hint: hint,
    htmlFor: other.id || other.name,
    required: required
  }, labelProps), label), /*#__PURE__*/_react["default"].createElement(Component, _extends({
    ref: ref,
    onFocus: handleFocus,
    onBlur: handleBlur,
    disabled: disabled,
    "aria-disabled": disabled
  }, other, {
    className: _style["default"].dynamic([["3742724510", [theme.typography.h4.fontSize, theme.typography.h5.fontSize, theme.typography.body2.fontSize, theme.palette.common.white, theme.shape.borderRadius.md, theme.typography.h2.fontSize, theme.spacing(2), theme.spacing(1), theme.spacing(1), theme.palette.negative.main, theme.palette.text.primary, theme.typography.fontFamily, theme.typography.body1.fontSize, theme.typography.body1.lineHeight, theme.spacing(2), theme.transitions.duration.standard, theme.palette.tertiary.main, theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.palette.warning.main, theme.breakpoints.sm, theme.typography.body1.mobile.fontSize, theme.typography.body1.mobile.lineHeight]]]) + " " + (other && other.className != null && other.className || componentClassName || "")
  })), startAdornment && /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["3742724510", [theme.typography.h4.fontSize, theme.typography.h5.fontSize, theme.typography.body2.fontSize, theme.palette.common.white, theme.shape.borderRadius.md, theme.typography.h2.fontSize, theme.spacing(2), theme.spacing(1), theme.spacing(1), theme.palette.negative.main, theme.palette.text.primary, theme.typography.fontFamily, theme.typography.body1.fontSize, theme.typography.body1.lineHeight, theme.spacing(2), theme.transitions.duration.standard, theme.palette.tertiary.main, theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.palette.warning.main, theme.breakpoints.sm, theme.typography.body1.mobile.fontSize, theme.typography.body1.mobile.lineHeight]]]) + " " + ((0, _clsx["default"])("adornment", "start", size) || "")
  }, startAdornment), endAdornment && /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["3742724510", [theme.typography.h4.fontSize, theme.typography.h5.fontSize, theme.typography.body2.fontSize, theme.palette.common.white, theme.shape.borderRadius.md, theme.typography.h2.fontSize, theme.spacing(2), theme.spacing(1), theme.spacing(1), theme.palette.negative.main, theme.palette.text.primary, theme.typography.fontFamily, theme.typography.body1.fontSize, theme.typography.body1.lineHeight, theme.spacing(2), theme.transitions.duration.standard, theme.palette.tertiary.main, theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.palette.warning.main, theme.breakpoints.sm, theme.typography.body1.mobile.fontSize, theme.typography.body1.mobile.lineHeight]]]) + " " + ((0, _clsx["default"])("adornment", "end", size) || "")
  }, endAdornment), (error || warning || meta) && /*#__PURE__*/_react["default"].createElement("div", {
    className: _style["default"].dynamic([["3742724510", [theme.typography.h4.fontSize, theme.typography.h5.fontSize, theme.typography.body2.fontSize, theme.palette.common.white, theme.shape.borderRadius.md, theme.typography.h2.fontSize, theme.spacing(2), theme.spacing(1), theme.spacing(1), theme.palette.negative.main, theme.palette.text.primary, theme.typography.fontFamily, theme.typography.body1.fontSize, theme.typography.body1.lineHeight, theme.spacing(2), theme.transitions.duration.standard, theme.palette.tertiary.main, theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.palette.warning.main, theme.breakpoints.sm, theme.typography.body1.mobile.fontSize, theme.typography.body1.mobile.lineHeight]]]) + " " + "bottom"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _style["default"].dynamic([["3742724510", [theme.typography.h4.fontSize, theme.typography.h5.fontSize, theme.typography.body2.fontSize, theme.palette.common.white, theme.shape.borderRadius.md, theme.typography.h2.fontSize, theme.spacing(2), theme.spacing(1), theme.spacing(1), theme.palette.negative.main, theme.palette.text.primary, theme.typography.fontFamily, theme.typography.body1.fontSize, theme.typography.body1.lineHeight, theme.spacing(2), theme.transitions.duration.standard, theme.palette.tertiary.main, theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.palette.warning.main, theme.breakpoints.sm, theme.typography.body1.mobile.fontSize, theme.typography.body1.mobile.lineHeight]]])
  }, error && /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    color: "negative",
    component: "div",
    variant: "body2"
  }, error), warning && /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    color: "secondary",
    component: "div",
    variant: "body2"
  }, warning)), meta && /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    color: "grey600",
    component: "span",
    variant: "body2"
  }, meta)), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "3742724510",
    dynamic: [theme.typography.h4.fontSize, theme.typography.h5.fontSize, theme.typography.body2.fontSize, theme.palette.common.white, theme.shape.borderRadius.md, theme.typography.h2.fontSize, theme.spacing(2), theme.spacing(1), theme.spacing(1), theme.palette.negative.main, theme.palette.text.primary, theme.typography.fontFamily, theme.typography.body1.fontSize, theme.typography.body1.lineHeight, theme.spacing(2), theme.transitions.duration.standard, theme.palette.tertiary.main, theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.spacing(2), theme.spacing(9), theme.spacing(11), theme.palette.warning.main, theme.breakpoints.sm, theme.typography.body1.mobile.fontSize, theme.typography.body1.mobile.lineHeight]
  }, ".bottom.__jsx-style-dynamic-selector{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-box-pack:justify;-webkit-justify-content:space-between;-ms-flex-pack:justify;justify-content:space-between;}.adornment.__jsx-style-dynamic-selector{position:absolute;}.adornment.large.__jsx-style-dynamic-selector{font-size:".concat(theme.typography.h4.fontSize, ";padding:17px;}.adornment.medium.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.h5.fontSize, ";}.adornment.small.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.body2.fontSize, ";padding:7px;}.default.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.common.white, ";border:1px solid rgba(0,0,0,0.23);border-radius:").concat(theme.shape.borderRadius.md, ";}.disabled.__jsx-style-dynamic-selector{opacity:0.5;pointer-events:none;}.large.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.h2.fontSize, ";}.medium.__jsx-style-dynamic-selector{padding:").concat(theme.spacing(2), "px;}.small.__jsx-style-dynamic-selector{padding-bottom:").concat(theme.spacing(1), "px;padding-top:").concat(theme.spacing(1), "px;}.error.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.negative.main, ";}input.__jsx-style-dynamic-selector,textarea.__jsx-style-dynamic-selector{box-sizing:border-box;color:").concat(theme.palette.text.primary, ";font-family:").concat(theme.typography.fontFamily, ";font-size:").concat(theme.typography.body1.fontSize, ";line-height:").concat(theme.typography.body1.lineHeight, ";outline:none;padding:").concat(theme.spacing(2), "px;position:relative;-webkit-transition:all ").concat(theme.transitions.duration.standard, "ms;transition:all ").concat(theme.transitions.duration.standard, "ms;width:100%;}input.__jsx-style-dynamic-selector:focus,textarea.__jsx-style-dynamic-selector:focus{outline:0;}input.focusVisible.__jsx-style-dynamic-selector,textarea.focusVisible.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.tertiary.main, ";outline:5px auto -webkit-focus-ring-color;}.end.__jsx-style-dynamic-selector{margin-right:").concat(theme.spacing(2), "px;right:0;}.end.large.__jsx-style-dynamic-selector{margin-right:0;}.endPadding.__jsx-style-dynamic-selector{padding-right:").concat(theme.spacing(9), "px;}.endPadding.large.__jsx-style-dynamic-selector{padding-right:").concat(theme.spacing(11), "px;}.start.__jsx-style-dynamic-selector{left:0;margin-left:").concat(theme.spacing(2), "px;}.start.large.__jsx-style-dynamic-selector{margin-left:0;}.startPadding.__jsx-style-dynamic-selector{padding-left:").concat(theme.spacing(9), "px;}.startPadding.large.__jsx-style-dynamic-selector{padding-left:").concat(theme.spacing(11), "px;}.underlined.__jsx-style-dynamic-selector{background-color:transparent;border:none;border-bottom:1px solid rgba(0,0,0,0.23);}.warning.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.warning.main, ";}.wrapper.__jsx-style-dynamic-selector{position:relative;}@media (max-width:").concat(theme.breakpoints.sm, "px){input.__jsx-style-dynamic-selector,textarea.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.body1.mobile.fontSize, ";line-height:").concat(theme.typography.body1.mobile.lineHeight, ";}}")));
};

Input.defaultProps = {
  disabled: false,
  multiline: false,
  size: "medium",
  variant: "default"
};
Input.propTypes = {
  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * If true, disables the input.
   */
  disabled: _propTypes["default"].bool,

  /**
   * Content to render on the right side of the input.
   */
  endAdornment: _propTypes["default"].node,

  /**
   * An error to display below the input.
   */
  error: _propTypes["default"].node,

  /**
   * Hint text to display under the label of the input.
   */
  hint: _propTypes["default"].string,

  /**
   * Label text to display for the input.
   */
  label: _propTypes["default"].node,

  /**
   * Props passed through to the InputLabel.
   */
  labelProps: _propTypes["default"].object,

  /**
   * Any text to display under the right side of the input.
   */
  meta: _propTypes["default"].node,

  /**
   * If `true`, a textarea element will be rendered.
   */
  multiline: _propTypes["default"].bool,

  /**
   * Function to execute when input is out of focus.
   */
  onBlur: _propTypes["default"].func,

  /**
   * Function to execute when input is in focus.
   */
  onFocus: _propTypes["default"].func,

  /**
   * If true, an asterisk will be appended to the end of the label.
   */
  required: _propTypes["default"].bool,

  /**
   * A whitelisted set of sizes that the input can be rendered at.
   */
  size: _propTypes["default"].oneOf(["large", "medium", "small"]),

  /**
   * Content to render on the left side of the input.
   */
  startAdornment: _propTypes["default"].node,

  /**
   * @ignore
   * The theme context object
   */
  theme: _propTypes["default"].object,

  /**
   * The input variant styling to apply.
   */
  variant: _propTypes["default"].oneOf(["default", "underlined"]),

  /**
   * A warning to display below the input.
   */
  warning: _propTypes["default"].node
};
Input.displayName = "Input";

var _default = (0, _utils.withThemeContext)(Input);

exports["default"] = _default;