"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _withThemeContext = _interopRequireDefault(require("../utils/withThemeContext"));

var _Typography = _interopRequireDefault(require("./Typography"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var InputHint = function InputHint(_ref) {
  var children = _ref.children,
      classes = _ref.classes,
      color = _ref.color,
      theme = _ref.theme;
  var className = (0, _clsx["default"])(classes);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: _style["default"].dynamic([["3631052581", [theme.palette.text.secondary, theme.spacing(2)]]]) + " " + (className || "")
  }, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    variant: "body2",
    color: color
  }, children)), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "3631052581",
    dynamic: [theme.palette.text.secondary, theme.spacing(2)]
  }, "div.__jsx-style-dynamic-selector{color:".concat(theme.palette.text.secondary, ";margin-bottom:").concat(theme.spacing(2), "px;}")));
};

InputHint.displayName = "InputHint";
InputHint.propTypes = {
  /**
   * The content of the component.
   */
  children: _propTypes["default"].node,

  /**
   * Color of the hint text. Passed through to Typography
   */
  color: _propTypes["default"].string,

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * @ignore
   * The theme context object
   */
  theme: _propTypes["default"].object
};
InputHint.defaultProps = {
  classes: [],
  color: "inherit"
};

var _default = (0, _withThemeContext["default"])((0, _withClasses["default"])(InputHint));

exports["default"] = _default;