"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _withThemeContext = _interopRequireDefault(require("../utils/withThemeContext"));

var _InputHint = _interopRequireDefault(require("./InputHint"));

var _Typography = _interopRequireDefault(require("./Typography"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var InputLabel = function InputLabel(_ref) {
  var children = _ref.children,
      color = _ref.color,
      classes = _ref.classes,
      fontWeight = _ref.fontWeight,
      hint = _ref.hint,
      required = _ref.required,
      theme = _ref.theme,
      suffix = _ref.suffix,
      variant = _ref.variant,
      other = _objectWithoutProperties(_ref, ["children", "color", "classes", "fontWeight", "hint", "required", "theme", "suffix", "variant"]);

  var className = (0, _clsx["default"])(classes);
  var marginBottom = hint ? 1 : 3;
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, children && /*#__PURE__*/_react["default"].createElement("label", _extends({}, other, {
    className: _style["default"].dynamic([["3813465581", [theme.spacing(marginBottom), theme.spacing(1)]]]) + " " + (other && other.className != null && other.className || className || "")
  }), /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    component: "span",
    color: color,
    fontWeight: fontWeight,
    variant: variant
  }, children, required && " *", /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["3813465581", [theme.spacing(marginBottom), theme.spacing(1)]]]) + " " + "suffix"
  }, suffix))), hint && /*#__PURE__*/_react["default"].createElement(_InputHint["default"], {
    color: color
  }, hint), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "3813465581",
    dynamic: [theme.spacing(marginBottom), theme.spacing(1)]
  }, "label.__jsx-style-dynamic-selector{display:inline-block;margin-bottom:".concat(theme.spacing(marginBottom), "px;}.suffix.__jsx-style-dynamic-selector{margin-left:").concat(theme.spacing(1), "px;}")));
};

InputLabel.displayName = "InputLabel";
InputLabel.propTypes = {
  /**
   * The content of the component.
   */
  children: _propTypes["default"].node,

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * Color of the label text. Passed through to Typopgraphy.
   */
  color: _propTypes["default"].string,

  /**
   * Font weight for the label text. Passed through to Typopgraphy.
   */
  fontWeight: _propTypes["default"].string,

  /**
   * Hint text to display under the label.
   */
  hint: _propTypes["default"].node,

  /**
   * If true, an asterisk will be appended to the end of the label.
   */
  required: _propTypes["default"].bool,

  /**
   * @ignore
   * The theme context object.
   */
  theme: _propTypes["default"].object,

  /**
   * Any suffix to display beside the label.
   */
  suffix: _propTypes["default"].node,

  /**
   * Variant for the label text. Passed through to Typopgraphy.
   */
  variant: _propTypes["default"].string
};
InputLabel.defaultProps = {
  classes: [],
  color: "greyA400",
  fontWeight: "medium",
  required: false,
  variant: "h5"
};

var _default = (0, _withThemeContext["default"])((0, _withClasses["default"])(InputLabel));

exports["default"] = _default;