"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _utils = require("../utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Link = function Link(props) {
  var children = props.children,
      classes = props.classes,
      color = props.color,
      Component = props.component,
      theme = props.theme,
      underline = props.underline,
      other = _objectWithoutProperties(props, ["children", "classes", "color", "component", "theme", "underline"]);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      focusVisible = _useState2[0],
      setFocusVisible = _useState2[1];

  var _useIsFocusVisible = (0, _utils.useIsFocusVisible)(),
      ref = _useIsFocusVisible.ref,
      isFocusVisible = _useIsFocusVisible.isFocusVisible,
      onBlurVisible = _useIsFocusVisible.onBlurVisible;

  var handleFocus = function handleFocus(e) {
    setFocusVisible(isFocusVisible(e));
  };

  var handleBlur = function handleBlur() {
    setFocusVisible(false);
    onBlurVisible();
  };

  var className = (0, _clsx["default"])(color, focusVisible ? "focusVisible" : null, classes);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(Component, _extends({
    ref: ref,
    onFocus: handleFocus,
    onBlur: handleBlur
  }, other, {
    className: _style["default"].dynamic([["4052177955", [theme.typography.fontFamily, underline === "always" ? "underline" : "none", theme.transitions.standard, underline === "hover" ? "underline" : "none", theme.palette.primary.main, theme.palette.primary.dark, theme.palette.secondary.main, theme.palette.secondary.dark, theme.palette.tertiary.main, theme.palette.tertiary.dark, theme.palette.positive.main, theme.palette.positive.dark, theme.palette.negative.main, theme.palette.negative.dark, theme.palette.common.white, theme.palette.grey[200]]]]) + " " + (other && other.className != null && other.className || className || "")
  }), children), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "4052177955",
    dynamic: [theme.typography.fontFamily, underline === "always" ? "underline" : "none", theme.transitions.standard, underline === "hover" ? "underline" : "none", theme.palette.primary.main, theme.palette.primary.dark, theme.palette.secondary.main, theme.palette.secondary.dark, theme.palette.tertiary.main, theme.palette.tertiary.dark, theme.palette.positive.main, theme.palette.positive.dark, theme.palette.negative.main, theme.palette.negative.dark, theme.palette.common.white, theme.palette.grey[200]]
  }, "a.__jsx-style-dynamic-selector{cursor:pointer;font-family:".concat(theme.typography.fontFamily, ";-webkit-text-decoration:").concat(underline === "always" ? "underline" : "none", ";text-decoration:").concat(underline === "always" ? "underline" : "none", ";-webkit-transition:").concat(theme.transitions.standard, " all;transition:").concat(theme.transitions.standard, " all;}a.__jsx-style-dynamic-selector:focus{outline:0;}a.focusVisible.__jsx-style-dynamic-selector{outline:5px auto -webkit-focus-ring-color;}a.__jsx-style-dynamic-selector:hover{-webkit-text-decoration:").concat(underline === "hover" ? "underline" : "none", ";text-decoration:").concat(underline === "hover" ? "underline" : "none", ";}.inherit.__jsx-style-dynamic-selector{color:inherit;}.primary.__jsx-style-dynamic-selector{color:").concat(theme.palette.primary.main, ";}.primary.__jsx-style-dynamic-selector:active,.primary.focusVisible.__jsx-style-dynamic-selector,.primary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.primary.dark, ";}.secondary.__jsx-style-dynamic-selector{color:").concat(theme.palette.secondary.main, ";}.secondary.__jsx-style-dynamic-selector:active,.secondary.focusVisible.__jsx-style-dynamic-selector,.secondary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.secondary.dark, ";}.tertiary.__jsx-style-dynamic-selector{color:").concat(theme.palette.tertiary.main, ";}.tertiary.__jsx-style-dynamic-selector:active,.tertiary.focusVisible.__jsx-style-dynamic-selector,.tertiary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.tertiary.dark, ";}.positive.__jsx-style-dynamic-selector{color:").concat(theme.palette.positive.main, ";}.positive.__jsx-style-dynamic-selector:active,.positive.focusVisible.__jsx-style-dynamic-selector,.positive.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.positive.dark, ";}.negative.__jsx-style-dynamic-selector{color:").concat(theme.palette.negative.main, ";}.negative.__jsx-style-dynamic-selector:active,.negative.focusVisible.__jsx-style-dynamic-selector,.negative.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.negative.dark, ";}.white.__jsx-style-dynamic-selector{color:").concat(theme.palette.common.white, ";}.white.__jsx-style-dynamic-selector:active,.white.focusVisible.__jsx-style-dynamic-selector,.white.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.grey[200], ";}")));
};

Link.propTypes = {
  /**
   * The content of the link.
   *
   */
  children: _propTypes["default"].any.isRequired,

  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].array,

  /**
   * The color of the link.
   */
  color: _propTypes["default"].oneOf(["inherit", "negative", "positive", "primary", "secondary", "tertiary", "white"]),

  /**
   * The component used for the root node.
   * Either a string to use a DOM element or a component.
   */
  component: _propTypes["default"].elementType,

  /**
   * Controls when the link should have an underline.
   */
  underline: _propTypes["default"].oneOf(["none", "hover", "always"]),

  /**
   * @ignore
   * The theme context object
   */
  theme: _propTypes["default"].object
};
Link.defaultProps = {
  classes: [],
  color: "primary",
  component: "a",
  underline: "none"
};
Link.displayName = "Link";

var _default = (0, _utils.withThemeContext)(Link);

exports["default"] = _default;