"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _utils = require("../utils");

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ListItem = function ListItem(props) {
  var children = props.children,
      classes = props.classes,
      spacing = props.spacing,
      theme = props.theme,
      variant = props.variant,
      other = _objectWithoutProperties(props, ["children", "classes", "spacing", "theme", "variant"]);

  var className = (0, _clsx["default"])("list-item", variant, classes);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("li", _extends({}, other, {
    className: _style["default"].dynamic([["4198676004", [theme.spacing(spacing), theme.spacing(spacing)]]]) + " " + (other && other.className != null && other.className || className || "")
  }), children), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "4198676004",
    dynamic: [theme.spacing(spacing), theme.spacing(spacing)]
  }, ".list-item.__jsx-style-dynamic-selector{list-style-type:none;margin:0;}.horizontal.__jsx-style-dynamic-selector{display:inline-block;margin-right:".concat(theme.spacing(spacing), "px;}.horizontal.__jsx-style-dynamic-selector:last-child{margin-right:0;}.vertical.__jsx-style-dynamic-selector{display:block;margin-bottom:").concat(theme.spacing(spacing), "px;}.vertical.__jsx-style-dynamic-selector:last-child{margin-bottom:0;}")));
};

ListItem.propTypes = {
  /**
   * The content of the list item.
   */
  children: _propTypes["default"].any,

  /**
   * Array of additional CSS classes to use.
   */
  classes: _propTypes["default"].array,

  /**
   * Additional spacing based in theme spacing multiplier to apply after list item.
   */
  spacing: _propTypes["default"].number,

  /**
   * @ignore
   * The theme context object
   */
  theme: _propTypes["default"].object,

  /**
   * The orientation variant to display the list item as.
   */
  variant: _propTypes["default"].oneOf(["horizontal", "vertical"])
};
ListItem.defaultProps = {
  classes: [],
  spacing: 2,
  variant: "vertical"
};
ListItem.displayName = "ListItem";

var _default = (0, _utils.withThemeContext)((0, _withClasses["default"])(ListItem));

exports["default"] = _default;