"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _MenuList = _interopRequireDefault(require("./MenuList"));

var _Popover = _interopRequireDefault(require("./Popover"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Menu = /*#__PURE__*/function (_React$Component) {
  _inherits(Menu, _React$Component);

  var _super = _createSuper(Menu);

  function Menu() {
    var _this;

    _classCallCheck(this, Menu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "handleAfterSelect", function (idx, event) {
      var _this$props = _this.props,
          closeOnSelect = _this$props.closeOnSelect,
          onClose = _this$props.onClose;
      if (onClose && closeOnSelect) onClose(idx, event);
    });

    return _this;
  }

  _createClass(Menu, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(oldProps) {
      var _this$props2 = this.props,
          anchorEl = _this$props2.anchorEl,
          isOpen = _this$props2.isOpen;
      var menuDidOpen = oldProps.anchorEl == null && anchorEl || !oldProps.isOpen && isOpen;

      if (menuDidOpen && document.activeElement) {
        document.activeElement.blur();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          anchorEl = _this$props3.anchorEl,
          anchorPosition = _this$props3.anchorPosition,
          children = _this$props3.children,
          contentPosition = _this$props3.contentPosition,
          fullWidth = _this$props3.fullWidth,
          keepOnScreen = _this$props3.keepOnScreen,
          isOpen = _this$props3.isOpen,
          onClose = _this$props3.onClose,
          popoverStyles = _this$props3.popoverStyles,
          marginThreshold = _this$props3.marginThreshold,
          other = _objectWithoutProperties(_this$props3, ["anchorEl", "anchorPosition", "children", "contentPosition", "fullWidth", "keepOnScreen", "isOpen", "onClose", "popoverStyles", "marginThreshold"]);

      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Popover["default"], {
        anchorEl: anchorEl,
        anchorPosition: anchorPosition,
        contentPosition: contentPosition,
        fullWidth: fullWidth,
        isOpen: isOpen,
        keepOnScreen: keepOnScreen,
        lockScroll: false,
        marginThreshold: marginThreshold,
        onClose: onClose,
        styles: popoverStyles
      }, /*#__PURE__*/_react["default"].createElement(_MenuList["default"], _extends({}, other, {
        afterSelect: this.handleAfterSelect
      }), children)));
    }
  }]);

  return Menu;
}(_react["default"].Component);

_defineProperty(Menu, "displayName", "Menu");

_defineProperty(Menu, "propTypes", {
  /**
   * The element the menu is attached too.
   */
  anchorEl: _propTypes["default"].object,

  /**
   * The location to attach the content too on the anchor element.
   */
  anchorPosition: _propTypes["default"].object,

  /**
   * The content of the menu, provided in a list of `<MenuItem>` components.
   */
  children: _propTypes["default"].node,

  /**
   * Array of additional CSS classes to use.
   */
  classes: _propTypes["default"].array,

  /**
   * If set, will invoke `onClose` any time a menu item is selected.
   */
  closeOnSelect: _propTypes["default"].bool,

  /**
   * The location to attach the anchor to on the content element.
   */
  contentPosition: _propTypes["default"].object,

  /**
   * Whether or not the dropdown should take up the entire screen-width.
   */
  fullWidth: _propTypes["default"].bool,

  /**
   * Whether or not the menu should be rendered.
   */
  isOpen: _propTypes["default"].bool,

  /**
   * Whether or not the popout should be forced to stay on screen.
   */
  keepOnScreen: _propTypes["default"].bool,

  /**
   * A function to be invoked to use when the menu closes.
   */
  onClose: _propTypes["default"].func,

  /**
   * The styles to be applied to the popover list.
   */
  popoverStyles: _propTypes["default"].object,

  /**
   * The index of the item currently selected in the list.
   */
  selectedIndex: _propTypes["default"].number,

  /**
   * The margins of the page the popover should respect.
   */
  marginThreshold: _propTypes["default"].number
});

_defineProperty(Menu, "defaultProps", {
  classes: [],
  closeOnSelect: true,
  isOpen: true,
  keepOnScreen: false,
  popoverStyles: {}
});

var _default = (0, _withClasses["default"])(Menu);

exports["default"] = _default;