"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _useIsFocusVisible2 = _interopRequireDefault(require("../utils/useIsFocusVisible"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var MenuItem = function MenuItem(_ref) {
  var children = _ref.children,
      classes = _ref.classes,
      color = _ref.color,
      disabled = _ref.disabled,
      onSelect = _ref.onSelect,
      afterSelect = _ref.afterSelect,
      selected = _ref.selected,
      other = _objectWithoutProperties(_ref, ["children", "classes", "color", "disabled", "onSelect", "afterSelect", "selected"]);

  var theme = (0, _react.useContext)(_ThemeContext["default"]);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      focusVisible = _useState2[0],
      setFocusVisible = _useState2[1];

  var _useIsFocusVisible = (0, _useIsFocusVisible2["default"])(),
      ref = _useIsFocusVisible.ref,
      isFocusVisible = _useIsFocusVisible.isFocusVisible,
      onBlurVisible = _useIsFocusVisible.onBlurVisible;

  var getLinkedStyles = function getLinkedStyles() {
    return {
      styles: /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "3701199905",
        dynamic: [theme.palette.text.secondary, theme.typography.body1.fontFamily, theme.typography.body1.fontSize, theme.typography.body1.fontWeight, theme.typography.body1.letterSpacing, theme.typography.body1.lineHeight, theme.spacing(2), theme.spacing(4), theme.palette.primary.main, theme.palette.grey[100], theme.palette.grey[50], theme.palette.text.secondary, theme.palette.grey[50], theme.palette.text.secondary, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.grey[200], theme.palette.text.primary, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.grey[50], theme.typography.fontWeight.light, theme.palette.grey[50], theme.breakpoints.sm, theme.typography.body1.mobile.fontSize, theme.typography.body1.mobile.lineHeight]
      }, ".menu-item.__jsx-style-dynamic-selector{box-sizing:border-box;color:".concat(theme.palette.text.secondary, ";cursor:pointer;font-family:").concat(theme.typography.body1.fontFamily, ";font-size:").concat(theme.typography.body1.fontSize, ";font-weight:").concat(theme.typography.body1.fontWeight, ";-webkit-letter-spacing:").concat(theme.typography.body1.letterSpacing, ";-moz-letter-spacing:").concat(theme.typography.body1.letterSpacing, ";-ms-letter-spacing:").concat(theme.typography.body1.letterSpacing, ";letter-spacing:").concat(theme.typography.body1.letterSpacing, ";line-height:").concat(theme.typography.body1.lineHeight, ";margin:0;outline:0;padding:").concat(theme.spacing(2), "px ").concat(theme.spacing(4), "px;text-align:inherit;}.menu-item.focusVisible.__jsx-style-dynamic-selector{color:").concat(theme.palette.primary.main, ";outline:5px auto;}.menu-item.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.grey[100], ";}.menu-item.disabled.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.grey[50], ";border-color:transparent;color:").concat(theme.palette.text.secondary, ";}.menu-item.disabled.focusVisible.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.grey[50], ";border-color:transparent;color:").concat(theme.palette.text.secondary, ";outline:0;}.menu-item.primary.__jsx-style-dynamic-selector,.menu-item.secondary.__jsx-style-dynamic-selector{border-left:3px solid transparent;}.menu-item.primary.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.primary.main, ";}.menu-item.primary.focusVisible.__jsx-style-dynamic-selector{color:").concat(theme.palette.primary.main, ";outline:5px auto;}.menu-item.secondary.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.secondary.main, ";}.menu-item.secondary.focusVisible.__jsx-style-dynamic-selector{color:").concat(theme.palette.secondary.main, ";outline:5px auto;}.menu-item.selected.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.grey[200], ";color:").concat(theme.palette.text.primary, ";}.menu-item.selected.primary.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.primary.main, ";}.menu-item.selected.secondary.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.secondary.main, ";}.menu-item.disabled.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.grey[50], ";border-color:transparent;cursor:inherit;font-weight:").concat(theme.typography.fontWeight.light, ";opacity:0.6;}.menu-item.disabled.__jsx-style-dynamic-selector:hover{background-color:").concat(theme.palette.grey[50], ";border-color:transparent;}@media (max-width:").concat(theme.breakpoints.sm, "px){.menu-item.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.body1.mobile.fontSize, ";line-height:").concat(theme.typography.body1.mobile.lineHeight, ";}}")),
      className: _style["default"].dynamic([["3701199905", [theme.palette.text.secondary, theme.typography.body1.fontFamily, theme.typography.body1.fontSize, theme.typography.body1.fontWeight, theme.typography.body1.letterSpacing, theme.typography.body1.lineHeight, theme.spacing(2), theme.spacing(4), theme.palette.primary.main, theme.palette.grey[100], theme.palette.grey[50], theme.palette.text.secondary, theme.palette.grey[50], theme.palette.text.secondary, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.grey[200], theme.palette.text.primary, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.grey[50], theme.typography.fontWeight.light, theme.palette.grey[50], theme.breakpoints.sm, theme.typography.body1.mobile.fontSize, theme.typography.body1.mobile.lineHeight]]])
    };
  };

  var handleBlur = function handleBlur() {
    setFocusVisible(false);
    onBlurVisible();
  };

  var handleClick = function handleClick(e) {
    if (disabled) {
      e.stopPropagation();
    }

    if (!disabled) {
      if (onSelect) onSelect(e);
      if (afterSelect) afterSelect(e);
    }
  };

  var handleFocus = function handleFocus(e) {
    setFocusVisible(isFocusVisible(e));
  };

  var handleKeyDown = function handleKeyDown(e) {
    if (onSelect && e.type === "keydown" && e.key === "Enter") {
      if (!disabled) {
        if (onSelect) onSelect(e);
        if (afterSelect) afterSelect(e);
      }
    }
  };

  var linkedStyles = getLinkedStyles();
  var className = (0, _clsx["default"])("menu-item", linkedStyles.className, color, {
    focusVisible: focusVisible,
    selected: selected,
    disabled: disabled
  }, classes);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: ref,
    tabIndex: "0",
    role: onSelect ? "button" : "",
    className: className,
    onKeyDown: handleKeyDown,
    onClick: handleClick,
    onFocus: handleFocus,
    onBlur: handleBlur
  }, other), children), linkedStyles.styles);
};

MenuItem.displayName = "MenuItem";
MenuItem.propTypes = {
  /**
   * The content of the component.
   */
  children: _propTypes["default"].node,

  /**
   * Array of additional CSS classes to use.
   */
  classes: _propTypes["default"].array,

  /**
   * The color of the component. It supports those theme colors that make sense for this component.
   */
  color: _propTypes["default"].oneOf(["primary", "secondary"]),

  /**
   * Whether or not the item is disabled
   */
  disabled: _propTypes["default"].bool,

  /**
   * A function to invoke when the menu item is selected. Can be overwritten by `<Menu>` `onSelect` handler.
   */
  onSelect: _propTypes["default"].func,

  /**
   * @ignore
   * A function to invoke after a selection is made.
   */
  afterSelect: _propTypes["default"].func,

  /**
   * Whether or not the item is selected
   */
  selected: _propTypes["default"].bool
};
MenuItem.defaultProps = {
  classes: []
};

var _default = (0, _withClasses["default"])(MenuItem);

exports["default"] = _default;