"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var MenuList = /*#__PURE__*/function (_React$Component) {
  _inherits(MenuList, _React$Component);

  var _super = _createSuper(MenuList);

  function MenuList(props) {
    var _this;

    _classCallCheck(this, MenuList);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "handleKeyDown", function (event) {
      var _this$props = _this.props,
          children = _this$props.children,
          selectedIndex = _this$props.selectedIndex;
      var nextEvents = ["ArrowDown", "ArrowRight"];
      var prevEvents = ["ArrowUp", "ArrowLeft"];
      var allEvents = [].concat(nextEvents, prevEvents);

      if (allEvents.includes(event.key)) {
        event.preventDefault();
        event.stopPropagation();
      }

      if (nextEvents.includes(event.key)) {
        _this.moveFocus(children, selectedIndex, "next", event);
      } else if (prevEvents.includes(event.key)) {
        _this.moveFocus(children, selectedIndex, "prev", event);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleSelect", function (index) {
      return function (event) {
        var onSelect = _this.props.onSelect;
        onSelect(index, event);
      };
    });

    _defineProperty(_assertThisInitialized(_this), "moveFocus", function (direction) {
      var _this$list$children$n;

      var children = _this.props.children;
      var currentIndex = Object.values(_this.list.children).indexOf(document.activeElement);
      var nextIndex = direction === "prev" ? currentIndex - 1 : currentIndex + 1;

      if (nextIndex >= children.length) {
        nextIndex = 0;
      } else if (nextIndex < 0) {
        nextIndex = children.length - 1;
      }

      return (_this$list$children$n = _this.list.children[nextIndex]) === null || _this$list$children$n === void 0 ? void 0 : _this$list$children$n.focus();
    });

    _this.handleKeyDown = _this.handleKeyDown.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(MenuList, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener("keydown", this.handleKeyDown);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener("keydown", this.handleKeyDown);
    }
  }, {
    key: "renderChildren",
    value: function renderChildren() {
      var _this2 = this;

      var _this$props2 = this.props,
          afterSelect = _this$props2.afterSelect,
          children = _this$props2.children,
          onSelect = _this$props2.onSelect,
          selectedIndex = _this$props2.selectedIndex;
      return _react["default"].Children.map(children.type === _react["default"].Fragment ? children.props.children : children, function (child, index) {
        if (!child) return null;
        var newProps = {
          afterSelect: afterSelect,
          color: _this2.props.color,
          key: index,
          selected: index === selectedIndex
        };

        if (onSelect) {
          newProps.onSelect = _this2.handleSelect(index);
        }

        return /*#__PURE__*/_react["default"].cloneElement(child, _objectSpread(_objectSpread({}, newProps), child.props));
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var classes = this.props.classes;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _clsx["default"])(classes),
        ref: function ref(_ref) {
          return _this3.list = _ref;
        }
      }, this.renderChildren());
    }
  }]);

  return MenuList;
}(_react["default"].Component);

_defineProperty(MenuList, "displayName", "MenuList");

_defineProperty(MenuList, "propTypes", {
  /**
   * The content of the menu list, provided in a list of `<MenuItem>` components.
   */
  children: _propTypes["default"].node,

  /**
   * Array of additional CSS classes to use.
   */
  classes: _propTypes["default"].array,

  /**
   * The color of the component. It supports those theme colors that make sense for this component.
   */
  color: _propTypes["default"].oneOf(["primary", "secondary"]),

  /**
   * A function to invoke when any menu item is selected. If provided, will override any menu item's
   * individual `onSelect` handler.
   */
  onSelect: _propTypes["default"].func,

  /**
   * @ignore
   * The function callback after an item is selected. Used for internal purposes only to support
   * `closeOnSelect` from `<Menu>`.
   */
  afterSelect: _propTypes["default"].func,

  /**
   * The selected index of the list.
   */
  selectedIndex: _propTypes["default"].number
});

_defineProperty(MenuList, "defaultProps", {
  selectedIndex: -1
});

var _default = (0, _withClasses["default"])(MenuList);

exports["default"] = _default;