"use strict";

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _react = _interopRequireDefault(require("react"));

var _Notice = _interopRequireDefault(require("./Notice.jsx"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<Notice>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Notice["default"], null));
    } catch (e) {
      error = e;
    }

    expect(error).toEqual(undefined);
  });
  it("renders correct snapshot", function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Notice["default"], null));
    expect((0, _enzymeToJson["default"])(wrapper)).toMatchSnapshot();
  });
  describe("default props", function () {
    it("sets correct default props", function () {
      var defaultProps = new _Notice["default"]().type.defaultProps;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Notice["default"], null));
      var component = wrapper.find("Notice");
      expect(component.props().color).toEqual(defaultProps.color);
    });
  });
  describe("children prop", function () {
    it("renders given children", function () {
      var child = /*#__PURE__*/_react["default"].createElement("h5", null, "hi hi");

      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Notice["default"], null, child));
      expect(wrapper.find("Notice").childAt(0).contains(child)).toEqual(true);
    });
  });
  describe("classes prop", function () {
    it("applies all classes to the div inside of Notice", function () {
      var classes = ["classOne"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Notice["default"], {
        classes: classes
      }));
      expect(wrapper.find("Notice").find("div").hasClass(classes[0])).toEqual(true);
    });
    it("appends higher order values to classes prop with withClass decorator", function () {
      var classes = ["riipen", "riipen-notice"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Notice["default"], null));
      expect(wrapper.find("Notice").props().classes.sort()).toEqual(classes.sort());
    });
    it("gives an error when classes are provided as one string", function () {
      var classes = "classOne classTwo";
      var errors = jest.spyOn(console, "error").mockImplementation();
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Notice["default"], {
        classes: classes
      }));
      expect(errors).toHaveBeenCalled();
    });
  });
  describe("color prop", function () {
    it("sets color class name with a valid color", function () {
      var color = "positive";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Notice["default"], {
        color: color
      }));
      expect(wrapper.find("Notice").childAt(0).hasClass(color)).toEqual(true);
    });
    it("gives an error when given an invalid color", function () {
      var errors = jest.spyOn(console, "error").mockImplementation();
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Notice["default"], {
        color: "red"
      }));
      expect(errors).toHaveBeenCalledTimes(1);
    });
  });
});