"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Paper = function Paper(props) {
  var children = props.children,
      classes = props.classes,
      Component = props.component,
      elevation = props.elevation,
      padding = props.padding,
      rounded = props.rounded,
      variant = props.variant,
      other = _objectWithoutProperties(props, ["children", "classes", "component", "elevation", "padding", "rounded", "variant"]);

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  var className = (0, _clsx["default"])("root", classes, rounded ? "rounded" : null, variant === "outlined" ? "outlined" : "elevation");
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(Component, _extends({}, other, {
    className: _style["default"].dynamic([["258748828", [theme.palette.common.white, theme.spacing[padding], theme.shadows[elevation], theme.palette.divider, theme.shape.borderRadius.md]]]) + " " + (other && other.className != null && other.className || className || "")
  }), children), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "258748828",
    dynamic: [theme.palette.common.white, theme.spacing[padding], theme.shadows[elevation], theme.palette.divider, theme.shape.borderRadius.md]
  }, ".root.__jsx-style-dynamic-selector{background-color:".concat(theme.palette.common.white, ";padding:").concat(theme.spacing[padding], ";}.elevation.__jsx-style-dynamic-selector{box-shadow:").concat(theme.shadows[elevation], ";}.outlined.__jsx-style-dynamic-selector{border:1px solid ").concat(theme.palette.divider, ";}.rounded.__jsx-style-dynamic-selector{border-radius:").concat(theme.shape.borderRadius.md, ";}")));
};

Paper.propTypes = {
  /**
   * The content of the component.
   */
  children: _propTypes["default"].node,

  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].array,

  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: _propTypes["default"].elementType,

  /**
   * The elevation of the box shadow with respect to the current theme.
   */
  elevation: _propTypes["default"].number,

  /**
   * The amount of padding the paper should have.
   */
  padding: _propTypes["default"].number,

  /**
   * If `true`, rounded corners are enabled.
   */
  rounded: _propTypes["default"].bool,

  /**
   * The variant to use.
   */
  variant: _propTypes["default"].oneOf(["elevation", "outlined"])
};
Paper.defaultProps = {
  classes: [],
  component: "div",
  padding: 2,
  rounded: false,
  variant: "elevation"
};
Paper.displayName = "Paper";

var _default = (0, _withClasses["default"])(Paper);

exports["default"] = _default;