"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _utils = require("../utils");

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Popover = /*#__PURE__*/function (_React$Component) {
  _inherits(Popover, _React$Component);

  var _super = _createSuper(Popover);

  function Popover(props) {
    var _this;

    _classCallCheck(this, Popover);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "getAnchorEl", function () {
      var anchorEl = _this.props.anchorEl;
      return typeof anchorEl === "function" ? anchorEl() : anchorEl;
    });

    _defineProperty(_assertThisInitialized(_this), "setPositioningStyle", function () {
      var contentRef = _this.contentRef.current;
      var _this$props = _this.props,
          _this$props$anchorPos = _this$props.anchorPosition,
          anchorPosition = _this$props$anchorPos === void 0 ? {
        vertical: "top",
        horizontal: "left"
      } : _this$props$anchorPos,
          _this$props$contentPo = _this$props.contentPosition,
          contentPosition = _this$props$contentPo === void 0 ? {
        vertical: "top",
        horizontal: "left"
      } : _this$props$contentPo,
          fullWidth = _this$props.fullWidth,
          keepOnScreen = _this$props.keepOnScreen;

      var anchorEl = _this.getAnchorEl();

      if (!anchorEl || !contentRef) return; // Set top and left of element based on location of anchor

      var anchorRect = anchorEl.getBoundingClientRect();
      var top = anchorRect.top;
      var left = anchorRect.left; // Offset Content Based on anchorPosition props

      var anchorVerticalOffset = (0, _utils.getOffsetTop)(anchorRect, anchorPosition.vertical);
      var anchorHorizonalOffset = (0, _utils.getOffsetLeft)(anchorRect, anchorPosition.horizontal);
      top += anchorVerticalOffset;
      left += anchorHorizonalOffset; // Offset Content Based on contentPosition props

      var contentRect = contentRef.getBoundingClientRect();
      var contentVerticalOffset = (0, _utils.getOffsetTop)(contentRect, contentPosition.vertical);
      var contentHorizontalOffset = (0, _utils.getOffsetLeft)(contentRect, contentPosition.horizontal);
      top -= contentVerticalOffset;
      left -= contentHorizontalOffset; // Move menu back into view if out of screen

      if (keepOnScreen) {
        var marginThreshold = _this.props.marginThreshold;
        var viewContainer = (0, _utils.getContainer)(anchorEl);
        var heightMax = viewContainer.innerHeight - marginThreshold;
        var widthMax = viewContainer.innerWidth - marginThreshold; // Check Vertical Constraints

        if (top + contentRect.height > heightMax) {
          top -= top + contentRect.height - heightMax;
        } else if (top < marginThreshold) {
          top = marginThreshold;
        } // Check Horizontal Constraints


        if (left + contentRect.width > widthMax) {
          left -= left + contentRect.width - widthMax;
        } else if (left < marginThreshold) {
          left = marginThreshold;
        }
      } // Handle fullWidth menu


      if (fullWidth) {
        left = 0;
      }

      _this.setState(Object.assign(_this.state, {
        contentStyles: {
          top: "".concat(top, "px"),
          left: "".concat(left, "px"),
          position: "fixed"
        }
      }));
    });

    _defineProperty(_assertThisInitialized(_this), "handleCloseEvent", function (event) {
      var _this$props2 = _this.props,
          isOpen = _this$props2.isOpen,
          anchorEl = _this$props2.anchorEl;
      var contentRef = _this.contentRef.current;
      if (!contentRef || !isOpen) return;

      if (event.type === "mousedown") {
        // Check if mouse click happened inside popover
        // Or on the anchorEl
        var target = event.target;

        if (contentRef === target || anchorEl === target || _this.isDecendant(contentRef, target) || _this.isDecendant(anchorEl, target)) {
          return;
        }

        _this.handleClose();
      } else if (event.type === "keydown" && event.key === "Escape") {
        _this.handleClose();
      } else if (event.type === "keydown" && _this.props.onKeyDown) {
        // stop this event from triggering other keydown listeners
        event.stopImmediatePropagation();

        _this.props.onKeyDown(event);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleClose", function () {
      var onClose = _this.props.onClose;
      if (onClose) onClose();
    });

    _defineProperty(_assertThisInitialized(_this), "updatePosition", function () {
      if (!_this.props.anchorEl) return undefined;
      return _this.setPositioningStyle();
    });

    _this.positionChangeEventHandler = (0, _utils.debounce)(_this.updatePosition, 10);
    _this.handleCloseEvent = _this.handleCloseEvent.bind(_assertThisInitialized(_this));
    _this.state = {
      scrollContainer: null,
      scrollContainerStyle: null,
      contentStyles: {
        top: 0,
        left: 0,
        visibility: "hidden"
      }
    };
    _this.contentRef = /*#__PURE__*/_react["default"].createRef();
    return _this;
  }

  _createClass(Popover, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props3 = this.props,
          anchorEl = _this$props3.anchorEl,
          lockScroll = _this$props3.lockScroll;
      window.addEventListener("resize", this.positionChangeEventHandler);
      window.addEventListener("scroll", this.positionChangeEventHandler);
      window.addEventListener("mousedown", this.handleCloseEvent);
      window.addEventListener("keydown", this.handleCloseEvent);

      if (anchorEl) {
        this.manageScrollableParentEventListeners(false);
      }

      if (anchorEl && lockScroll) {
        this.lockParentScroll();
      }

      this.setPositioningStyle();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var anchorChange = prevProps.anchorEl === null && this.props.anchorEl !== null;
      /* need to NOT check that previous prop was !isOpen
       * in order to cause positioning of popover to be correct
       * when it is opened by a controlled Tooltip being opened
       */

      var openChange = this.props.isOpen;
      var anchorPositionChange = !(prevProps.anchorPosition === this.props.anchorPosition);
      var contentPositionChange = !(prevProps.contentPosition === this.props.contentPosition);

      if (anchorChange) {
        // add event listeners
        this.manageScrollableParentEventListeners(false);
      }

      if (anchorChange || openChange || contentPositionChange || anchorPositionChange) {
        // need to use requestAnimationFrame in order for popover to get proper position on first open
        window.requestAnimationFrame(this.setPositioningStyle);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$props4 = this.props,
          anchorEl = _this$props4.anchorEl,
          lockScroll = _this$props4.lockScroll;
      window.removeEventListener("resize", this.positionChangeEventHandler);
      window.removeEventListener("scroll", this.positionChangeEventHandler);
      window.removeEventListener("mousedown", this.handleCloseEvent);
      window.removeEventListener("keydown", this.handleCloseEvent);
      this.manageScrollableParentEventListeners(true);

      if (anchorEl && lockScroll) {
        this.resetParentScroll();
      }
    }
  }, {
    key: "manageScrollableParentEventListeners",
    value: function manageScrollableParentEventListeners() {
      var remove = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      var _this$props5 = this.props,
          anchorEl = _this$props5.anchorEl,
          closeOnScrolled = _this$props5.closeOnScrolled;

      if (anchorEl) {
        var closestScrollableParent = (0, _utils.getClosestScrollableParent)(anchorEl);

        if (closestScrollableParent) {
          if (remove) {
            closestScrollableParent.removeEventListener("resize", closeOnScrolled ? this.handleClose : this.positionChangeEventHandler);
            closestScrollableParent.removeEventListener("scroll", closeOnScrolled ? this.handleClose : this.positionChangeEventHandler);
          } else {
            closestScrollableParent.addEventListener("resize", closeOnScrolled ? this.handleClose : this.positionChangeEventHandler);
            closestScrollableParent.addEventListener("scroll", closeOnScrolled ? this.handleClose : this.positionChangeEventHandler);
          }
        }
      }
    }
  }, {
    key: "isDecendant",
    value: function isDecendant(parent, child) {
      var node = child.parentNode;

      if (node == null) {
        return false;
      } else if (node === parent) {
        return true;
      }

      return this.isDecendant(parent, node);
    }
  }, {
    key: "lockParentScroll",
    // Find the outer most scrollable content and remove the scrollbar
    value: function lockParentScroll() {
      var anchorEl = this.getAnchorEl();
      var parent = anchorEl.parentElement;
      var container = (0, _utils.getDocument)(anchorEl);
      this.state.scrollContainer = parent.nodeName === "HTML" && window.getComputedStyle(parent)["overflow-y"] === "scroll" ? parent : container.body;
      this.state.scrollContainerStyle = this.state.scrollContainer.style.overflow;
      this.state.scrollContainer.style.overflow = "hidden";
    }
  }, {
    key: "resetParentScroll",
    value: function resetParentScroll() {
      this.state.scrollContainer.style.overflow = this.state.scrollContainerStyle;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props6 = this.props,
          anchorEl = _this$props6.anchorEl,
          classes = _this$props6.classes,
          children = _this$props6.children,
          component = _this$props6.component,
          fullWidth = _this$props6.fullWidth,
          styles = _this$props6.styles,
          isOpen = _this$props6.isOpen;
      var theme = this.context;
      var className = (0, _clsx["default"])(classes, "popover", {
        open: isOpen
      });
      var Component = component;
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, anchorEl && isOpen && /*#__PURE__*/_react["default"].createElement(Component, {
        style: _objectSpread(_objectSpread({}, styles), this.state.contentStyles),
        ref: this.contentRef,
        className: _style["default"].dynamic([["631859544", [theme.palette.common.white, theme.shape.borderRadius.md, theme.shadows[4], fullWidth ? "100%" : "calc(100% - 32px)", fullWidth ? "width: 100%;" : "", theme.zIndex.middle]]]) + " " + (className || "")
      }, children), /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "631859544",
        dynamic: [theme.palette.common.white, theme.shape.borderRadius.md, theme.shadows[4], fullWidth ? "100%" : "calc(100% - 32px)", fullWidth ? "width: 100%;" : "", theme.zIndex.middle]
      }, ".popover.__jsx-style-dynamic-selector{background:".concat(theme.palette.common.white, ";border-radius:").concat(theme.shape.borderRadius.md, ";box-shadow:").concat(theme.shadows[4], ";box-sizing:border-box;max-height:calc(100% - 32px);max-width:").concat(fullWidth ? "100%" : "calc(100% - 32px)", ";min-height:16px;min-width:16px;outline:0;position:absolute;").concat(fullWidth ? "width: 100%;" : "", " z-index:").concat(theme.zIndex.middle, ";}.popover.__jsx-style-dynamic-selector::webkit-scrollbar{display:none;}")));
    }
  }]);

  return Popover;
}(_react["default"].Component);

_defineProperty(Popover, "displayName", "Popover");

_defineProperty(Popover, "propTypes", {
  /**
   * Either a reference to an anchor element or a function to get the reference
   */
  anchorEl: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].object]),

  /**
   * The location to attach the content too on the anchor element
   */
  anchorPosition: _propTypes["default"].object,

  /**
   * The content of the component
   */
  children: _propTypes["default"].node,

  /**
   * Array of additional CSS classes to use.
   */
  classes: _propTypes["default"].array,

  /**
   * Whether the popover should be closed when its closest scrollable parent is scrolled.
   * [Default] true
   */
  closeOnScrolled: _propTypes["default"].bool,

  /**
   * The type of element to use at the root
   */
  component: _propTypes["default"].string,

  /**
   * The location to attach the anchor to on the content element
   */
  contentPosition: _propTypes["default"].object,

  /**
   * Whether or not the dropdown should take up the entire screen-width.
   */
  fullWidth: _propTypes["default"].bool,

  /**
   * Whether the popover should be displayed
   */
  isOpen: _propTypes["default"].bool,

  /**
   * Function call to handle keydown events,
   */
  onKeyDown: _propTypes["default"].func,

  /**
   * Whether to keep the popout on screen when the anchor element scrolls off
   */
  keepOnScreen: _propTypes["default"].bool,

  /**
   * Whether to lock the scrollbar when the popover is open
   */
  lockScroll: _propTypes["default"].bool,

  /**
   * The marigins of the page the popover should respect
   */
  marginThreshold: _propTypes["default"].number,

  /**
   * Function call to handle clickaway/ close events,
   * if not provided the anchor element must be removed to clear the popover or use isOpen
   */
  onClose: _propTypes["default"].func,

  /**
   * Styles to apply to the component
   */
  styles: _propTypes["default"].object
});

_defineProperty(Popover, "defaultProps", {
  closeOnScrolled: true,
  component: "span",
  fullWidth: false,
  isOpen: true,
  lockScroll: true,
  marginThreshold: 16,
  styles: {}
});

_defineProperty(Popover, "contextType", _ThemeContext["default"]);

var _default = (0, _withClasses["default"])(Popover);

exports["default"] = _default;