"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _Typography = _interopRequireDefault(require("./Typography"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var RadioButton = function RadioButton(_ref) {
  var checked = _ref.checked,
      classes = _ref.classes,
      color = _ref.color,
      disabled = _ref.disabled,
      label = _ref.label,
      prefix = _ref.prefix,
      size = _ref.size,
      suffix = _ref.suffix,
      wrapperProps = _ref.wrapperProps,
      other = _objectWithoutProperties(_ref, ["checked", "classes", "color", "disabled", "label", "prefix", "size", "suffix", "wrapperProps"]);

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  var typographyVariant;

  if (size === "medium") {
    typographyVariant = "body2";
  } else if (size === "small") {
    typographyVariant = "body3";
  } else if (size === "large") {
    typographyVariant = "h5";
  }

  return /*#__PURE__*/_react["default"].createElement("div", _extends({}, wrapperProps, {
    className: _style["default"].dynamic([["10583402", [theme.spacing(1), theme.palette.grey[300], theme.palette.grey[300], theme.palette.text.secondary, theme.palette.grey[600], theme.palette.text.primary, theme.palette.grey[300], theme.palette.grey[300], theme.palette.common.black, theme.palette.primary.light, theme.palette.primary.dark, theme.palette.primary.main, theme.palette.primary.main, theme.palette.common.white, theme.palette.secondary.light, theme.palette.secondary.dark, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.tertiary.light, theme.palette.tertiary.dark, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.disabled, theme.palette.disabled, theme.palette.grey[200]]]]) + " " + (wrapperProps && wrapperProps.className != null && wrapperProps.className || (0, _clsx["default"])(classes, color, checked && "checked", disabled && "disabled", "root", size) || "")
  }), /*#__PURE__*/_react["default"].createElement("label", {
    className: _style["default"].dynamic([["10583402", [theme.spacing(1), theme.palette.grey[300], theme.palette.grey[300], theme.palette.text.secondary, theme.palette.grey[600], theme.palette.text.primary, theme.palette.grey[300], theme.palette.grey[300], theme.palette.common.black, theme.palette.primary.light, theme.palette.primary.dark, theme.palette.primary.main, theme.palette.primary.main, theme.palette.common.white, theme.palette.secondary.light, theme.palette.secondary.dark, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.tertiary.light, theme.palette.tertiary.dark, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.disabled, theme.palette.disabled, theme.palette.grey[200]]]]) + " " + ((0, _clsx["default"])(checked && "checked", disabled && "disabled") || "")
  }, /*#__PURE__*/_react["default"].createElement("input", _extends({
    checked: checked,
    disabled: disabled,
    type: "radio"
  }, other, {
    className: _style["default"].dynamic([["10583402", [theme.spacing(1), theme.palette.grey[300], theme.palette.grey[300], theme.palette.text.secondary, theme.palette.grey[600], theme.palette.text.primary, theme.palette.grey[300], theme.palette.grey[300], theme.palette.common.black, theme.palette.primary.light, theme.palette.primary.dark, theme.palette.primary.main, theme.palette.primary.main, theme.palette.common.white, theme.palette.secondary.light, theme.palette.secondary.dark, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.tertiary.light, theme.palette.tertiary.dark, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.disabled, theme.palette.disabled, theme.palette.grey[200]]]]) + " " + (other && other.className != null && other.className || "")
  })), /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    component: "span",
    variant: typographyVariant,
    color: "inherit"
  }, prefix && /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["10583402", [theme.spacing(1), theme.palette.grey[300], theme.palette.grey[300], theme.palette.text.secondary, theme.palette.grey[600], theme.palette.text.primary, theme.palette.grey[300], theme.palette.grey[300], theme.palette.common.black, theme.palette.primary.light, theme.palette.primary.dark, theme.palette.primary.main, theme.palette.primary.main, theme.palette.common.white, theme.palette.secondary.light, theme.palette.secondary.dark, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.tertiary.light, theme.palette.tertiary.dark, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.disabled, theme.palette.disabled, theme.palette.grey[200]]]]) + " " + "content"
  }, prefix), /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["10583402", [theme.spacing(1), theme.palette.grey[300], theme.palette.grey[300], theme.palette.text.secondary, theme.palette.grey[600], theme.palette.text.primary, theme.palette.grey[300], theme.palette.grey[300], theme.palette.common.black, theme.palette.primary.light, theme.palette.primary.dark, theme.palette.primary.main, theme.palette.primary.main, theme.palette.common.white, theme.palette.secondary.light, theme.palette.secondary.dark, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.tertiary.light, theme.palette.tertiary.dark, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.disabled, theme.palette.disabled, theme.palette.grey[200]]]]) + " " + "content"
  }, label), suffix && /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["10583402", [theme.spacing(1), theme.palette.grey[300], theme.palette.grey[300], theme.palette.text.secondary, theme.palette.grey[600], theme.palette.text.primary, theme.palette.grey[300], theme.palette.grey[300], theme.palette.common.black, theme.palette.primary.light, theme.palette.primary.dark, theme.palette.primary.main, theme.palette.primary.main, theme.palette.common.white, theme.palette.secondary.light, theme.palette.secondary.dark, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.tertiary.light, theme.palette.tertiary.dark, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.disabled, theme.palette.disabled, theme.palette.grey[200]]]]) + " " + "content"
  }, suffix))), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "10583402",
    dynamic: [theme.spacing(1), theme.palette.grey[300], theme.palette.grey[300], theme.palette.text.secondary, theme.palette.grey[600], theme.palette.text.primary, theme.palette.grey[300], theme.palette.grey[300], theme.palette.common.black, theme.palette.primary.light, theme.palette.primary.dark, theme.palette.primary.main, theme.palette.primary.main, theme.palette.common.white, theme.palette.secondary.light, theme.palette.secondary.dark, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.common.white, theme.palette.tertiary.light, theme.palette.tertiary.dark, theme.palette.tertiary.main, theme.palette.tertiary.main, theme.palette.common.white, theme.palette.disabled, theme.palette.disabled, theme.palette.grey[200]]
  }, ".content.__jsx-style-dynamic-selector{margin:0 ".concat(theme.spacing(1), "px;}.root.__jsx-style-dynamic-selector{display:-webkit-inline-box;display:-webkit-inline-flex;display:-ms-inline-flexbox;display:inline-flex;cursor:pointer;border:1px solid ").concat(theme.palette.grey[300], ";-webkit-transition:0.2s linear;transition:0.2s linear;}label.__jsx-style-dynamic-selector{cursor:pointer;text-align:center;}input.__jsx-style-dynamic-selector{opacity:0;position:absolute;pointer-events:none;}.disabled.__jsx-style-dynamic-selector{cursor:default;}.small.__jsx-style-dynamic-selector label.__jsx-style-dynamic-selector{min-width:100px;padding:4px;width:100%;}.medium.__jsx-style-dynamic-selector label.__jsx-style-dynamic-selector{min-width:150px;padding:6px 12px;width:100%;}.large.__jsx-style-dynamic-selector label.__jsx-style-dynamic-selector{min-width:200px;padding:10px;width:100%;}.root.__jsx-style-dynamic-selector{background-color:transparent;border-color:").concat(theme.palette.grey[300], ";color:").concat(theme.palette.text.secondary, ";}.root.default.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.grey[600], ";color:").concat(theme.palette.text.primary, ";}.root.default.checked.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.grey[300], ";border-color:").concat(theme.palette.grey[300], ";color:").concat(theme.palette.common.black, ";}.root.primary.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.primary.light, ";color:").concat(theme.palette.primary.dark, ";}.root.primary.checked.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.primary.main, ";border-color:").concat(theme.palette.primary.main, ";color:").concat(theme.palette.common.white, ";}.root.secondary.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.secondary.light, ";color:").concat(theme.palette.secondary.dark, ";}.root.secondary.checked.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.secondary.main, ";border-color:").concat(theme.palette.secondary.main, ";color:").concat(theme.palette.common.white, ";}.root.tertiary.__jsx-style-dynamic-selector:hover{border-color:").concat(theme.palette.tertiary.light, ";color:").concat(theme.palette.tertiary.dark, ";}.root.tertiary.checked.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.tertiary.main, ";border-color:").concat(theme.palette.tertiary.main, ";color:").concat(theme.palette.common.white, ";}.root.disabled.__jsx-style-dynamic-selector:hover,.root.disabled.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.disabled, ";border-color:").concat(theme.palette.disabled, ";color:").concat(theme.palette.grey[200], ";}")));
};

RadioButton.propTypes = {
  /**
   * If `true`, the component is checked.
   */
  checked: _propTypes["default"].bool,

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * The color of the radio button.
   */
  color: _propTypes["default"].oneOf(["default", "primary", "secondary", "tertiary"]),

  /**
   * If `true`, the radio will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * Label text to display for the radio.
   */
  label: _propTypes["default"].node,

  /**
   * The component to render before the label text.
   */
  prefix: _propTypes["default"].node,

  /**
   * The size of the radio button
   */
  size: _propTypes["default"].oneOf(["small", "medium", "large"]),

  /**
   * The component to render after the label text.
   */
  suffix: _propTypes["default"].node,

  /**
   * Props to apply to div wrapper.
   */
  wrapperProps: _propTypes["default"].object
};
RadioButton.defaultProps = {
  size: "medium",
  color: "default",
  wrapperProps: {}
};
RadioButton.displayName = "RadioButton";

var _default = (0, _withClasses["default"])(RadioButton);

exports["default"] = _default;