"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _clsx = _interopRequireDefault(require("clsx"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _withThemeContext = _interopRequireDefault(require("../utils/withThemeContext"));

var _InputLabel = _interopRequireDefault(require("./InputLabel"));

var _Typography = _interopRequireDefault(require("./Typography"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var RadioButtonGroup = function RadioButtonGroup(_ref) {
  var children = _ref.children,
      error = _ref.error,
      fullWidth = _ref.fullWidth,
      hint = _ref.hint,
      id = _ref.id,
      label = _ref.label,
      labelProps = _ref.labelProps,
      onChange = _ref.onChange,
      required = _ref.required,
      theme = _ref.theme,
      value = _ref.value,
      variant = _ref.variant,
      warning = _ref.warning,
      other = _objectWithoutProperties(_ref, ["children", "error", "fullWidth", "hint", "id", "label", "labelProps", "onChange", "required", "theme", "value", "variant", "warning"]);

  var linkedStyles = {
    styles: /*#__PURE__*/_react["default"].createElement(_style["default"], {
      id: "1823270956",
      dynamic: [theme.shape.borderRadius.md, theme.shape.borderRadius.md, theme.shape.borderRadius.md, theme.shape.borderRadius.md, 100 / (_react["default"].Children.count(children) || 1), theme.shape.borderRadius.md, theme.spacing(4)]
    }, ".connected.radioButtons.__jsx-style-dynamic-selector .radioButton.__jsx-style-dynamic-selector:first-child{border-top-left-radius:".concat(theme.shape.borderRadius.md, ";border-bottom-left-radius:").concat(theme.shape.borderRadius.md, ";}.connected.radioButtons.__jsx-style-dynamic-selector .radioButton.__jsx-style-dynamic-selector:last-child{border-top-right-radius:").concat(theme.shape.borderRadius.md, ";border-bottom-right-radius:").concat(theme.shape.borderRadius.md, ";}.connected.radioButtons.__jsx-style-dynamic-selector .radioButton.__jsx-style-dynamic-selector:not(:first-child){border-left-color:transparent;}.connected.radioButtons.__jsx-style-dynamic-selector .radioButton.__jsx-style-dynamic-selector:not(:first-child .checked):hover{border-left-color:inherit;}fieldset.fullWidth.__jsx-style-dynamic-selector{width:100%;}div.fullWidth.__jsx-style-dynamic-selector{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;}div.fullWidth.__jsx-style-dynamic-selector>*.__jsx-style-dynamic-selector{-webkit-flex:1 1 ").concat(100 / (_react["default"].Children.count(children) || 1), "%;-ms-flex:1 1 ").concat(100 / (_react["default"].Children.count(children) || 1), "%;flex:1 1 ").concat(100 / (_react["default"].Children.count(children) || 1), "%;}.separate.radioButtons.__jsx-style-dynamic-selector .radioButton.__jsx-style-dynamic-selector{border-radius:").concat(theme.shape.borderRadius.md, ";}.separate.radioButtons.__jsx-style-dynamic-selector .radioButton.__jsx-style-dynamic-selector:not(:last-child){margin-right:").concat(theme.spacing(4), "px;}")),
    className: _style["default"].dynamic([["1823270956", [theme.shape.borderRadius.md, theme.shape.borderRadius.md, theme.shape.borderRadius.md, theme.shape.borderRadius.md, 100 / (_react["default"].Children.count(children) || 1), theme.shape.borderRadius.md, theme.spacing(4)]]])
  };

  var handleChange = function handleChange(e) {
    if (onChange) {
      onChange(e, e.target.value);
    }
  };

  var childrenWithProps = _react["default"].Children.map(children, function (child) {
    return child && /*#__PURE__*/_react["default"].cloneElement(child, _objectSpread(_objectSpread(_objectSpread({
      checked: value === child.props.value,
      onChange: handleChange
    }, other), child.props), {}, {
      classes: [linkedStyles.className, "radioButton"].concat(_toConsumableArray(child.props.classes || []))
    }));
  }).filter(Boolean);

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("fieldset", {
    id: id,
    className: "jsx-3241897731" + " " + ((0, _clsx["default"])(fullWidth && "fullWidth", linkedStyles.className) || "")
  }, (label || hint) && /*#__PURE__*/_react["default"].createElement(_InputLabel["default"], _extends({
    hint: hint,
    htmlFor: other.name,
    required: required
  }, labelProps), label), /*#__PURE__*/_react["default"].createElement("div", {
    className: "jsx-3241897731" + " " + ((0, _clsx["default"])("radioButtons", fullWidth && "fullWidth", variant, linkedStyles.className) || "")
  }, childrenWithProps), error && /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    color: "negative",
    variant: "body2"
  }, error), warning && /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    color: "secondary",
    variant: "body2"
  }, warning)), linkedStyles.styles, /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "3241897731"
  }, "fieldset.jsx-3241897731{border:none;margin:0;padding:0;}"));
};

RadioButtonGroup.displayName = "RadioButtonGroup";
RadioButtonGroup.propTypes = {
  /**
   * The content of the component.
   */
  children: _propTypes["default"].node.isRequired,

  /**
   * An error to display below the input.
   */
  error: _propTypes["default"].node,

  /**
   * Hint text to display under the label of the input.
   */
  hint: _propTypes["default"].node,

  /**
   * An ID to set on this component.
   */
  id: _propTypes["default"].string,

  /**
   * If `true`, will make the radio button group grow to use all the available space.
   */
  fullWidth: _propTypes["default"].bool,

  /**
   * Label text to display for the input.
   */
  label: _propTypes["default"].node,

  /**
   * Any props to pass through to the InputLabel
   */
  labelProps: _propTypes["default"].object,

  /**
   * Callback fired when a radio button is selected.
   *
   * @param {object} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (string).
   */
  onChange: _propTypes["default"].func,

  /**
   * If true, an asterisk will be appended to the end of the label.
   */
  required: _propTypes["default"].bool,

  /**
   * @ignore
   * The theme context object
   */
  theme: _propTypes["default"].object,

  /**
   * The value of the selected radio button
   */
  value: _propTypes["default"].any,

  /**
   * Radio button group variant to display
   */
  variant: _propTypes["default"].oneOf(["connected", "separate"]),

  /**
   * A warning to display below the input.
   */
  warning: _propTypes["default"].node
};
RadioButtonGroup.defaultProps = {
  variant: "connected"
};

var _default = (0, _withThemeContext["default"])((0, _withClasses["default"])(RadioButtonGroup));

exports["default"] = _default;