"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _InputLabel = _interopRequireDefault(require("./InputLabel"));

var _Typography = _interopRequireDefault(require("./Typography"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var RadioGroup = function RadioGroup(_ref) {
  var children = _ref.children,
      error = _ref.error,
      hint = _ref.hint,
      label = _ref.label,
      labelProps = _ref.labelProps,
      onChange = _ref.onChange,
      required = _ref.required,
      suffix = _ref.suffix,
      value = _ref.value,
      warning = _ref.warning,
      other = _objectWithoutProperties(_ref, ["children", "error", "hint", "label", "labelProps", "onChange", "required", "suffix", "value", "warning"]);

  var handleChange = function handleChange(e) {
    if (onChange) {
      onChange(e, e.target.value);
    }
  };

  var childrenWithProps = _react["default"].Children.map(children || [], function (child) {
    return child && /*#__PURE__*/_react["default"].cloneElement(child, _objectSpread({
      checked: value === child.props.value,
      onChange: handleChange
    }, child.props));
  }).filter(Boolean);

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("fieldset", {
    className: "jsx-3241897731"
  }, (label || hint || suffix) && /*#__PURE__*/_react["default"].createElement(_InputLabel["default"], _extends({
    hint: hint,
    htmlFor: other.name,
    required: required,
    suffix: suffix
  }, labelProps), label), childrenWithProps, error && /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    color: "negative",
    variant: "body2"
  }, error), warning && /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    color: "secondary",
    variant: "body2"
  }, warning)), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "3241897731"
  }, "fieldset.jsx-3241897731{border:none;margin:0;padding:0;}"));
};

RadioGroup.propTypes = {
  /**
   * The content of the component.
   */
  children: _propTypes["default"].node,

  /**
   * An error to display below the input.
   */
  error: _propTypes["default"].node,

  /**
   * Hint text to display under the label of the input.
   */
  hint: _propTypes["default"].node,

  /**
   * Label text to display for the input.
   */
  label: _propTypes["default"].node,

  /**
   * Any props to pass through to the InputLabel.
   */
  labelProps: _propTypes["default"].object,

  /**
   * Callback fired when a radio button is selected.
   *
   * @param {object} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (string).
   */
  onChange: _propTypes["default"].func,

  /**
   * If true, an asterisk will be appended to the end of the label.
   */
  required: _propTypes["default"].bool,

  /**
   * Any suffix to display beside the label.
   */
  suffix: _propTypes["default"].node,

  /**
   * The value of the selected radio button.
   */
  value: _propTypes["default"].any,

  /**
   * A warning to display below the input.
   */
  warning: _propTypes["default"].node
};
RadioGroup.displayName = "RadioGroup";

var _default = (0, _withClasses["default"])(RadioGroup);

exports["default"] = _default;