"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _withForwardedRef = _interopRequireDefault(require("../utils/withForwardedRef"));

var _Editor = _interopRequireDefault(require("./Editor"));

var _InputLabel = _interopRequireDefault(require("./InputLabel"));

var _Typography = _interopRequireDefault(require("./Typography"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var RichTextEditor = /*#__PURE__*/function (_React$Component) {
  _inherits(RichTextEditor, _React$Component);

  var _super = _createSuper(RichTextEditor);

  function RichTextEditor() {
    _classCallCheck(this, RichTextEditor);

    return _super.apply(this, arguments);
  }

  _createClass(RichTextEditor, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          ariaLabelledBy = _this$props.ariaLabelledBy,
          error = _this$props.error,
          forwardedRef = _this$props.forwardedRef,
          label = _this$props.label,
          id = _this$props.id,
          isRequired = _this$props.isRequired,
          maxHeight = _this$props.maxHeight,
          warning = _this$props.warning,
          other = _objectWithoutProperties(_this$props, ["ariaLabelledBy", "error", "forwardedRef", "label", "id", "isRequired", "maxHeight", "warning"]);

      var ariaLabel = ariaLabelledBy || label;
      return /*#__PURE__*/_react["default"].createElement("div", {
        id: id
      }, label && /*#__PURE__*/_react["default"].createElement(_InputLabel["default"], {
        id: ariaLabel,
        htmlFor: id,
        required: isRequired
      }, label), /*#__PURE__*/_react["default"].createElement(_Editor["default"], _extends({
        ariaLabelledBy: ariaLabel,
        error: error,
        maxHeight: maxHeight,
        ref: forwardedRef
      }, other)), error && /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
        component: "div",
        color: "negative",
        variant: "body2"
      }, error), warning && /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
        component: "div",
        color: "secondary",
        variant: "body2"
      }, warning));
    }
  }]);

  return RichTextEditor;
}(_react["default"].Component);

_defineProperty(RichTextEditor, "displayName", "RichTextEditor");

_defineProperty(RichTextEditor, "propTypes", {
  /**
   * The id of the element to use as the aria-label for the Editor.
   */
  ariaLabelledBy: _propTypes["default"].string,

  /**
   * An error to display below the input.
   */
  error: _propTypes["default"].node,

  /**
   * A reference to the Editor component.
   */
  forwardedRef: _propTypes["default"].object,

  /**
   * An ID to set on the wrapper div of this component.
   */
  id: _propTypes["default"].string,

  /**
   * Optional indicator to show if field is required.
   * Defaults to false.
   */
  isRequired: _propTypes["default"].bool,

  /**
   * Optional form field label string.
   */
  label: _propTypes["default"].string,

  /**
   * The max height of the Editor text area.
   */
  maxHeight: _propTypes["default"].string,

  /**
   * A warning to display below the input.
   */
  warning: _propTypes["default"].node
});

_defineProperty(RichTextEditor, "defaultProps", {
  isRequired: false,
  maxHeight: "auto"
});

var _default = (0, _withForwardedRef["default"])(RichTextEditor);

exports["default"] = _default;