"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _SpinnerClip = _interopRequireDefault(require("./SpinnerClip"));

var _SpinnerPulse = _interopRequireDefault(require("./SpinnerPulse"));

var _SpinnerScale = _interopRequireDefault(require("./SpinnerScale"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Spinner = function Spinner(_ref) {
  var variant = _ref.variant,
      other = _objectWithoutProperties(_ref, ["variant"]);

  var spinnersMap = {
    clip: _SpinnerClip["default"],
    pulse: _SpinnerPulse["default"],
    scale: _SpinnerScale["default"]
  };
  var Component = spinnersMap[variant];
  return /*#__PURE__*/_react["default"].createElement(Component, other);
};

Spinner.displayName = "Spinner";
Spinner.propTypes = {
  /**
   * The variant of spinner to display.
   */
  variant: _propTypes["default"].oneOf(["clip", "pulse", "scale"])
};
Spinner.defaultProps = {
  variant: "scale"
};

var _default = (0, _withClasses["default"])(Spinner);

exports["default"] = _default;