"use strict";

var _enzyme = require("enzyme");

var _react = _interopRequireDefault(require("react"));

var _Spinner = _interopRequireDefault(require("./Spinner"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<Spinner>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Spinner["default"], null));
    } catch (theError) {
      error = theError;
    }

    expect(error).toEqual(undefined);
  });
  describe("default props", function () {
    it("sets correct default props", function () {
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Spinner["default"], null));
      expect(wrapper.find("Spinner").props().variant).toEqual("scale");
    });
  });
  describe("variant prop", function () {
    it("renders the correct spinner when set to clip", function () {
      var variant = "clip";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Spinner["default"], {
        variant: variant
      }));
      expect(wrapper.find("SpinnerClip").length).toEqual(1);
    });
    it("renders the correct spinner when set to pulse", function () {
      var variant = "pulse";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Spinner["default"], {
        variant: variant
      }));
      expect(wrapper.find("SpinnerPulse").length).toEqual(1);
    });
    it("renders the correct spinner when set to scale", function () {
      var variant = "scale";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Spinner["default"], {
        variant: variant
      }));
      expect(wrapper.find("SpinnerScale").length).toEqual(1);
    });
  });
});