"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var SpinnerClip = function SpinnerClip(_ref) {
  var classes = _ref.classes,
      color = _ref.color,
      size = _ref.size;

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  var getStyles = function getStyles() {
    return {
      styles: /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "2451068266",
        dynamic: [size, size, theme.palette.common.black, theme.palette.grey[600], theme.palette.grey[800], theme.palette.grey.A400, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.tertiary.main]
      }, "@-webkit-keyframes clip-__jsx-style-dynamic-selector{0%{-webkit-transform:rotate(0deg);-ms-transform:rotate(0deg);transform:rotate(0deg);}50%{-webkit-transform:rotate(180deg);-ms-transform:rotate(180deg);transform:rotate(180deg);}100%{-webkit-transform:rotate(360deg);-ms-transform:rotate(360deg);transform:rotate(360deg);}}@keyframes clip-__jsx-style-dynamic-selector{0%{-webkit-transform:rotate(0deg);-ms-transform:rotate(0deg);transform:rotate(0deg);}50%{-webkit-transform:rotate(180deg);-ms-transform:rotate(180deg);transform:rotate(180deg);}100%{-webkit-transform:rotate(360deg);-ms-transform:rotate(360deg);transform:rotate(360deg);}}.root.__jsx-style-dynamic-selector{-webkit-animation-fill-mode:both;animation-fill-mode:both;-webkit-animation:clip-__jsx-style-dynamic-selector 1.25s 0s infinite linear;animation:clip-__jsx-style-dynamic-selector 1.25s 0s infinite linear;background:transparent;border:2px solid;border-radius:100%;border-bottom-color:transparent !important;display:inline-block;height:".concat(size, "px;width:").concat(size, "px;}.black.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.common.black, ";}.grey600.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.grey[600], ";}.grey800.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.grey[800], ";}.greyA400.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.grey.A400, ";}.primary.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.primary.main, ";}.secondary.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.secondary.main, ";}.tertiary.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.tertiary.main, ";}")),
      className: _style["default"].dynamic([["2451068266", [size, size, theme.palette.common.black, theme.palette.grey[600], theme.palette.grey[800], theme.palette.grey.A400, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.tertiary.main]]])
    };
  };

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: (0, _clsx["default"])(classes)
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: (0, _clsx["default"])(getStyles().className, "root", color)
  }), getStyles().styles);
};

SpinnerClip.displayName = "SpinnerClip";
SpinnerClip.propTypes = {
  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].array,

  /**
   * The color of the spinner.
   */
  color: _propTypes["default"].oneOf(["black", "grey600", "grey800", "greyA400", "primary", "secondary", "tertiary"]),

  /**
   * The size in pixels the spinner should be.
   */
  size: _propTypes["default"].number
};
SpinnerClip.defaultProps = {
  classes: [],
  color: "primary",
  size: 40
};

var _default = (0, _withClasses["default"])(SpinnerClip);

exports["default"] = _default;