"use strict";

var _enzyme = require("enzyme");

var _react = _interopRequireDefault(require("react"));

var _SpinnerClip = _interopRequireDefault(require("./SpinnerClip"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<SpinnerClip>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerClip["default"], null));
    } catch (theError) {
      error = theError;
    }

    expect(error).toEqual(undefined);
  });
  describe("default props", function () {
    it("sets correct default props", function () {
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerClip["default"], null));
      expect(wrapper.find("SpinnerClip").props().classes).toEqual(["riipen", "riipen-spinnerclip"]);
      expect(wrapper.find("SpinnerClip").props().color).toEqual("primary");
      expect(wrapper.find("SpinnerClip").props().size).toEqual(40);
    });
  });
  describe("classes prop", function () {
    it("applies custom classes", function () {
      var classes = ["classOne"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerClip["default"], {
        classes: classes
      }));
      expect(wrapper.find("SpinnerClip").childAt(0).hasClass(classes[0])).toEqual(true);
    });
  });
  describe("color prop", function () {
    it("applies valid custom colour class", function () {
      var color = "secondary";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerClip["default"], {
        color: color
      }));
      expect(wrapper.find("SpinnerClip").childAt(0).childAt(0).hasClass(color)).toEqual(true);
    });
    it("gives an error with invalid color", function () {
      var errors = jest.spyOn(console, "error").mockImplementation();
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerClip["default"], {
        color: "yellow"
      }));
      expect(errors).toHaveBeenCalled();
    });
  });
  describe("size prop", function () {
    it("sets valid custom size", function () {
      var size = 20;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerClip["default"], {
        size: size
      }));
      expect(wrapper.find("JSXStyle").props().dynamic).toContain(size);
    });
  });
});