"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var SpinnerPulse = function SpinnerPulse(_ref) {
  var classes = _ref.classes,
      color = _ref.color,
      margin = _ref.margin,
      size = _ref.size;

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  var getStyles = function getStyles(index) {
    return {
      styles: /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "324799779",
        dynamic: [index * 0.12, size, margin, size, theme.palette.common.black, theme.palette.grey[600], theme.palette.grey[800], theme.palette.grey.A400, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.tertiary.main]
      }, "@-webkit-keyframes pulse-__jsx-style-dynamic-selector{0%{-webkit-transform:scale(1);-ms-transform:scale(1);transform:scale(1);opacity:1;}45%{-webkit-transform:scale(0.1);-ms-transform:scale(0.1);transform:scale(0.1);opacity:0.7;}80%{-webkit-transform:scale(1);-ms-transform:scale(1);transform:scale(1);opacity:1;}}@keyframes pulse-__jsx-style-dynamic-selector{0%{-webkit-transform:scale(1);-ms-transform:scale(1);transform:scale(1);opacity:1;}45%{-webkit-transform:scale(0.1);-ms-transform:scale(0.1);transform:scale(0.1);opacity:0.7;}80%{-webkit-transform:scale(1);-ms-transform:scale(1);transform:scale(1);opacity:1;}}.root.__jsx-style-dynamic-selector{-webkit-animation-fill-mode:both;animation-fill-mode:both;-webkit-animation:pulse-__jsx-style-dynamic-selector 1.5s ".concat(index * 0.12, "s infinite cubic-bezier(0.2,0.68,0.18,1.08);animation:pulse-__jsx-style-dynamic-selector 1.5s ").concat(index * 0.12, "s infinite cubic-bezier(0.2,0.68,0.18,1.08);border-radius:100%;display:inline-block;height:").concat(size, "px;margin:").concat(margin, "px;width:").concat(size, "px;}.black.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.common.black, ";}.grey600.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.grey[600], ";}.grey800.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.grey[800], ";}.greyA400.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.grey.A400, ";}.primary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.primary.main, ";}.secondary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.secondary.main, ";}.tertiary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.tertiary.main, ";}")),
      className: _style["default"].dynamic([["324799779", [index * 0.12, size, margin, size, theme.palette.common.black, theme.palette.grey[600], theme.palette.grey[800], theme.palette.grey.A400, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.tertiary.main]]])
    };
  };

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: (0, _clsx["default"])(classes)
  }, Array(3).fill(null).map(function (_, index) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
      key: index
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: (0, _clsx["default"])(getStyles(index).className, "root", color)
    }), getStyles(index).styles);
  }));
};

SpinnerPulse.displayName = "SpinnerPulse";
SpinnerPulse.propTypes = {
  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].array,

  /**
   * The color of the spinner.
   */
  color: _propTypes["default"].oneOf(["black", "grey600", "grey800", "greyA400", "primary", "secondary", "tertiary"]),

  /**
   * The margin in pixels betwene pulse elements.
   */
  margin: _propTypes["default"].number,

  /**
   * The size in pixels the spinner should be.
   */
  size: _propTypes["default"].number
};
SpinnerPulse.defaultProps = {
  classes: [],
  color: "primary",
  margin: 5,
  size: 10
};

var _default = (0, _withClasses["default"])(SpinnerPulse);

exports["default"] = _default;