"use strict";

var _enzyme = require("enzyme");

var _react = _interopRequireDefault(require("react"));

var _SpinnerPulse = _interopRequireDefault(require("./SpinnerPulse"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<SpinnerPulse>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerPulse["default"], null));
    } catch (theError) {
      error = theError;
    }

    expect(error).toEqual(undefined);
  });
  describe("default props", function () {
    it("sets correct default props", function () {
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerPulse["default"], null));
      expect(wrapper.find("SpinnerPulse").props().classes).toEqual(["riipen", "riipen-spinnerpulse"]);
      expect(wrapper.find("SpinnerPulse").props().color).toEqual("primary");
      expect(wrapper.find("SpinnerPulse").props().margin).toEqual(5);
      expect(wrapper.find("SpinnerPulse").props().size).toEqual(10);
    });
  });
  describe("classes prop", function () {
    it("applies custom classes", function () {
      var classes = ["classOne"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerPulse["default"], {
        classes: classes
      }));
      expect(wrapper.find("SpinnerPulse").childAt(0).hasClass(classes[0])).toEqual(true);
    });
  });
  describe("color prop", function () {
    it("applies valid custom colour class", function () {
      var color = "secondary";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerPulse["default"], {
        color: color
      }));
      expect(wrapper.find("SpinnerPulse").childAt(0).childAt(0).hasClass(color)).toEqual(true);
    });
    it("gives an error with invalid color", function () {
      var errors = jest.spyOn(console, "error").mockImplementation();
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerPulse["default"], {
        color: "yellow"
      }));
      expect(errors).toHaveBeenCalled();
    });
  });
  describe("margin prop", function () {
    it("sets valid custom margin", function () {
      var margin = 20;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerPulse["default"], {
        margin: margin
      }));
      expect(wrapper.find("JSXStyle").at(0).props().dynamic).toContain(margin);
    });
  });
  describe("size prop", function () {
    it("sets valid custom size", function () {
      var size = 20;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerPulse["default"], {
        size: size
      }));
      expect(wrapper.find("JSXStyle").at(0).props().dynamic).toContain(size);
    });
  });
});