"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var SpinnerScale = function SpinnerScale(_ref) {
  var classes = _ref.classes,
      color = _ref.color,
      height = _ref.height,
      margin = _ref.margin,
      width = _ref.width;

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  var getStyles = function getStyles(index) {
    return {
      styles: /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "1319321421",
        dynamic: [index * 0.1, height, margin, width, theme.palette.common.black, theme.palette.grey[600], theme.palette.grey[800], theme.palette.grey.A400, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.tertiary.main]
      }, "@-webkit-keyframes scale-__jsx-style-dynamic-selector{0%{-webkit-transform:scaley(1);-ms-transform:scaley(1);transform:scaley(1);}40%{-webkit-transform:scaley(0.4);-ms-transform:scaley(0.4);transform:scaley(0.4);}60%{-webkit-transform:scaley(0.4);-ms-transform:scaley(0.4);transform:scaley(0.4);}100%{-webkit-transform:scaley(1);-ms-transform:scaley(1);transform:scaley(1);}}@keyframes scale-__jsx-style-dynamic-selector{0%{-webkit-transform:scaley(1);-ms-transform:scaley(1);transform:scaley(1);}40%{-webkit-transform:scaley(0.4);-ms-transform:scaley(0.4);transform:scaley(0.4);}60%{-webkit-transform:scaley(0.4);-ms-transform:scaley(0.4);transform:scaley(0.4);}100%{-webkit-transform:scaley(1);-ms-transform:scaley(1);transform:scaley(1);}}.root.__jsx-style-dynamic-selector{-webkit-animation-fill-mode:both;animation-fill-mode:both;-webkit-animation:scale-__jsx-style-dynamic-selector 1.5s ".concat(index * 0.1, "s infinite cubic-bezier(0.2,0.68,0.18,1.08);animation:scale-__jsx-style-dynamic-selector 1.5s ").concat(index * 0.1, "s infinite cubic-bezier(0.2,0.68,0.18,1.08);display:inline-block;height:").concat(height, "px;margin:").concat(margin, "px;width:").concat(width, "px;}.black.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.common.black, ";}.grey600.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.grey[600], ";}.grey800.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.grey[800], ";}.greyA400.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.grey.A400, ";}.primary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.primary.main, ";}.secondary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.secondary.main, ";}.tertiary.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.tertiary.main, ";}")),
      className: _style["default"].dynamic([["1319321421", [index * 0.1, height, margin, width, theme.palette.common.black, theme.palette.grey[600], theme.palette.grey[800], theme.palette.grey.A400, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.tertiary.main]]])
    };
  };

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: (0, _clsx["default"])(classes)
  }, Array(5).fill(null).map(function (_, index) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
      key: index
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: (0, _clsx["default"])(getStyles(index).className, "root", color)
    }), getStyles(index).styles);
  }));
};

SpinnerScale.displayName = "SpinnerScale";
SpinnerScale.propTypes = {
  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].array,

  /**
   * The color of the spinner.
   */
  color: _propTypes["default"].oneOf(["black", "grey600", "grey800", "greyA400", "primary", "secondary", "tertiary"]),

  /**
   * The height in pixels each element should be.
   */
  height: _propTypes["default"].number,

  /**
   * The margin in pixels betwene pulse elements.
   */
  margin: _propTypes["default"].number,

  /**
   * The width in pixels each element should be.
   */
  width: _propTypes["default"].number
};
SpinnerScale.defaultProps = {
  classes: [],
  color: "primary",
  height: 40,
  margin: 5,
  width: 5
};

var _default = (0, _withClasses["default"])(SpinnerScale);

exports["default"] = _default;