"use strict";

var _enzyme = require("enzyme");

var _react = _interopRequireDefault(require("react"));

var _SpinnerScale = _interopRequireDefault(require("./SpinnerScale"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<SpinnerScale>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerScale["default"], null));
    } catch (theError) {
      error = theError;
    }

    expect(error).toEqual(undefined);
  });
  describe("default props", function () {
    it("sets correct default props", function () {
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerScale["default"], null));
      expect(wrapper.find("SpinnerScale").props().classes).toEqual(["riipen", "riipen-spinnerscale"]);
      expect(wrapper.find("SpinnerScale").props().color).toEqual("primary");
      expect(wrapper.find("SpinnerScale").props().height).toEqual(40);
      expect(wrapper.find("SpinnerScale").props().margin).toEqual(5);
      expect(wrapper.find("SpinnerScale").props().width).toEqual(5);
    });
  });
  describe("classes prop", function () {
    it("applies custom classes", function () {
      var classes = ["classOne"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerScale["default"], {
        classes: classes
      }));
      expect(wrapper.find("SpinnerScale").childAt(0).hasClass(classes[0])).toEqual(true);
    });
  });
  describe("color prop", function () {
    it("applies valid custom colour class", function () {
      var color = "secondary";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerScale["default"], {
        color: color
      }));
      expect(wrapper.find("SpinnerScale").childAt(0).childAt(0).hasClass(color)).toEqual(true);
    });
    it("gives an error with invalid color", function () {
      var errors = jest.spyOn(console, "error").mockImplementation();
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerScale["default"], {
        color: "yellow"
      }));
      expect(errors).toHaveBeenCalled();
    });
  });
  describe("height prop", function () {
    it("sets valid custom height", function () {
      var height = 20;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerScale["default"], {
        height: height
      }));
      expect(wrapper.find("JSXStyle").at(0).props().dynamic).toContain(height);
    });
  });
  describe("margin prop", function () {
    it("sets valid custom margin", function () {
      var margin = 20;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerScale["default"], {
        margin: margin
      }));
      expect(wrapper.find("JSXStyle").at(0).props().dynamic).toContain(margin);
    });
  });
  describe("width prop", function () {
    it("sets valid custom width", function () {
      var width = 20;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_SpinnerScale["default"], {
        width: width
      }));
      expect(wrapper.find("JSXStyle").at(0).props().dynamic).toContain(width);
    });
  });
});