"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Switch = function Switch(props) {
  var checked = props.checked,
      classes = props.classes,
      color = props.color,
      disabled = props.disabled,
      id = props.id,
      onChange = props.onChange,
      required = props.required,
      size = props.size,
      value = props.value,
      other = _objectWithoutProperties(props, ["checked", "classes", "color", "disabled", "id", "onChange", "required", "size", "value"]);

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["2441136838", [theme.palette.grey[400], theme.transitions.create(["background-color"], {
      duration: theme.transitions.duration.standard
    }), theme.palette.grey[600], theme.transitions.create(["transform", "background-color"], {
      duration: theme.transitions.duration.standard
    }), theme.palette.grey[500], theme.palette.grey[200], theme.palette.disabled, theme.palette.primary.light, theme.palette.primary.dark, theme.palette.secondary.light, theme.palette.secondary.dark, theme.palette.tertiary.light, theme.palette.tertiary.dark, theme.palette.negative.light, theme.palette.negative.dark, theme.palette.positive.light, theme.palette.positive.dark]]]) + " " + ((0, _clsx["default"])(classes) || "")
  }, /*#__PURE__*/_react["default"].createElement("input", _extends({
    checked: checked,
    disabled: disabled,
    id: id,
    onChange: onChange,
    required: required,
    type: "checkbox",
    value: value
  }, other, {
    className: _style["default"].dynamic([["2441136838", [theme.palette.grey[400], theme.transitions.create(["background-color"], {
      duration: theme.transitions.duration.standard
    }), theme.palette.grey[600], theme.transitions.create(["transform", "background-color"], {
      duration: theme.transitions.duration.standard
    }), theme.palette.grey[500], theme.palette.grey[200], theme.palette.disabled, theme.palette.primary.light, theme.palette.primary.dark, theme.palette.secondary.light, theme.palette.secondary.dark, theme.palette.tertiary.light, theme.palette.tertiary.dark, theme.palette.negative.light, theme.palette.negative.dark, theme.palette.positive.light, theme.palette.positive.dark]]]) + " " + (other && other.className != null && other.className || (0, _clsx["default"])(color, other.readOnly ? "read-only" : null, size) || "")
  })), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "2441136838",
    dynamic: [theme.palette.grey[400], theme.transitions.create(["background-color"], {
      duration: theme.transitions.duration.standard
    }), theme.palette.grey[600], theme.transitions.create(["transform", "background-color"], {
      duration: theme.transitions.duration.standard
    }), theme.palette.grey[500], theme.palette.grey[200], theme.palette.disabled, theme.palette.primary.light, theme.palette.primary.dark, theme.palette.secondary.light, theme.palette.secondary.dark, theme.palette.tertiary.light, theme.palette.tertiary.dark, theme.palette.negative.light, theme.palette.negative.dark, theme.palette.positive.light, theme.palette.positive.dark]
  }, "input.__jsx-style-dynamic-selector{background-color:".concat(theme.palette.grey[400], ";cursor:pointer;outline:none;position:relative;-webkit-transition:").concat(theme.transitions.create(["background-color"], {
    duration: theme.transitions.duration.standard
  }), ";transition:").concat(theme.transitions.create(["background-color"], {
    duration: theme.transitions.duration.standard
  }), ";-webkit-appearance:none;}input.__jsx-style-dynamic-selector:before{background-color:").concat(theme.palette.grey[600], ";content:\"\";left:0;position:absolute;top:0;-webkit-transition:").concat(theme.transitions.create(["transform", "background-color"], {
    duration: theme.transitions.duration.standard
  }), ";transition:").concat(theme.transitions.create(["transform", "background-color"], {
    duration: theme.transitions.duration.standard
  }), ";}input.__jsx-style-dynamic-selector:hover.__jsx-style-dynamic-selector:before{box-shadow:0px 0px 7px 1px ").concat(theme.palette.grey[500], ";}.read-only.__jsx-style-dynamic-selector{cursor:initial;pointer-events:none;}input.__jsx-style-dynamic-selector:disabled,input.__jsx-style-dynamic-selector:checked.__jsx-style-dynamic-selector:disabled{background-color:").concat(theme.palette.grey[200], ";pointer-events:none;}input.__jsx-style-dynamic-selector:disabled.__jsx-style-dynamic-selector:before,input.__jsx-style-dynamic-selector:disabled.__jsx-style-dynamic-selector:checked.__jsx-style-dynamic-selector:before{background-color:").concat(theme.palette.disabled, ";}.medium.__jsx-style-dynamic-selector{border-radius:12px;height:20px;width:40px;}.medium.__jsx-style-dynamic-selector:before{border-radius:50%;height:20px;width:20px;}.medium.__jsx-style-dynamic-selector:checked.__jsx-style-dynamic-selector:before{-webkit-transform:translate(20px);-ms-transform:translate(20px);transform:translate(20px);}.small.__jsx-style-dynamic-selector{border-radius:10px;height:15px;width:30px;}.small.__jsx-style-dynamic-selector:before{border-radius:50%;height:15px;width:15px;}.small.__jsx-style-dynamic-selector:checked.__jsx-style-dynamic-selector:before{-webkit-transform:translate(15px);-ms-transform:translate(15px);transform:translate(15px);}.primary.__jsx-style-dynamic-selector:checked{background-color:").concat(theme.palette.primary.light, ";}.primary.__jsx-style-dynamic-selector:checked.__jsx-style-dynamic-selector:before{background-color:").concat(theme.palette.primary.dark, ";}.secondary.__jsx-style-dynamic-selector:checked{background-color:").concat(theme.palette.secondary.light, ";}.secondary.__jsx-style-dynamic-selector:checked.__jsx-style-dynamic-selector:before{background-color:").concat(theme.palette.secondary.dark, ";}.tertiary.__jsx-style-dynamic-selector:checked{background-color:").concat(theme.palette.tertiary.light, ";}.tertiary.__jsx-style-dynamic-selector:checked.__jsx-style-dynamic-selector:before{background-color:").concat(theme.palette.tertiary.dark, ";}.negative.__jsx-style-dynamic-selector:checked{background-color:").concat(theme.palette.negative.light, ";}.negative.__jsx-style-dynamic-selector:checked.__jsx-style-dynamic-selector:before{background-color:").concat(theme.palette.negative.dark, ";}.positive.__jsx-style-dynamic-selector:checked{background-color:").concat(theme.palette.positive.light, ";}.positive.__jsx-style-dynamic-selector:checked.__jsx-style-dynamic-selector:before{background-color:").concat(theme.palette.positive.dark, ";}")));
};

Switch.propTypes = {
  /**
   * If true, the input is checked.
   */
  checked: _propTypes["default"].bool,

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * The color of the switch.
   */
  color: _propTypes["default"].oneOf(["primary", "secondary", "tertiary", "positive", "negative"]),

  /**
   * If true, the switch will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * The id of the input element.
   */
  id: _propTypes["default"].string,

  /**
   * Callback fired when the state is changed.
   *
   * @param {object} event The event source of the callback.
   * You can pull out the new value by accessing event.target.value (string). You can pull out the new checked state by accessing event.target.checked (boolean).
   */
  onChange: _propTypes["default"].func,

  /**
   * If true, the input element will be required.
   */
  required: _propTypes["default"].bool,

  /**
   * The size of the switch. small is equivalent to the dense switch styling.
   */
  size: _propTypes["default"].oneOf(["small", "medium"]),

  /**
   * @ignore
   * The theme context object
   */
  theme: _propTypes["default"].object,

  /**
   * The value of the component. The DOM API casts this to a string. The browser uses "on" as the default value.
   */
  value: _propTypes["default"].any
};
Switch.defaultProps = {
  checked: false,
  classes: [],
  color: "secondary",
  size: "medium"
};
Switch.displayName = "Switch";
var _default = Switch;
exports["default"] = _default;