"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _utils = require("../utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var Tab = function Tab(props) {
  var active = props.active,
      breakpoint = props.breakpoint,
      classes = props.classes,
      color = props.color,
      disabled = props.disabled,
      displayActive = props.displayActive,
      fullWidth = props.fullWidth,
      Icon = props.icon,
      label = props.label,
      letterSpacing = props.letterSpacing,
      onClick = props.onClick,
      orientation = props.orientation,
      textTransform = props.textTransform,
      theme = props.theme,
      value = props.value;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      focusVisible = _useState2[0],
      setFocusVisible = _useState2[1];

  var _useIsFocusVisible = (0, _utils.useIsFocusVisible)(),
      ref = _useIsFocusVisible.ref,
      isFocusVisible = _useIsFocusVisible.isFocusVisible,
      onBlurVisible = _useIsFocusVisible.onBlurVisible;

  var handleFocus = function handleFocus(e) {
    setFocusVisible(isFocusVisible(e));
  };

  var handleBlur = function handleBlur() {
    setFocusVisible(false);
    onBlurVisible();
  };

  var handleChange = function handleChange(e) {
    if (!onClick || disabled) {
      return;
    }

    if (e.type === "click" || e.type === "keydown" && e.key === "Enter") {
      onClick(e, value);
    }

    return;
  };

  var className = (0, _clsx["default"])("root", orientation === "horizontal" && breakpoint !== "none" ? "breakpoint" : null, active || displayActive ? "".concat(color, "-active") : null, active || displayActive ? "".concat(orientation, "-active") : null, color, disabled ? "disabled" : null, focusVisible ? "focusVisible" : null, fullWidth ? "full-width" : null, orientation, classes);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    tabIndex: "0",
    role: "button",
    ref: ref,
    "aria-pressed": active,
    "aria-disabled": disabled,
    onClick: handleChange,
    onKeyDown: handleChange,
    onFocus: handleFocus,
    onBlur: handleBlur,
    className: _style["default"].dynamic([["1274470273", [theme.spacing(3), theme.spacing(6), theme.transitions.duration.standard, theme.spacing(2), theme.typography.fontFamily, theme.typography.fontWeight.regular, theme.typography.body2.fontSize, letterSpacing, theme.typography.body2.lineHeight, textTransform, theme.spacing(), theme.spacing(5), theme.palette.grey[50], theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.breakpoints[breakpoint], theme.spacing(1), theme.spacing(2), theme.palette.divider, theme.spacing(6), theme.spacing(-1), theme.spacing(1), theme.spacing(3), theme.typography.body2.mobile.fontSize, theme.typography.body2.mobile.lineHeight, theme.spacing(2), theme.spacing(5)]]]) + " " + (className || "")
  }, Icon && /*#__PURE__*/_react["default"].createElement("span", {
    className: _style["default"].dynamic([["1274470273", [theme.spacing(3), theme.spacing(6), theme.transitions.duration.standard, theme.spacing(2), theme.typography.fontFamily, theme.typography.fontWeight.regular, theme.typography.body2.fontSize, letterSpacing, theme.typography.body2.lineHeight, textTransform, theme.spacing(), theme.spacing(5), theme.palette.grey[50], theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.breakpoints[breakpoint], theme.spacing(1), theme.spacing(2), theme.palette.divider, theme.spacing(6), theme.spacing(-1), theme.spacing(1), theme.spacing(3), theme.typography.body2.mobile.fontSize, theme.typography.body2.mobile.lineHeight, theme.spacing(2), theme.spacing(5)]]]) + " " + ((0, _clsx["default"])("icon") || "")
  }, typeof Icon === "function" ? /*#__PURE__*/_react["default"].createElement(Icon, {
    className: _style["default"].dynamic([["1274470273", [theme.spacing(3), theme.spacing(6), theme.transitions.duration.standard, theme.spacing(2), theme.typography.fontFamily, theme.typography.fontWeight.regular, theme.typography.body2.fontSize, letterSpacing, theme.typography.body2.lineHeight, textTransform, theme.spacing(), theme.spacing(5), theme.palette.grey[50], theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.breakpoints[breakpoint], theme.spacing(1), theme.spacing(2), theme.palette.divider, theme.spacing(6), theme.spacing(-1), theme.spacing(1), theme.spacing(3), theme.typography.body2.mobile.fontSize, theme.typography.body2.mobile.lineHeight, theme.spacing(2), theme.spacing(5)]]])
  }) : Icon), label && /*#__PURE__*/_react["default"].createElement("div", {
    className: _style["default"].dynamic([["1274470273", [theme.spacing(3), theme.spacing(6), theme.transitions.duration.standard, theme.spacing(2), theme.typography.fontFamily, theme.typography.fontWeight.regular, theme.typography.body2.fontSize, letterSpacing, theme.typography.body2.lineHeight, textTransform, theme.spacing(), theme.spacing(5), theme.palette.grey[50], theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.breakpoints[breakpoint], theme.spacing(1), theme.spacing(2), theme.palette.divider, theme.spacing(6), theme.spacing(-1), theme.spacing(1), theme.spacing(3), theme.typography.body2.mobile.fontSize, theme.typography.body2.mobile.lineHeight, theme.spacing(2), theme.spacing(5)]]]) + " " + ((0, _clsx["default"])("label") || "")
  }, label)), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "1274470273",
    dynamic: [theme.spacing(3), theme.spacing(6), theme.transitions.duration.standard, theme.spacing(2), theme.typography.fontFamily, theme.typography.fontWeight.regular, theme.typography.body2.fontSize, letterSpacing, theme.typography.body2.lineHeight, textTransform, theme.spacing(), theme.spacing(5), theme.palette.grey[50], theme.palette.primary.main, theme.palette.primary.main, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.palette.secondary.main, theme.breakpoints[breakpoint], theme.spacing(1), theme.spacing(2), theme.palette.divider, theme.spacing(6), theme.spacing(-1), theme.spacing(1), theme.spacing(3), theme.typography.body2.mobile.fontSize, theme.typography.body2.mobile.lineHeight, theme.spacing(2), theme.spacing(5)]
  }, ".root.__jsx-style-dynamic-selector{-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;border-bottom:3px solid transparent;cursor:pointer;display:-webkit-inline-box;display:-webkit-inline-flex;display:-ms-inline-flexbox;display:inline-flex;-webkit-box-pack:center;-webkit-justify-content:center;-ms-flex-pack:center;justify-content:center;height:100%;min-width:72px;outline:0;padding:".concat(theme.spacing(3), "px ").concat(theme.spacing(6), "px;text-align:center;-webkit-transition:all ").concat(theme.transitions.duration.standard, "ms;transition:all ").concat(theme.transitions.duration.standard, "ms;}.root.focusVisible.__jsx-style-dynamic-selector{outline:5px auto -webkit-focus-ring-color;}.icon.__jsx-style-dynamic-selector+*.__jsx-style-dynamic-selector{margin-left:").concat(theme.spacing(2), "px;}.icon.__jsx-style-dynamic-selector{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;}.label.__jsx-style-dynamic-selector{font-family:").concat(theme.typography.fontFamily, ";font-weight:").concat(theme.typography.fontWeight.regular, ";font-size:").concat(theme.typography.body2.fontSize, ";-webkit-letter-spacing:").concat(letterSpacing, "px;-moz-letter-spacing:").concat(letterSpacing, "px;-ms-letter-spacing:").concat(letterSpacing, "px;letter-spacing:").concat(letterSpacing, "px;line-height:").concat(theme.typography.body2.lineHeight, ";-webkit-text-decoration:none;text-decoration:none;text-transform:").concat(textTransform, ";width:100%;}.vertical.__jsx-style-dynamic-selector{border-bottom:0;border-right:3px solid transparent;padding:").concat(theme.spacing(), "px ").concat(theme.spacing(5), "px;text-align:left;}.vertical-active.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.grey[50], ";}.primary-active.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.primary.main, ";color:").concat(theme.palette.primary.main, ";}.primary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.primary.main, ";}.secondary-active.__jsx-style-dynamic-selector{border-color:").concat(theme.palette.secondary.main, ";color:").concat(theme.palette.secondary.main, ";}.secondary.__jsx-style-dynamic-selector:hover{color:").concat(theme.palette.secondary.main, ";}.disabled.__jsx-style-dynamic-selector{opacity:0.5;pointer-events:none;}.full-width.__jsx-style-dynamic-selector{-webkit-flex-basis:0;-ms-flex-preferred-size:0;flex-basis:0;-webkit-box-flex:1;-webkit-flex-grow:1;-ms-flex-positive:1;flex-grow:1;-webkit-flex-shrink:1;-ms-flex-negative:1;flex-shrink:1;max-width:none;}@media (max-width:").concat(theme.breakpoints[breakpoint], "px){.breakpoint.__jsx-style-dynamic-selector{margin:0 ").concat(theme.spacing(1), "px;padding:").concat(theme.spacing(2), "px 0;position:relative;}.breakpoint.__jsx-style-dynamic-selector:not(:last-child)::after{border-right:1px solid ").concat(theme.palette.divider, ";content:\"\";height:").concat(theme.spacing(6), "px;position:absolute;right:").concat(theme.spacing(-1), "px;}.breakpoint.__jsx-style-dynamic-selector>*.__jsx-style-dynamic-selector{padding:").concat(theme.spacing(1), "px ").concat(theme.spacing(3), "px;}.label.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.body2.mobile.fontSize, ";-webkit-letter-spacing:1px;-moz-letter-spacing:1px;-ms-letter-spacing:1px;letter-spacing:1px;line-height:").concat(theme.typography.body2.mobile.lineHeight, ";}.vertical.__jsx-style-dynamic-selector{padding:").concat(theme.spacing(2), "px ").concat(theme.spacing(5), "px;}}")));
};

Tab.defaultProps = {
  active: false,
  breakpoint: "sm",
  color: "secondary",
  disabled: false,
  fullWidth: false,
  letterSpacing: 1,
  orientation: "horizontal",
  textTransform: "uppercase"
};
Tab.propTypes = {
  /**
   * If `true`, the tab indicator will be displayed.
   */
  active: _propTypes["default"].bool,

  /**
   * The breakpoint to display the mobile tab styling. Use "none" for no styling.
   */
  breakpoint: _propTypes["default"].oneOf(["sm", "md", "lg", "xl", "none"]),

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * Determines the color of the indicator.
   */
  color: _propTypes["default"].oneOf(["primary", "secondary"]),

  /**
   * If `true`, the tab will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If `true` will force the tab to be displayed active.
   */
  displayActive: _propTypes["default"].bool,

  /**
   * If `true`, will make the tab grow to use all the available space.
   */
  fullWidth: _propTypes["default"].bool,

  /**
   * The icon element.
   */
  icon: _propTypes["default"].oneOfType([_propTypes["default"].elementType, _propTypes["default"].node]),

  /**
   * The label element.
   */
  label: _propTypes["default"].node,

  /**
   * Spacing to apply to letters. Is always 1px at screen sizes smaller `breakpoint` prop.
   */
  letterSpacing: _propTypes["default"].number,

  /**
   * Callback fired when the tab is clicked.
   *
   * @param {object} event The event source of the callback.
   * @param {any} value We default to the index of the child (number).
   */
  onClick: _propTypes["default"].func,

  /**
   * The indicator orientation.
   */
  orientation: _propTypes["default"].oneOf(["horizontal", "vertical"]),

  /**
   * Set the text-transform on the tabs.
   */
  textTransform: _propTypes["default"].oneOf(["inherit", "capitalize", "uppercase", "lowercase"]),

  /**
   * @ignore
   * The theme context object.
   */
  theme: _propTypes["default"].object,

  /**
   * The value provided when a click event is dispatched.
   */
  value: _propTypes["default"].any.isRequired
};
Tab.displayName = "Tab";

var _default = (0, _utils.withThemeContext)(Tab);

exports["default"] = _default;