"use strict";

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _react = _interopRequireDefault(require("react"));

var _default = _interopRequireDefault(require("../themes/default"));

var _TableCell = _interopRequireDefault(require("./TableCell"));

var _Table = _interopRequireDefault(require("./Table"));

var _TableBody = _interopRequireDefault(require("./TableBody"));

var _TableRow = _interopRequireDefault(require("./TableRow"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<TableCell>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], null)))));
    } catch (theError) {
      error = theError;
    }

    expect(error).toEqual(undefined);
  });
  it("renders correct snapshot", function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], null)))));
    expect((0, _enzymeToJson["default"])(wrapper)).toMatchSnapshot();
  });
  describe("default props", function () {
    it("sets correct default props", function () {
      var defaultProps = new _TableCell["default"]().type.defaultProps;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], null)))));
      expect(wrapper.find("TableCell").props().colSpan).toEqual(defaultProps.colSpan);
      expect(wrapper.find("TableCell").props().padding).toEqual(defaultProps.padding);
      expect(wrapper.find("TableCell").props().rowSpan).toEqual(defaultProps.rowSpan);
      expect(wrapper.find("TableCell").props().textAlign).toEqual(defaultProps.textAlign);
    });
  });
  describe("children prop", function () {
    it("displays given children", function () {
      var child = /*#__PURE__*/_react["default"].createElement("div", null, "child");

      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], null, child)))));
      expect(wrapper.containsMatchingElement(child)).toBeTruthy();
    });
  });
  describe("classes prop", function () {
    it("sets custom class", function () {
      var classes = ["newClass"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], {
        classes: classes
      })))));
      expect(wrapper.find("TableCell").childAt(0).hasClass(classes[0])).toEqual(true);
    });
    it("appends higher order values to classes prop with withClasses decorator", function () {
      var classes = ["riipen", "riipen-tablecell"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], null)))));
      expect(wrapper.find("TableCell").props().classes.sort()).toEqual(classes.sort());
    });
  });
  describe("colSpan prop", function () {
    it("sets custom colSpan", function () {
      var colSpan = 2;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], {
        colSpan: colSpan
      })))));
      expect(wrapper.find("TableCell").find("td").props().colSpan).toEqual(colSpan);
    });
  });
  describe("padding prop", function () {
    it("sets custom padding", function () {
      var padding = 2;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], {
        padding: padding
      })))));
      expect(wrapper.find("JSXStyle").at(0).props().dynamic).toContain(_default["default"].spacing(padding));
    });
  });
  describe("rowSpan prop", function () {
    it("sets custom rowSpan", function () {
      var rowSpan = 2;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], {
        rowSpan: rowSpan
      })))));
      expect(wrapper.find("TableCell").find("td").props().rowSpan).toEqual(rowSpan);
    });
  });
  describe("textAlign prop", function () {
    it("sets custom valid textAlign", function () {
      var textAlign = "center";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], {
        textAlign: textAlign
      })))));
      expect(wrapper.find("JSXStyle").at(0).props().dynamic).toContain(textAlign);
    });
    it("gives an error when given an invalid textAlign", function () {
      var errors = jest.spyOn(console, "error").mockImplementation();
      var textAlign = "centered";
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], {
        textAlign: textAlign
      })))));
      expect(errors).toHaveBeenCalledTimes(1);
    });
  });
});