"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _debounce = _interopRequireDefault(require("../utils/debounce"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _TableHeader = _interopRequireDefault(require("./TableHeader"));

var _Table = _interopRequireDefault(require("./Table"));

var _TableRow = _interopRequireDefault(require("./TableRow"));

var _TableGeneratorRow = _interopRequireDefault(require("./TableGeneratorRow"));

var _TableBody = _interopRequireDefault(require("./TableBody"));

var _TableHeaderCell = _interopRequireDefault(require("./TableHeaderCell"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TableGenerator = /*#__PURE__*/function (_React$Component) {
  _inherits(TableGenerator, _React$Component);

  var _super = _createSuper(TableGenerator);

  function TableGenerator(props) {
    var _this;

    _classCallCheck(this, TableGenerator);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "updateWindowDimensions", function () {
      var theme = _this.context;
      var windowWidth = window.innerWidth;
      var breakpoint = theme.breakpoints[_this.props.mobileBreakpoint];

      _this.setState({
        isMobile: windowWidth <= breakpoint
      });
    });

    _this.state = {
      isMobile: false
    };
    _this.updateWindowDimensions = (0, _debounce["default"])(_this.updateWindowDimensions);
    return _this;
  }

  _createClass(TableGenerator, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.updateWindowDimensions();
      window.addEventListener("resize", this.updateWindowDimensions);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener("resize", this.updateWindowDimensions);
    }
  }, {
    key: "render",
    value: function render() {
      var isMobile = this.state.isMobile;
      var _this$props = this.props,
          classes = _this$props.classes,
          data = _this$props.data,
          empty = _this$props.empty,
          loading = _this$props.loading,
          hover = _this$props.hover,
          columns = _this$props.columns,
          expandedNode = _this$props.expandedNode,
          expandRow = _this$props.expandRow,
          rowProps = _this$props.rowProps;
      var theme = this.context;
      var rowCount = data.length;
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        className: _style["default"].dynamic([["1798651688", [theme.palette.grey[400]]]]) + " " + ((0, _clsx["default"])("container", classes) || "")
      }, /*#__PURE__*/_react["default"].createElement(_Table["default"], null, !isMobile && /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], {
        border: true
      }, columns.map(function (col, i) {
        var _col$headerProps;

        return /*#__PURE__*/_react["default"].createElement(_TableHeaderCell["default"], _extends({
          key: "header-column-".concat(i)
        }, (_col$headerProps = col.headerProps) === null || _col$headerProps === void 0 ? void 0 : _col$headerProps.call(col, isMobile)), col === null || col === void 0 ? void 0 : col.header(isMobile));
      }))), /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, data.map(function (row, i) {
        var isLastRow = i === rowCount - 1;
        return /*#__PURE__*/_react["default"].createElement(_TableGeneratorRow["default"], {
          key: "row-".concat(i),
          columns: columns,
          data: row,
          expandedNode: expandedNode,
          expandRow: expandRow,
          hover: hover,
          isLastRow: isLastRow,
          mobile: isMobile,
          rowProps: rowProps,
          rowNum: i
        });
      }))), loading, !loading && data.length === 0 && empty), /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "1798651688",
        dynamic: [theme.palette.grey[400]]
      }, ".container.__jsx-style-dynamic-selector{border:1px solid ".concat(theme.palette.grey[400], ";border-radius:4px;display:inline-block;min-width:100%;overflow-x:auto;}")));
    }
  }]);

  return TableGenerator;
}(_react["default"].Component);

_defineProperty(TableGenerator, "displayName", "TableGenerator");

_defineProperty(TableGenerator, "propTypes", {
  /**
   * Classes to apply to the root element.
   */
  classes: _propTypes["default"].arrayOf(_propTypes["default"].string),

  /**
   * The columns to render.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    cell: _propTypes["default"].func.isRequired,
    cellProps: _propTypes["default"].func,
    header: _propTypes["default"].func.isRequired,
    headerProps: _propTypes["default"].func,
    mobileFooter: _propTypes["default"].bool,
    mobileHeader: _propTypes["default"].bool
  })),

  /**
   * The entities to render in the table rows.
   */
  data: _propTypes["default"].array,

  /**
   * The react node to display if no data is provided.
   */
  empty: _propTypes["default"].node,

  /**
   * Function to determine if row should be expanded or not
   */
  expandRow: _propTypes["default"].func,

  /**
   * Node to render for an expanded row.
   */
  expandedNode: _propTypes["default"].func,

  /**
   * Whether or not to highlight rows on highlight.
   */
  hover: _propTypes["default"].bool,

  /**
   * A react node to display if data is loading. will display if provided.
   */
  loading: _propTypes["default"].node,

  /**
   * Size to change table render from desktop to mobile.
   */
  mobileBreakpoint: _propTypes["default"].oneOf(["xs", "sm", "md", "lg", "xl"]),

  /**
   * Properties to pass to a rendered row.
   */
  rowProps: _propTypes["default"].object
});

_defineProperty(TableGenerator, "defaultProps", {
  columns: [],
  data: [],
  hover: true,
  mobileBreakpoint: "md"
});

_defineProperty(TableGenerator, "contextType", _ThemeContext["default"]);

var _default = (0, _withClasses["default"])(TableGenerator);

exports["default"] = _default;