"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _Table = _interopRequireDefault(require("./Table"));

var _TableRow = _interopRequireDefault(require("./TableRow"));

var _TableBody = _interopRequireDefault(require("./TableBody"));

var _TableCell = _interopRequireDefault(require("./TableCell"));

var _TableHeaderCell = _interopRequireDefault(require("./TableHeaderCell"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var TableGeneratorRow = function TableGeneratorRow(_ref) {
  var hover = _ref.hover,
      data = _ref.data,
      columns = _ref.columns,
      expandedNode = _ref.expandedNode,
      expandRow = _ref.expandRow,
      isLastRow = _ref.isLastRow,
      mobile = _ref.mobile,
      rowNum = _ref.rowNum,
      rowProps = _ref.rowProps;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      hovering = _useState2[0],
      setHovering = _useState2[1];

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  var handleRowMouseEnter = hover ? function () {
    return setHovering(true);
  } : undefined;
  var handleRowMouseLeave = hover ? function () {
    return setHovering(false);
  } : undefined;
  var isExpandable = expandRow && expandedNode;
  var isExpanded = isExpandable && expandRow(data);

  var renderDefault = function renderDefault() {
    return columns.map(function (col, j) {
      var _col$cellProps;

      return /*#__PURE__*/_react["default"].createElement(_TableCell["default"], _extends({
        key: "default-cell-".concat(rowNum, "-").concat(j)
      }, (_col$cellProps = col.cellProps) === null || _col$cellProps === void 0 ? void 0 : _col$cellProps.call(col, data, rowNum, mobile)), col === null || col === void 0 ? void 0 : col.cell(data, rowNum, mobile));
    });
  };

  var renderMobile = function renderMobile() {
    var mobileHeader = columns.find(function (x) {
      return x.mobileHeader;
    });
    var mobileFooter = columns.find(function (x) {
      return x.mobileFooter;
    });
    var bodyColumns = columns.filter(function (x) {
      return !x.mobileFooter && !x.mobileHeader;
    });
    return /*#__PURE__*/_react["default"].createElement(_TableCell["default"], {
      padding: 0
    }, mobileHeader && /*#__PURE__*/_react["default"].createElement(_Table["default"], {
      backgroundColor: "transparent"
    }, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], null, mobileHeader === null || mobileHeader === void 0 ? void 0 : mobileHeader.cell(data, rowNum, mobile))))), /*#__PURE__*/_react["default"].createElement(_Table["default"], {
      layout: "fixed",
      backgroundColor: "transparent"
    }, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, bodyColumns.map(function (bodyColumn, j) {
      return /*#__PURE__*/_react["default"].createElement(_TableRow["default"], {
        border: false,
        key: "".concat(rowNum, "-").concat(j)
      }, /*#__PURE__*/_react["default"].createElement(_TableHeaderCell["default"], {
        align: "left"
      }, bodyColumn === null || bodyColumn === void 0 ? void 0 : bodyColumn.header(mobile)), /*#__PURE__*/_react["default"].createElement(_TableCell["default"], null, bodyColumn === null || bodyColumn === void 0 ? void 0 : bodyColumn.cell(data, rowNum, mobile)));
    }))), mobileFooter && /*#__PURE__*/_react["default"].createElement(_Table["default"], {
      backgroundColor: "transparent"
    }, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], {
      border: false
    }, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], null, mobileFooter === null || mobileFooter === void 0 ? void 0 : mobileFooter.cell(data, rowNum, mobile))))));
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], _extends({
    border: !isLastRow || isExpanded,
    forceHover: hovering,
    onMouseEnter: handleRowMouseEnter,
    onMouseLeave: handleRowMouseLeave
  }, rowProps), !mobile && renderDefault(), mobile && renderMobile()), isExpanded && /*#__PURE__*/_react["default"].createElement(_TableRow["default"], {
    border: !isLastRow,
    forceHover: hovering,
    onMouseEnter: handleRowMouseEnter,
    onMouseLeave: handleRowMouseLeave
  }, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], {
    classes: ["expanded"],
    padding: 0,
    colSpan: columns.length
  }, expandedNode(data))), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "725096434",
    dynamic: [theme.palette.grey[100]]
  }, ".expanded.__jsx-style-dynamic-selector{background-color:".concat(theme.palette.grey[100], ";}")));
};

TableGeneratorRow.displayName = "TableGeneratorRow";
TableGeneratorRow.propTypes = {
  /**
   * Classes to apply to the root element.
   */
  classes: _propTypes["default"].arrayOf(_propTypes["default"].string),

  /**
   * The columns to render.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    cell: _propTypes["default"].func.isRequired,
    cellProps: _propTypes["default"].func,
    header: _propTypes["default"].func.isRequired,
    headerProps: _propTypes["default"].func,
    mobileFooter: _propTypes["default"].bool,
    mobileHeader: _propTypes["default"].bool
  })),

  /**
   * Row data to render.
   */
  data: _propTypes["default"].object,

  /**
   * Function to determine if row should be expanded or not
   */
  expandRow: _propTypes["default"].func,

  /**
   * Node to render for an expanded row.
   */
  expandedNode: _propTypes["default"].func,

  /**
   * Whether or not to highlight rows on highlight.
   */
  hover: _propTypes["default"].bool,

  /**
   * Is this the last row or not.
   */
  isLastRow: _propTypes["default"].bool,

  /**
   * Render mobile view or not.
   */
  mobile: _propTypes["default"].bool,

  /**
   * The number of this row
   */
  rowNum: _propTypes["default"].number,

  /**
   * Properties to pass to a rendered row.
   */
  rowProps: _propTypes["default"].object
};
TableGeneratorRow.defaultProps = {
  columns: [],
  data: {},
  hover: true,
  mobile: false,
  isLastRow: false
};

var _default = (0, _withClasses["default"])(TableGeneratorRow);

exports["default"] = _default;