"use strict";

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _react = _interopRequireDefault(require("react"));

var _Table = _interopRequireDefault(require("./Table.jsx"));

var _TableHeader = _interopRequireDefault(require("./TableHeader.jsx"));

var _TableRow = _interopRequireDefault(require("./TableRow.jsx"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<TableHeader>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], null)));
    } catch (theError) {
      error = theError;
    }

    expect(error).toEqual(undefined);
  });
  it("renders correct snapshot", function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], null)));
    expect((0, _enzymeToJson["default"])(wrapper)).toMatchSnapshot();
  });
  describe("children prop", function () {
    it("renders given non null children", function () {
      var child = /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null);

      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], null, null, child)));
      expect(wrapper.find("thead").childAt(0).matchesElement(child)).toEqual(true);
    });
  });
  describe("classes prop", function () {
    it("applies classes to the root node", function () {
      var classes = ["classOne"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], {
        classes: classes
      })));
      expect(wrapper.find("thead").hasClass(classes[0])).toEqual(true);
    });
    it("appends higher order values to classes prop with withClasses decorator", function () {
      var classes = ["riipen", "riipen-tableheader"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], null)));
      expect(wrapper.find("TableHeader").props().classes.sort()).toEqual(classes.sort());
    });
  });
});