"use strict";

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _react = _interopRequireDefault(require("react"));

var _Table = _interopRequireDefault(require("./Table"));

var _TableHeader = _interopRequireDefault(require("./TableHeader"));

var _TableHeaderCell = _interopRequireDefault(require("./TableHeaderCell"));

var _TableRow = _interopRequireDefault(require("./TableRow"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<TableHeaderCell>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeaderCell["default"], null)))));
    } catch (theError) {
      error = theError;
    }

    expect(error).toEqual(undefined);
  });
  it("renders correct snapshot", function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeaderCell["default"], null)))));
    expect((0, _enzymeToJson["default"])(wrapper)).toMatchSnapshot();
  });
  describe("default props", function () {
    it("sets correct default props", function () {
      var defaultProps = new _TableHeaderCell["default"]().type.defaultProps;
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeaderCell["default"], null)))));
      var component = wrapper.find("TableHeaderCell");
      expect(component.props().textAlign).toEqual(defaultProps.textAlign);
    });
  });
  describe("children prop", function () {
    it("renders given children in the th element", function () {
      var child = /*#__PURE__*/_react["default"].createElement("span", null, "child");

      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeaderCell["default"], null, child)))));
      expect(wrapper.find("TableHeaderCell").find("th").contains(child)).toEqual(true);
    });
  });
  describe("classes prop", function () {
    it("applies classes to the root node of Typography", function () {
      var classes = ["classOne"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeaderCell["default"], {
        classes: classes
      })))));
      expect(wrapper.find("TableHeaderCell").find("th").hasClass(classes[0])).toEqual(true);
    });
    it("appends higher order values to classes prop with withClasses decorator", function () {
      var classes = ["riipen", "riipen-tableheadercell"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeaderCell["default"], null)))));
      expect(wrapper.find("TableHeaderCell").props().classes.sort()).toEqual(classes.sort());
    });
  });
  describe("textAlign prop", function () {
    it("applies valid textAlign to the style", function () {
      var textAlign = "right";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeaderCell["default"], {
        textAlign: textAlign
      })))));
      expect(wrapper.find("JSXStyle").at(0).props().dynamic).toContain(textAlign);
    });
    it("gives an error given an invalid textAlign", function () {
      var errors = jest.spyOn(console, "error").mockImplementation();
      var textAlign = "middle";
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeader["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableHeaderCell["default"], {
        textAlign: textAlign
      })))));
      expect(errors).toHaveBeenCalledTimes(1);
    });
  });
});