"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Tabs = /*#__PURE__*/function (_React$Component) {
  _inherits(Tabs, _React$Component);

  var _super = _createSuper(Tabs);

  function Tabs() {
    var _this;

    _classCallCheck(this, Tabs);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (e, value) {
      var onChange = _this.props.onChange;

      if (onChange) {
        onChange(e, value);
      }
    });

    return _this;
  }

  _createClass(Tabs, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          breakpoint = _this$props.breakpoint,
          children = _this$props.children,
          classes = _this$props.classes,
          color = _this$props.color,
          Component = _this$props.component,
          letterSpacing = _this$props.letterSpacing,
          orientation = _this$props.orientation,
          textTransform = _this$props.textTransform,
          value = _this$props.value,
          variant = _this$props.variant;
      var className = (0, _clsx["default"])("root", orientation, classes);

      var childrenWithProps = _react["default"].Children.map(children, function (child) {
        if (!child) return null;
        var active = child.props.active || child.props.value === value;
        return /*#__PURE__*/_react["default"].cloneElement(child, {
          active: active,
          breakpoint: breakpoint,
          color: color,
          fullWidth: variant === "fullWidth",
          letterSpacing: letterSpacing,
          onClick: _this2.handleChange,
          orientation: orientation,
          textTransform: textTransform
        });
      });

      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(Component, {
        role: "tablist",
        className: "jsx-3443918914" + " " + (className || "")
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "jsx-3443918914" + " " + ((0, _clsx["default"])("scroller") || "")
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "jsx-3443918914" + " " + ((0, _clsx["default"])(orientation) || "")
      }, childrenWithProps))), /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "3443918914"
      }, ".root.jsx-3443918914{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;min-height:48px;overflow:hidden;}.vertical.jsx-3443918914{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-direction:column;-ms-flex-direction:column;flex-direction:column;}.scroller.jsx-3443918914{display:inline-block;-webkit-flex:1 1 auto;-ms-flex:1 1 auto;flex:1 1 auto;overflow-x:auto;position:relative;white-space:nowrap;}"));
    }
  }]);

  return Tabs;
}(_react["default"].Component);

_defineProperty(Tabs, "displayName", "Tabs");

_defineProperty(Tabs, "propTypes", {
  /**
   * The breakpoint to display the mobile tab styling. Use "none" for no styling.
   */
  breakpoint: _propTypes["default"].oneOf(["sm", "md", "lg", "xl", "none"]),

  /**
   * The content of the component.
   */
  children: _propTypes["default"].node,

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * Determines the color of the indicator.
   */
  color: _propTypes["default"].oneOf(["secondary", "primary"]),

  /**
   * The component used for the root node.
   * Either a string to use a DOM element or a component.
   */
  component: _propTypes["default"].elementType,

  /**
   * Spacing to apply to letters to the Tab.
   */
  letterSpacing: _propTypes["default"].number,

  /**
   * Callback fired when the value changes.
   *
   * @param {object} event The event source of the callback
   * @param {any} value The value of the tab.
   */
  onChange: _propTypes["default"].func,

  /**
   * The tabs orientation (layout flow direction).
   */
  orientation: _propTypes["default"].oneOf(["horizontal", "vertical"]),

  /**
   * Set the text-transform on the tabs.
   */
  textTransform: _propTypes["default"].oneOf(["inherit", "capitalize", "uppercase", "lowercase"]),

  /**
   * The value of the currently selected `Tab`.
   */
  value: _propTypes["default"].any,

  /**
   *  Determines additional display behavior of the tabs:
   *
   *  - `standard` will render the default state.
   *  -`fullWidth` will make the tabs grow to use all the available space,
   *  which should be used for small views, like on mobile.
   */
  variant: _propTypes["default"].oneOf(["standard", "fullWidth"])
});

_defineProperty(Tabs, "defaultProps", {
  breakpoint: "sm",
  color: "secondary",
  component: "div",
  orientation: "horizontal",
  textTransform: "uppercase",
  variant: "standard"
});

var _default = (0, _withClasses["default"])(Tabs);

exports["default"] = _default;