"use strict";

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _react = _interopRequireDefault(require("react"));

var _Toolbar = _interopRequireDefault(require("./Toolbar.jsx"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<Toolbar>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Toolbar["default"], null));
    } catch (e) {
      error = e;
    }

    expect(error).toEqual(undefined);
  });
  it("renders correct snapshot", function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Toolbar["default"], null));
    expect((0, _enzymeToJson["default"])(wrapper)).toMatchSnapshot();
  });
  describe("children prop", function () {
    it("renders given children inside the div element", function () {
      var child = /*#__PURE__*/_react["default"].createElement("h5", null, "hello");

      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Toolbar["default"], null, child));
      expect(wrapper.find("Toolbar").find("div").contains(child)).toEqual(true);
    });
  });
  describe("classes prop", function () {
    it("applies all classes to the div inside of Toolbar", function () {
      var classes = ["classOne"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Toolbar["default"], {
        classes: classes
      }));
      expect(wrapper.find("Toolbar").childAt(0).find("div").hasClass(classes[0])).toEqual(true);
    });
    it("appends higher order values to classes prop with withClass decorator", function () {
      var classes = ["riipen", "riipen-toolbar"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Toolbar["default"], null));
      expect(wrapper.find("Toolbar").props().classes.sort()).toEqual(classes.sort());
    });
    it("gives an error when classes are provided as one string", function () {
      var classes = "classOne classTwo";
      var errors = jest.spyOn(console, "error").mockImplementation();
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_Toolbar["default"], {
        classes: classes
      }));
      expect(errors).toHaveBeenCalled();
    });
  });
});