"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _Popover = _interopRequireDefault(require("./Popover"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Gets the opposing direction of direction1 and direction2.
 * @param {string} direction1 - first direction
 * @param {string} direction2 - opposing direction of direction1
 * @param {string} value - value to compare
 * @returns {string} Opposing direciton, or just value if directions do not oppose.
 */
var getOppositeDirection = function getOppositeDirection(direction, oppositeDirection, value) {
  if (value === direction) {
    return oppositeDirection;
  } else if (value === oppositeDirection) {
    return direction;
  }

  return value;
};

var Tooltip = function Tooltip(_ref) {
  var children = _ref.children,
      classes = _ref.classes,
      click = _ref.click,
      color = _ref.color,
      Component = _ref.component,
      hover = _ref.hover,
      isControlledByProps = _ref.isControlledByProps,
      keepOpenOnMouseLeave = _ref.keepOpenOnMouseLeave,
      onClose = _ref.onClose,
      onKeyDown = _ref.onKeyDown,
      onOpen = _ref.onOpen,
      open = _ref.open,
      position = _ref.position,
      size = _ref.size,
      tooltip = _ref.tooltip,
      other = _objectWithoutProperties(_ref, ["children", "classes", "click", "color", "component", "hover", "isControlledByProps", "keepOpenOnMouseLeave", "onClose", "onKeyDown", "onOpen", "open", "position", "size", "tooltip"]);

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  var _useState = (0, _react.useState)(isControlledByProps ? open : false),
      _useState2 = _slicedToArray(_useState, 2),
      isOpen = _useState2[0],
      setIsOpen = _useState2[1];

  var tooltipRootRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    if (isControlledByProps) {
      setIsOpen(open);
    }
  }, [isControlledByProps, open]);

  var getLinkedStyles = function getLinkedStyles() {
    return {
      styles: /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "918424231",
        dynamic: [theme.palette.common.white, theme.transitions.duration["short"], theme.transitions.easing.easeIn, theme.spacing(1), theme.spacing(4), theme.spacing(4), theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.common.white, theme.palette.grey[300], theme.palette.common.white, theme.palette.grey[300], theme.palette.text.primary, theme.spacing(2), theme.spacing(2), theme.spacing(3), theme.spacing(-4), theme.spacing(2), theme.spacing(-4), theme.spacing(2), theme.spacing(2), theme.spacing(2), theme.spacing(-4), theme.spacing(2), theme.spacing(-4), theme.spacing(2), theme.spacing(2), theme.spacing(3), theme.spacing(-4), theme.spacing(2), theme.spacing(-4), theme.spacing(-3), theme.spacing(-4), theme.spacing(2), theme.spacing(-4), theme.spacing(-3), theme.spacing(-4), theme.spacing(2), theme.spacing(2), theme.spacing(2), theme.spacing(-4), theme.spacing(2)]
      }, ".popover.__jsx-style-dynamic-selector{border-radius:2px;color:".concat(theme.palette.common.white, ";}@-webkit-keyframes fade-__jsx-style-dynamic-selector{from{opacity:0;}to:{opacity:1;}}@keyframes fade-__jsx-style-dynamic-selector{from{opacity:0;}to:{opacity:1;}}.popover.show.__jsx-style-dynamic-selector{-webkit-animation:fade-__jsx-style-dynamic-selector ").concat(theme.transitions.duration["short"], "ms ").concat(theme.transitions.easing.easeIn, ";animation:fade-__jsx-style-dynamic-selector ").concat(theme.transitions.duration["short"], "ms ").concat(theme.transitions.easing.easeIn, ";}.popover.small.__jsx-style-dynamic-selector{padding:").concat(theme.spacing(1), "px ").concat(theme.spacing(4), "px;}.popover.medium.__jsx-style-dynamic-selector{padding:").concat(theme.spacing(4), "px;}.popover.default.__jsx-style-dynamic-selector{--after-color:").concat(theme.palette.grey[600], ";--before-color:").concat(theme.palette.grey[600], ";background:").concat(theme.palette.grey[600], ";border:1px solid ").concat(theme.palette.grey[600], ";}.popover.negative.__jsx-style-dynamic-selector{--after-color:").concat(theme.palette.negative.main, ";--before-color:").concat(theme.palette.negative.main, ";background:").concat(theme.palette.negative.main, ";border:1px solid ").concat(theme.palette.negative.main, ";}.popover.positive.__jsx-style-dynamic-selector{--after-color:").concat(theme.palette.positive.main, ";--before-color:").concat(theme.palette.positive.main, ";background:").concat(theme.palette.positive.main, ";border:1px solid ").concat(theme.palette.positive.main, ";}.popover.warning.__jsx-style-dynamic-selector{--after-color:").concat(theme.palette.warning.main, ";--before-color:").concat(theme.palette.warning.main, ";background:").concat(theme.palette.warning.main, ";border:1px solid ").concat(theme.palette.warning.main, ";}.popover.white.__jsx-style-dynamic-selector{--after-color:").concat(theme.palette.common.white, ";--before-color:").concat(theme.palette.grey[300], ";background:").concat(theme.palette.common.white, ";border:1px solid ").concat(theme.palette.grey[300], ";color:").concat(theme.palette.text.primary, ";}.popover.__jsx-style-dynamic-selector::before{border-color:transparent;border-style:solid;border-width:").concat(theme.spacing(2), "px;content:\"\";position:absolute;white-space:normal;}.popover.__jsx-style-dynamic-selector::after{border-color:transparent;border-style:solid;border-width:calc(").concat(theme.spacing(2), "px - 1px);content:\"\";position:absolute;white-space:normal;}.popover.bottom.__jsx-style-dynamic-selector{margin-top:").concat(theme.spacing(3), "px;}.popover.bottom.__jsx-style-dynamic-selector::before{margin-top:").concat(theme.spacing(-4), "px;top:0;}.popover.bottom.__jsx-style-dynamic-selector::after{margin-top:-17px;top:0;}.popover.bottom-right.__jsx-style-dynamic-selector{border-top-left-radius:0;}.popover.bottom-right.__jsx-style-dynamic-selector::before{border-bottom-color:var(--before-color);border-left:none;left:0;margin-left:-1px;}.popover.bottom-right.__jsx-style-dynamic-selector::after{border-bottom-color:var(--after-color);border-left:none;border-width:").concat(theme.spacing(2), "px;left:0;margin-top:calc(").concat(theme.spacing(-4), "px + 1px);}.popover.bottom-center.__jsx-style-dynamic-selector::before{border-bottom-color:var(--before-color);left:calc(50% - (").concat(theme.spacing(2), "px));}.popover.bottom-center.__jsx-style-dynamic-selector::after{border-bottom-color:var(--after-color);border-width:").concat(theme.spacing(2), "px;left:calc(50% - ").concat(theme.spacing(2), "px);margin-top:calc(").concat(theme.spacing(-4), "px + 1px);}.popover.bottom-left.__jsx-style-dynamic-selector{border-top-right-radius:0;}.popover.bottom-left.__jsx-style-dynamic-selector::before{border-bottom-color:var(--before-color);border-right:none;margin-right:-1px;right:0;}.popover.bottom-left.__jsx-style-dynamic-selector::after{border-bottom-color:var(--after-color);border-right:none;border-width:").concat(theme.spacing(2), "px;margin-top:calc(").concat(theme.spacing(-4), "px + 1px);right:0;}.popover.center.__jsx-style-dynamic-selector::before{top:calc(50% - ").concat(theme.spacing(2), "px);}.popover.center.__jsx-style-dynamic-selector::after{top:calc(50% - ").concat(theme.spacing(2), "px);}.popover.center-right.__jsx-style-dynamic-selector{margin-left:").concat(theme.spacing(3), "px;}.popover.center-right.__jsx-style-dynamic-selector::before{border-right-color:var(--before-color);left:0;margin-left:").concat(theme.spacing(-4), "px;}.popover.center-right.__jsx-style-dynamic-selector::after{border-right-color:var(--after-color);border-width:").concat(theme.spacing(2), "px;left:0;margin-left:calc(").concat(theme.spacing(-4), "px + 1px);}.popover.center-left.__jsx-style-dynamic-selector{margin-left:").concat(theme.spacing(-3), "px;}.popover.center-left.__jsx-style-dynamic-selector::before{border-left-color:var(--before-color);margin-right:").concat(theme.spacing(-4), "px;right:0;}.popover.center-left.__jsx-style-dynamic-selector::after{border-left-color:var(--after-color);border-width:").concat(theme.spacing(2), "px;margin-right:calc(").concat(theme.spacing(-4), "px + 1px);right:0;}.popover.top.__jsx-style-dynamic-selector{margin-top:").concat(theme.spacing(-3), "px;}.popover.top.__jsx-style-dynamic-selector::before{bottom:0;margin-bottom:").concat(theme.spacing(-4), "px;}.popover.top.__jsx-style-dynamic-selector::after{bottom:0;margin-bottom:-17px;}.popover.top-right.__jsx-style-dynamic-selector{border-bottom-left-radius:0;}.popover.top-right.__jsx-style-dynamic-selector::before{border-left:none;border-top-color:var(--before-color);left:0;margin-left:-1px;}.popover.top-right.__jsx-style-dynamic-selector::after{border-left:none;border-top-color:var(--after-color);left:0;}.popover.top-center.__jsx-style-dynamic-selector::before{border-top-color:var(--before-color);left:calc(50% - ").concat(theme.spacing(2), "px);}.popover.top-center.__jsx-style-dynamic-selector::after{border-top-color:var(--after-color);border-width:").concat(theme.spacing(2), "px;left:calc(50% - ").concat(theme.spacing(2), "px);margin-bottom:calc(").concat(theme.spacing(-4), "px + 1px);}.popover.top-left.__jsx-style-dynamic-selector{border-bottom-right-radius:0;}.popover.top-left.__jsx-style-dynamic-selector::before{border-right:none;border-top-color:var(--before-color);border-width:").concat(theme.spacing(2), "px;margin-right:-1px;right:0;}.popover.top-left.__jsx-style-dynamic-selector::after{border-right:none;border-top-color:var(--after-color);right:0;}")),
      className: _style["default"].dynamic([["918424231", [theme.palette.common.white, theme.transitions.duration["short"], theme.transitions.easing.easeIn, theme.spacing(1), theme.spacing(4), theme.spacing(4), theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.grey[600], theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.negative.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.positive.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.warning.main, theme.palette.common.white, theme.palette.grey[300], theme.palette.common.white, theme.palette.grey[300], theme.palette.text.primary, theme.spacing(2), theme.spacing(2), theme.spacing(3), theme.spacing(-4), theme.spacing(2), theme.spacing(-4), theme.spacing(2), theme.spacing(2), theme.spacing(2), theme.spacing(-4), theme.spacing(2), theme.spacing(-4), theme.spacing(2), theme.spacing(2), theme.spacing(3), theme.spacing(-4), theme.spacing(2), theme.spacing(-4), theme.spacing(-3), theme.spacing(-4), theme.spacing(2), theme.spacing(-4), theme.spacing(-3), theme.spacing(-4), theme.spacing(2), theme.spacing(2), theme.spacing(2), theme.spacing(-4), theme.spacing(2)]]])
    };
  };

  var handleOpen = function handleOpen() {
    if (!isControlledByProps) setIsOpen(true);

    if (onOpen) {
      onOpen();
    }
  };

  var handleClose = function handleClose() {
    if (!isControlledByProps) setIsOpen(false);

    if (onClose) {
      onClose();
    }
  };

  var clickCallback = function clickCallback() {
    return isOpen ? handleClose() : handleOpen();
  };

  var _position$split = position.split("-"),
      _position$split2 = _slicedToArray(_position$split, 2),
      vertical = _position$split2[0],
      horizontal = _position$split2[1];

  var contentPosition = {
    horizontal: getOppositeDirection("left", "right", horizontal),
    vertical: getOppositeDirection("top", "bottom", vertical)
  };
  var linkedStyles = getLinkedStyles();
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(Component, {
    ref: tooltipRootRef,
    onClick: click ? clickCallback : undefined,
    onMouseEnter: hover ? handleOpen : null,
    onMouseLeave: hover && !keepOpenOnMouseLeave ? handleClose : null
  }, children), /*#__PURE__*/_react["default"].createElement(_Popover["default"], _extends({
    classes: classes.concat([linkedStyles.className, "popover", color, position, vertical, size, isOpen && "show"]),
    anchorPosition: {
      horizontal: horizontal,
      vertical: vertical
    },
    contentPosition: contentPosition,
    onKeyDown: onKeyDown,
    anchorEl: tooltipRootRef.current,
    isOpen: isOpen,
    keepOnScreen: true,
    lockScroll: false,
    onClose: handleClose
  }, other), tooltip), linkedStyles.styles);
};

Tooltip.displayName = "Tooltip";
Tooltip.propTypes = {
  /**
   * The content to trigger the tooltip with.
   */
  children: _propTypes["default"].node,

  /**
   * Any additional classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * Whether tooltip should display on click.
   */
  click: _propTypes["default"].bool,

  /**
   * Color of tooltip.
   */
  color: _propTypes["default"].oneOf(["default", "white", "positive", "negative", "warning"]),

  /**
   * The component used for the root node.
   * Either a string to use a DOM element or a component.
   */
  component: _propTypes["default"].elementType,

  /**
   * Whether tooltip should display on hover.
   */
  hover: _propTypes["default"].bool,

  /**
   * How the open/close state will be determined:
   * [Default] false: by this component's state,
   * true: by this component's props.
   */
  isControlledByProps: _propTypes["default"].bool,

  /**
   * Whether the popover should stay open after leaving the content.
   */
  keepOpenOnMouseLeave: _propTypes["default"].bool,

  /**
   * Function to call on tooltip close.
   */
  onClose: _propTypes["default"].func,

  /**
   * Function to call on tooltip keydown.
   */
  onKeyDown: _propTypes["default"].func,

  /**
   * Function to call on tooltip open.
   */
  onOpen: _propTypes["default"].func,

  /**
   * Whether the popover should be open/shown.
   * Only used when props.isControlledByProps is true
   * [Default] false
   */
  open: _propTypes["default"].bool,

  /**
   * Where to display the tooltip in relation to element.
   */
  position: _propTypes["default"].oneOf(["top-right", "top-center", "top-left", "center-right", "center-left", "bottom-right", "bottom-center", "bottom-left"]),

  /**
   * The size of the tooltip.
   */
  size: _propTypes["default"].oneOf(["small", "medium"]),

  /**
   * The tooltip content to display.
   */
  tooltip: _propTypes["default"].node
};
Tooltip.defaultProps = {
  classes: [],
  click: false,
  color: "default",
  component: "div",
  hover: true,
  isControlledByProps: false,
  open: false,
  keepOpenOnMouseLeave: false,
  position: "bottom-center",
  size: "small"
};

var _default = (0, _withClasses["default"])(Tooltip);

exports["default"] = _default;