"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var variantMapping = {
  h1: "h1",
  h2: "h2",
  h3: "h3",
  h4: "h4",
  h5: "h5",
  h6: "h6",
  subtitle1: "h6",
  subtitle2: "h6",
  body1: "p",
  body2: "p"
};

var Typography = /*#__PURE__*/function (_React$Component) {
  _inherits(Typography, _React$Component);

  var _super = _createSuper(Typography);

  function Typography() {
    _classCallCheck(this, Typography);

    return _super.apply(this, arguments);
  }

  _createClass(Typography, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          classes = _this$props.classes,
          color = _this$props.color,
          component = _this$props.component,
          display = _this$props.display,
          fontWeight = _this$props.fontWeight,
          gutter = _this$props.gutter,
          letterSpacing = _this$props.letterSpacing,
          mobileBreakpoint = _this$props.mobileBreakpoint,
          textAlign = _this$props.textAlign,
          textTransform = _this$props.textTransform,
          variant = _this$props.variant,
          wordBreak = _this$props.wordBreak;
      var theme = this.context;
      var className = (0, _clsx["default"])("root", "color-".concat(color), display, fontWeight, gutter ? "gutter" : null, letterSpacing ? 'letter-spacing' : null, mobileBreakpoint ? "mobile" : null, variant, "align-".concat(textAlign), "transform-".concat(textTransform), wordBreak ? "word-break-".concat(wordBreak) : null, classes);
      var Component = component || variantMapping[variant] || "span";
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(Component, {
        className: _style["default"].dynamic([["172326200", [theme.palette.grey[800], theme.typography.body1.fontFamily, theme.typography.body1.fontWeight, theme.typography.body1.fontSize, theme.typography.body1.lineHeight, theme.typography.body1.letterSpacing, theme.palette.grey[800], theme.typography.body2.fontFamily, theme.typography.body2.fontWeight, theme.typography.body2.fontSize, theme.typography.body2.lineHeight, theme.typography.body2.letterSpacing, theme.palette.grey[800], theme.typography.body3.fontFamily, theme.typography.body3.fontWeight, theme.typography.body3.fontSize, theme.typography.body3.lineHeight, theme.typography.body3.letterSpacing, theme.palette.grey.A400, theme.typography.h1.fontFamily, theme.typography.h1.fontWeight, theme.typography.h1.fontSize, theme.typography.h1.lineHeight, theme.typography.h1.letterSpacing, theme.palette.grey.A400, theme.typography.h2.fontFamily, theme.typography.h2.fontWeight, theme.typography.h2.fontSize, theme.typography.h2.lineHeight, theme.typography.h2.letterSpacing, theme.palette.grey.A400, theme.typography.h3.fontFamily, theme.typography.h3.fontWeight, theme.typography.h3.fontSize, theme.typography.h3.lineHeight, theme.typography.h3.letterSpacing, theme.palette.grey.A400, theme.typography.h4.fontFamily, theme.typography.h4.fontWeight, theme.typography.h4.fontSize, theme.typography.h4.lineHeight, theme.typography.h4.letterSpacing, theme.palette.grey.A400, theme.typography.h5.fontFamily, theme.typography.h5.fontWeight, theme.typography.h5.fontSize, theme.typography.h5.lineHeight, theme.typography.h5.letterSpacing, theme.palette.common.black, theme.palette.text.disabled, theme.palette.grey[500], theme.palette.grey[600], theme.palette.grey[800], theme.palette.grey.A400, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.warning.main, theme.palette.common.white, theme.typography.fontWeight.bold, theme.typography.fontWeight.light, theme.typography.fontWeight.medium, theme.typography.fontWeight.regular, letterSpacing, theme.breakpoints[mobileBreakpoint], theme.typography.body1.mobile.fontSize, theme.typography.body1.mobile.lineHeight, theme.typography.body2.mobile.fontSize, theme.typography.body2.mobile.lineHeight, theme.typography.body3.mobile.fontSize, theme.typography.body3.mobile.lineHeight, theme.typography.h1.mobile.fontSize, theme.typography.h1.mobile.lineHeight, theme.typography.h2.mobile.fontSize, theme.typography.h2.mobile.lineHeight, theme.typography.h3.mobile.fontSize, theme.typography.h3.mobile.lineHeight, theme.typography.h4.mobile.fontSize, theme.typography.h4.mobile.lineHeight, theme.typography.h5.mobile.fontSize, theme.typography.h5.mobile.lineHeight]]]) + " " + (className || "")
      }, children), /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "172326200",
        dynamic: [theme.palette.grey[800], theme.typography.body1.fontFamily, theme.typography.body1.fontWeight, theme.typography.body1.fontSize, theme.typography.body1.lineHeight, theme.typography.body1.letterSpacing, theme.palette.grey[800], theme.typography.body2.fontFamily, theme.typography.body2.fontWeight, theme.typography.body2.fontSize, theme.typography.body2.lineHeight, theme.typography.body2.letterSpacing, theme.palette.grey[800], theme.typography.body3.fontFamily, theme.typography.body3.fontWeight, theme.typography.body3.fontSize, theme.typography.body3.lineHeight, theme.typography.body3.letterSpacing, theme.palette.grey.A400, theme.typography.h1.fontFamily, theme.typography.h1.fontWeight, theme.typography.h1.fontSize, theme.typography.h1.lineHeight, theme.typography.h1.letterSpacing, theme.palette.grey.A400, theme.typography.h2.fontFamily, theme.typography.h2.fontWeight, theme.typography.h2.fontSize, theme.typography.h2.lineHeight, theme.typography.h2.letterSpacing, theme.palette.grey.A400, theme.typography.h3.fontFamily, theme.typography.h3.fontWeight, theme.typography.h3.fontSize, theme.typography.h3.lineHeight, theme.typography.h3.letterSpacing, theme.palette.grey.A400, theme.typography.h4.fontFamily, theme.typography.h4.fontWeight, theme.typography.h4.fontSize, theme.typography.h4.lineHeight, theme.typography.h4.letterSpacing, theme.palette.grey.A400, theme.typography.h5.fontFamily, theme.typography.h5.fontWeight, theme.typography.h5.fontSize, theme.typography.h5.lineHeight, theme.typography.h5.letterSpacing, theme.palette.common.black, theme.palette.text.disabled, theme.palette.grey[500], theme.palette.grey[600], theme.palette.grey[800], theme.palette.grey.A400, theme.palette.primary.main, theme.palette.secondary.main, theme.palette.tertiary.main, theme.palette.positive.main, theme.palette.negative.main, theme.palette.warning.main, theme.palette.common.white, theme.typography.fontWeight.bold, theme.typography.fontWeight.light, theme.typography.fontWeight.medium, theme.typography.fontWeight.regular, letterSpacing, theme.breakpoints[mobileBreakpoint], theme.typography.body1.mobile.fontSize, theme.typography.body1.mobile.lineHeight, theme.typography.body2.mobile.fontSize, theme.typography.body2.mobile.lineHeight, theme.typography.body3.mobile.fontSize, theme.typography.body3.mobile.lineHeight, theme.typography.h1.mobile.fontSize, theme.typography.h1.mobile.lineHeight, theme.typography.h2.mobile.fontSize, theme.typography.h2.mobile.lineHeight, theme.typography.h3.mobile.fontSize, theme.typography.h3.mobile.lineHeight, theme.typography.h4.mobile.fontSize, theme.typography.h4.mobile.lineHeight, theme.typography.h5.mobile.fontSize, theme.typography.h5.mobile.lineHeight]
      }, ".root.__jsx-style-dynamic-selector{margin:0;}.block.__jsx-style-dynamic-selector{display:block;}.inline.__jsx-style-dynamic-selector{display:inline;}.gutter.__jsx-style-dynamic-selector{margin-bottom:0.35em;}.align-center.__jsx-style-dynamic-selector{text-align:center;}.align-left.__jsx-style-dynamic-selector{text-align:left;}.align-right.__jsx-style-dynamic-selector{text-align:right;}.body1.__jsx-style-dynamic-selector{color:".concat(theme.palette.grey[800], ";font-family:").concat(theme.typography.body1.fontFamily, ";font-weight:").concat(theme.typography.body1.fontWeight, ";font-size:").concat(theme.typography.body1.fontSize, ";line-height:").concat(theme.typography.body1.lineHeight, ";-webkit-letter-spacing:").concat(theme.typography.body1.letterSpacing, ";-moz-letter-spacing:").concat(theme.typography.body1.letterSpacing, ";-ms-letter-spacing:").concat(theme.typography.body1.letterSpacing, ";letter-spacing:").concat(theme.typography.body1.letterSpacing, ";}.body2.__jsx-style-dynamic-selector{color:").concat(theme.palette.grey[800], ";font-family:").concat(theme.typography.body2.fontFamily, ";font-weight:").concat(theme.typography.body2.fontWeight, ";font-size:").concat(theme.typography.body2.fontSize, ";line-height:").concat(theme.typography.body2.lineHeight, ";-webkit-letter-spacing:").concat(theme.typography.body2.letterSpacing, ";-moz-letter-spacing:").concat(theme.typography.body2.letterSpacing, ";-ms-letter-spacing:").concat(theme.typography.body2.letterSpacing, ";letter-spacing:").concat(theme.typography.body2.letterSpacing, ";}.body3.__jsx-style-dynamic-selector{color:").concat(theme.palette.grey[800], ";font-family:").concat(theme.typography.body3.fontFamily, ";font-weight:").concat(theme.typography.body3.fontWeight, ";font-size:").concat(theme.typography.body3.fontSize, ";line-height:").concat(theme.typography.body3.lineHeight, ";-webkit-letter-spacing:").concat(theme.typography.body3.letterSpacing, ";-moz-letter-spacing:").concat(theme.typography.body3.letterSpacing, ";-ms-letter-spacing:").concat(theme.typography.body3.letterSpacing, ";letter-spacing:").concat(theme.typography.body3.letterSpacing, ";}.h1.__jsx-style-dynamic-selector{color:").concat(theme.palette.grey.A400, ";font-family:").concat(theme.typography.h1.fontFamily, ";font-weight:").concat(theme.typography.h1.fontWeight, ";font-size:").concat(theme.typography.h1.fontSize, ";line-height:").concat(theme.typography.h1.lineHeight, ";-webkit-letter-spacing:").concat(theme.typography.h1.letterSpacing, ";-moz-letter-spacing:").concat(theme.typography.h1.letterSpacing, ";-ms-letter-spacing:").concat(theme.typography.h1.letterSpacing, ";letter-spacing:").concat(theme.typography.h1.letterSpacing, ";}.h2.__jsx-style-dynamic-selector{color:").concat(theme.palette.grey.A400, ";font-family:").concat(theme.typography.h2.fontFamily, ";font-weight:").concat(theme.typography.h2.fontWeight, ";font-size:").concat(theme.typography.h2.fontSize, ";line-height:").concat(theme.typography.h2.lineHeight, ";-webkit-letter-spacing:").concat(theme.typography.h2.letterSpacing, ";-moz-letter-spacing:").concat(theme.typography.h2.letterSpacing, ";-ms-letter-spacing:").concat(theme.typography.h2.letterSpacing, ";letter-spacing:").concat(theme.typography.h2.letterSpacing, ";}.h3.__jsx-style-dynamic-selector{color:").concat(theme.palette.grey.A400, ";font-family:").concat(theme.typography.h3.fontFamily, ";font-weight:").concat(theme.typography.h3.fontWeight, ";font-size:").concat(theme.typography.h3.fontSize, ";line-height:").concat(theme.typography.h3.lineHeight, ";-webkit-letter-spacing:").concat(theme.typography.h3.letterSpacing, ";-moz-letter-spacing:").concat(theme.typography.h3.letterSpacing, ";-ms-letter-spacing:").concat(theme.typography.h3.letterSpacing, ";letter-spacing:").concat(theme.typography.h3.letterSpacing, ";}.h4.__jsx-style-dynamic-selector{color:").concat(theme.palette.grey.A400, ";font-family:").concat(theme.typography.h4.fontFamily, ";font-weight:").concat(theme.typography.h4.fontWeight, ";font-size:").concat(theme.typography.h4.fontSize, ";line-height:").concat(theme.typography.h4.lineHeight, ";-webkit-letter-spacing:").concat(theme.typography.h4.letterSpacing, ";-moz-letter-spacing:").concat(theme.typography.h4.letterSpacing, ";-ms-letter-spacing:").concat(theme.typography.h4.letterSpacing, ";letter-spacing:").concat(theme.typography.h4.letterSpacing, ";}.h5.__jsx-style-dynamic-selector{color:").concat(theme.palette.grey.A400, ";font-family:").concat(theme.typography.h5.fontFamily, ";font-weight:").concat(theme.typography.h5.fontWeight, ";font-size:").concat(theme.typography.h5.fontSize, ";line-height:").concat(theme.typography.h5.lineHeight, ";-webkit-letter-spacing:").concat(theme.typography.h5.letterSpacing, ";-moz-letter-spacing:").concat(theme.typography.h5.letterSpacing, ";-ms-letter-spacing:").concat(theme.typography.h5.letterSpacing, ";letter-spacing:").concat(theme.typography.h5.letterSpacing, ";}.color-inherit.__jsx-style-dynamic-selector{color:inherit;}.color-initial.__jsx-style-dynamic-selector{color:initial;}.color-black.__jsx-style-dynamic-selector{color:").concat(theme.palette.common.black, ";}.color-disabled.__jsx-style-dynamic-selector{color:").concat(theme.palette.text.disabled, ";}.color-grey500.__jsx-style-dynamic-selector{color:").concat(theme.palette.grey[500], ";}.color-grey600.__jsx-style-dynamic-selector{color:").concat(theme.palette.grey[600], ";}.color-grey800.__jsx-style-dynamic-selector{color:").concat(theme.palette.grey[800], ";}.color-greyA400.__jsx-style-dynamic-selector{color:").concat(theme.palette.grey.A400, ";}.color-primary.__jsx-style-dynamic-selector{color:").concat(theme.palette.primary.main, ";}.color-secondary.__jsx-style-dynamic-selector{color:").concat(theme.palette.secondary.main, ";}.color-tertiary.__jsx-style-dynamic-selector{color:").concat(theme.palette.tertiary.main, ";}.color-positive.__jsx-style-dynamic-selector{color:").concat(theme.palette.positive.main, ";}.color-negative.__jsx-style-dynamic-selector{color:").concat(theme.palette.negative.main, ";}.color-warning.__jsx-style-dynamic-selector{color:").concat(theme.palette.warning.main, ";}.color-white.__jsx-style-dynamic-selector{color:").concat(theme.palette.common.white, ";}.bold.__jsx-style-dynamic-selector{font-weight:").concat(theme.typography.fontWeight.bold, ";}.light.__jsx-style-dynamic-selector{font-weight:").concat(theme.typography.fontWeight.light, ";}.medium.__jsx-style-dynamic-selector{font-weight:").concat(theme.typography.fontWeight.medium, ";}.regular.__jsx-style-dynamic-selector{font-weight:").concat(theme.typography.fontWeight.regular, ";}.letter-spacing.__jsx-style-dynamic-selector{-webkit-letter-spacing:").concat(letterSpacing, "px;-moz-letter-spacing:").concat(letterSpacing, "px;-ms-letter-spacing:").concat(letterSpacing, "px;letter-spacing:").concat(letterSpacing, "px;}.transform-capitalize.__jsx-style-dynamic-selector{text-transform:capitalize;}.transform-uppercase.__jsx-style-dynamic-selector{text-transform:uppercase;}.transform-lowercase.__jsx-style-dynamic-selector{text-transform:lowercase;}.word-break-break-all.__jsx-style-dynamic-selector{word-break:break-all;}.word-break-break-word.__jsx-style-dynamic-selector{word-break:break-word;}.word-break-normal.__jsx-style-dynamic-selector{word-break:normal;}@media (max-width:").concat(theme.breakpoints[mobileBreakpoint], "px){.body1.mobile.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.body1.mobile.fontSize, ";line-height:").concat(theme.typography.body1.mobile.lineHeight, ";}.body2.mobile.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.body2.mobile.fontSize, ";line-height:").concat(theme.typography.body2.mobile.lineHeight, ";}.body3.mobile.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.body3.mobile.fontSize, ";line-height:").concat(theme.typography.body3.mobile.lineHeight, ";}.h1.mobile.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.h1.mobile.fontSize, ";line-height:").concat(theme.typography.h1.mobile.lineHeight, ";}.h2.mobile.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.h2.mobile.fontSize, ";line-height:").concat(theme.typography.h2.mobile.lineHeight, ";}.h3.mobile.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.h3.mobile.fontSize, ";line-height:").concat(theme.typography.h3.mobile.lineHeight, ";}.h4.mobile.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.h4.mobile.fontSize, ";line-height:").concat(theme.typography.h4.mobile.lineHeight, ";}.h5.mobile.__jsx-style-dynamic-selector{font-size:").concat(theme.typography.h5.mobile.fontSize, ";line-height:").concat(theme.typography.h5.mobile.lineHeight, ";}}")));
    }
  }]);

  return Typography;
}(_react["default"].Component);

_defineProperty(Typography, "displayName", "Typography");

_defineProperty(Typography, "propTypes", {
  /**
   * The content of the component.
   */
  children: _propTypes["default"].node,

  /**
   * An array of custom CSS classes to apply.
   */
  classes: _propTypes["default"].array,

  /**
   * The color of the component. It supports those theme colors that make sense for this component.
   */
  color: _propTypes["default"].oneOf(["inherit", "initial", "black", "disabled", "grey500", "grey600", "grey800", "greyA400", "negative", "positive", "primary", "secondary", "tertiary", "warning", "white"]),

  /**
   * The component used for the root node.
   * Either a string to use a DOM element or a component.
   * By default, it maps the variant to a good default headline component.
   */
  component: _propTypes["default"].elementType,

  /**
   * Controls the display type.
   */
  display: _propTypes["default"].oneOf(["initial", "block", "inline"]),

  /**
   * Set the font weight on the component.
   */
  fontWeight: _propTypes["default"].oneOf(["bold", "light", "medium", "regular"]),

  /**
   * If true, the text will have a bottom margin.
   */
  gutter: _propTypes["default"].bool,

  /**
   * Custom spacing to apply to letters to the Typography.
   */
  letterSpacing: _propTypes["default"].number,

  /**
   * Screen size to render font from desktop to mobile.
   */
  mobileBreakpoint: _propTypes["default"].oneOf(["xs", "sm", "md", "lg", "xl"]),

  /**
   * Set the text-align on the component.
   */
  textAlign: _propTypes["default"].oneOf(["inherit", "left", "center", "right", "justify"]),

  /**
   * Set the text-transform on the component.
   */
  textTransform: _propTypes["default"].oneOf(["inherit", "capitalize", "uppercase", "lowercase"]),

  /**
   * Applies the theme typography styles.
   */
  variant: _propTypes["default"].oneOf(["h1", "h2", "h3", "h4", "h5", "h6", "body1", "body2", "body3", "inherit"]),

  /**
   * Set the word break on the component.
   */
  wordBreak: _propTypes["default"].oneOf(["break-all", "break-word", "normal"])
});

_defineProperty(Typography, "defaultProps", {
  classes: [],
  color: "inherit",
  display: "initial",
  gutter: false,
  mobileBreakpoint: "sm",
  textAlign: "inherit",
  textTransform: "inherit",
  variant: "body1"
});

_defineProperty(Typography, "contextType", _ThemeContext["default"]);

var _default = (0, _withClasses["default"])(Typography);

exports["default"] = _default;