"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var VerticalDivider = function VerticalDivider(props) {
  var classes = props.classes,
      spacing = props.spacing,
      theme = props.theme,
      width = props.width;
  var className = (0, _clsx["default"])(classes);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: _style["default"].dynamic([["3218977506", [theme.palette.divider, width, theme.spacing(spacing), theme.spacing(spacing)]]]) + " " + (className || "")
  }), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "3218977506",
    dynamic: [theme.palette.divider, width, theme.spacing(spacing), theme.spacing(spacing)]
  }, "div.__jsx-style-dynamic-selector{background-color:".concat(theme.palette.divider, ";width:").concat(width, "px;margin-left:").concat(theme.spacing(spacing), "px;margin-right:").concat(theme.spacing(spacing), "px;}")));
};

VerticalDivider.propTypes = {
  /**
   * List of additional classes to apply to this component.
   */
  classes: _propTypes["default"].array,

  /**
   * Additional spacing based in theme spacing multiplier to apply after each list item.
   */
  spacing: _propTypes["default"].number,

  /**
   * @ignore
   * The theme context object.
   */
  theme: _propTypes["default"].object,

  /**
   * The width of the divider in pixels.
   */
  width: _propTypes["default"].number
};
VerticalDivider.defaultProps = {
  classes: [],
  spacing: 2,
  width: 1
};
VerticalDivider.displayName = "VerticalDivider";

var _default = (0, _utils.withThemeContext)(VerticalDivider);

exports["default"] = _default;