"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _Grid = _interopRequireDefault(require("./Grid"));

var _GridItem = _interopRequireDefault(require("./GridItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var VerticalProgressBar = function VerticalProgressBar(_ref) {
  var children = _ref.children,
      classes = _ref.classes;
  return /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
    classes: classes,
    spacing: 0
  }, _react["default"].Children.map(children, function (child, index) {
    return /*#__PURE__*/_react["default"].createElement(_GridItem["default"], {
      key: "progress-".concat(index)
    }, index === children.length - 1 ? /*#__PURE__*/_react["default"].cloneElement(child, {
      bar: false
    }) : child);
  }));
};

VerticalProgressBar.propTypes = {
  // external

  /**
   * The progresses to display.
   */
  children: _propTypes["default"].node,

  /**
   * Additional classes to style with.
   */
  classes: _propTypes["default"].array
};
VerticalProgressBar.defaultProps = {
  children: [],
  classes: []
};

var _default = (0, _withClasses["default"])(VerticalProgressBar);

exports["default"] = _default;