"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _reactFontawesome = require("@fortawesome/react-fontawesome");

var _clsx = _interopRequireDefault(require("clsx"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _style = _interopRequireDefault(require("styled-jsx/style"));

var _ThemeContext = _interopRequireDefault(require("../styles/ThemeContext"));

var _withClasses = _interopRequireDefault(require("../utils/withClasses"));

var _Grid = _interopRequireDefault(require("./Grid"));

var _GridItem = _interopRequireDefault(require("./GridItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var VerticalProgressBarItem = function VerticalProgressBarItem(_ref) {
  var bar = _ref.bar,
      children = _ref.children,
      classes = _ref.classes,
      color = _ref.color,
      icon = _ref.icon;

  var theme = _react["default"].useContext(_ThemeContext["default"]);

  var getLinkedStyles = function getLinkedStyles() {
    return {
      styles: /*#__PURE__*/_react["default"].createElement(_style["default"], {
        id: "3174789173",
        dynamic: [theme.palette.common.white, theme.zIndex.low]
      }, ".icon.__jsx-style-dynamic-selector{color:".concat(theme.palette.common.white, ";z-index:").concat(theme.zIndex.low, ";}")),
      className: _style["default"].dynamic([["3174789173", [theme.palette.common.white, theme.zIndex.low]]])
    };
  };

  var linkedStyles = getLinkedStyles();
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _style["default"].dynamic([["3229497486", [theme.palette.grey[300], theme.palette.positive.main, theme.palette.warning.main, theme.spacing(3), theme.palette.grey[300], theme.palette.positive.main, theme.palette.warning.main, theme.spacing(7), theme.spacing(5)]]]) + " " + ((0, _clsx["default"])("progress", color && bar && "progress-".concat(color), !bar && "progress-none", classes) || "")
  }, /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
    classes: [linkedStyles.className, "wrapper"],
    spacing: 0
  }, /*#__PURE__*/_react["default"].createElement(_GridItem["default"], {
    lg: "auto"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _style["default"].dynamic([["3229497486", [theme.palette.grey[300], theme.palette.positive.main, theme.palette.warning.main, theme.spacing(3), theme.palette.grey[300], theme.palette.positive.main, theme.palette.warning.main, theme.spacing(7), theme.spacing(5)]]]) + " " + ((0, _clsx["default"])("iconWrapper", color && "".concat(color)) || "")
  }, !!icon && /*#__PURE__*/_react["default"].createElement(_reactFontawesome.FontAwesomeIcon, {
    className: (0, _clsx["default"])(linkedStyles.className, "icon"),
    size: "sm",
    icon: icon
  }))), /*#__PURE__*/_react["default"].createElement(_GridItem["default"], {
    flexGrow: 1,
    flexShrink: 1,
    lg: 10
  }, children)), /*#__PURE__*/_react["default"].createElement(_style["default"], {
    id: "3229497486",
    dynamic: [theme.palette.grey[300], theme.palette.positive.main, theme.palette.warning.main, theme.spacing(3), theme.palette.grey[300], theme.palette.positive.main, theme.palette.warning.main, theme.spacing(7), theme.spacing(5)]
  }, ".default.__jsx-style-dynamic-selector{background-color:".concat(theme.palette.grey[300], ";}.positive.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.positive.main, ";}.warning.__jsx-style-dynamic-selector{background-color:").concat(theme.palette.warning.main, ";}.progress.__jsx-style-dynamic-selector{border-left:8px solid var(--border-color);margin-left:").concat(theme.spacing(3), "px;}.progress-default.__jsx-style-dynamic-selector{--border-color:").concat(theme.palette.grey[300], ";}.progress-none.__jsx-style-dynamic-selector{--border-color:transparent;}.progress-positive.__jsx-style-dynamic-selector{--border-color:").concat(theme.palette.positive.main, ";}.progress-warning.__jsx-style-dynamic-selector{--border-color:").concat(theme.palette.warning.main, ";}.iconWrapper.__jsx-style-dynamic-selector{-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;border-radius:50%;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;height:24px;-webkit-box-pack:center;-webkit-justify-content:center;-ms-flex-pack:center;justify-content:center;margin-bottom:").concat(theme.spacing(7), "px;margin-left:-16px;margin-right:").concat(theme.spacing(5), "px;margin-top:-1px;width:24px;}")), linkedStyles.styles);
};

VerticalProgressBarItem.propTypes = {
  // external

  /**
   * The content to render inside.
   */
  children: _propTypes["default"].node,

  /**
   * Additional classes to style with.
   */
  classes: _propTypes["default"].array,

  /**
   * The colour of the progress icon.
   */
  color: _propTypes["default"].oneOf(["positive", "warning", "default"]),

  /**
   * The progress icon.
   */
  icon: _propTypes["default"].object,

  /**
   * Whether to not have bar.
   */
  bar: _propTypes["default"].bool
};
VerticalProgressBarItem.defaultProps = {
  bar: true,
  classes: []
};

var _default = (0, _withClasses["default"])(VerticalProgressBarItem);

exports["default"] = _default;