"use strict";

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _react = _interopRequireDefault(require("react"));

var _VerticalProgressBarItem = _interopRequireDefault(require("./VerticalProgressBarItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe("<VerticalProgressBarItem>", function () {
  it("renders without errors", function () {
    var error;

    try {
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_VerticalProgressBarItem["default"], null));
    } catch (theError) {
      error = theError;
    }

    expect(error).toEqual(undefined);
  });
  it("renders correct snapshot", function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_VerticalProgressBarItem["default"], null));
    expect((0, _enzymeToJson["default"])(wrapper)).toMatchSnapshot();
  });
  describe("children prop", function () {
    it("renders given children", function () {
      var child = /*#__PURE__*/_react["default"].createElement("span", null, "this is a child");

      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_VerticalProgressBarItem["default"], null, child));
      expect(wrapper.text()).toContain("this is a child");
    });
  });
  describe("classes prop", function () {
    it("applies classes to the root node of VerticalProgressBarItem", function () {
      var classes = ["classOne"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_VerticalProgressBarItem["default"], {
        classes: classes
      }));
      expect(wrapper.find("VerticalProgressBarItem").childAt(0).hasClass(classes[0])).toEqual(true);
    });
    it("appends higher order values to classes prop with withClasses decorator", function () {
      var classes = ["riipen", "riipen-verticalprogressbaritem"];
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_VerticalProgressBarItem["default"], null));
      expect(wrapper.find("VerticalProgressBarItem").props().classes.sort()).toEqual(classes.sort());
    });
    it("gives an error when classes are provided as one string", function () {
      var classes = "classOne classTwo";
      var errors = jest.spyOn(console, "error").mockImplementation();
      (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_VerticalProgressBarItem["default"], {
        classes: classes
      }));
      expect(errors).toHaveBeenCalled();
    });
  });
  describe("color prop", function () {
    it("renders given color", function () {
      var color = "positive";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_VerticalProgressBarItem["default"], {
        color: color
      }));
      expect(wrapper.find(".positive")).toHaveLength(1);
    });
  });
  describe("icon prop", function () {
    it("renders an icon", function () {
      var icon = /*#__PURE__*/_react["default"].createElement("span", null);

      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_VerticalProgressBarItem["default"], {
        icon: icon
      }));
      expect(wrapper.find("FontAwesomeIcon")).toHaveLength(1);
    });
    it("does not render an icon if not provided", function () {
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_VerticalProgressBarItem["default"], null));
      expect(wrapper.find("FontAwesomeIcon")).toHaveLength(0);
    });
  });
  describe("bar prop", function () {
    it("passes correct class when bar and color provided", function () {
      var color = "positive";
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_VerticalProgressBarItem["default"], {
        color: color
      }));
      expect(wrapper.find(".progress-positive")).toHaveLength(1);
    });
    it("has correct classes when bar ", function () {
      var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react["default"].createElement(_VerticalProgressBarItem["default"], {
        bar: false
      }));
      expect(wrapper.find(".progress-none")).toHaveLength(1);
    });
  });
});