"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _default = {
  breakpoints: {
    xs: 320,
    sm: 480,
    md: 960,
    lg: 1280,
    xl: 1920
  },
  palette: {
    background: {
      "default": "#fafafa"
    },
    common: {
      black: "#000",
      white: "#fff"
    },
    divider: "#ddd",
    disabled: "#cccbcb",
    grey: {
      50: "#fafafa",
      100: "#f5f5f5",
      200: "#eeeeee",
      300: "#dddddd",
      400: "#cccbcb",
      500: "#9a9a9a",
      600: "#747474",
      800: "#424242",
      900: "#212121",
      A100: "#d5d5d5",
      A400: "#373737"
    },
    negative: {
      dark: "#ba2222",
      light: "#ea7e7e",
      main: "#e95353",
      contrast: "#fff"
    },
    warning: {
      dark: "#cf890e",
      light: "#ffd894",
      main: "#febb46",
      contrast: "#fff"
    },
    positive: {
      dark: "#1b965c",
      light: "#78dbac",
      main: "#4cc88d",
      contrast: "#fff"
    },
    primary: {
      dark: "#254364",
      light: "#2c8ddc",
      main: "#1f71ae",
      contrast: "#fff"
    },
    secondary: {
      dark: "#ed7321",
      light: "#f5bf95",
      main: "#f58632",
      contrast: "#fff"
    },
    tertiary: {
      dark: "#41978a",
      light: "#78becc",
      main: "#3caabb",
      contrast: "#fff"
    },
    text: {
      primary: "#373737",
      secondary: "#747474",
      disabled: "#cccbcb",
      hint: "rgba(0, 0, 0, 0.38)"
    }
  },
  shadows: {
    0: "none",
    1: "0px 2px 1px -1px rgba(0,0,0,0.2),0px 1px 1px 0px rgba(0,0,0,0.14),0px 1px 3px 0px rgba(0,0,0,0.12)",
    2: "0px 3px 1px -2px rgba(0,0,0,0.2),0px 2px 2px 0px rgba(0,0,0,0.14),0px 1px 5px 0px rgba(0,0,0,0.12)",
    3: "0px 3px 3px -2px rgba(0,0,0,0.2),0px 3px 4px 0px rgba(0,0,0,0.14),0px 1px 8px 0px rgba(0,0,0,0.12)",
    4: "0px 2px 4px -1px rgba(0,0,0,0.2),0px 4px 5px 0px rgba(0,0,0,0.14),0px 1px 10px 0px rgba(0,0,0,0.12)",
    5: "0px 3px 5px -1px rgba(0,0,0,0.2),0px 5px 8px 0px rgba(0,0,0,0.14),0px 1px 14px 0px rgba(0,0,0,0.12)",
    6: "0px 3px 5px -1px rgba(0,0,0,0.2),0px 6px 10px 0px rgba(0,0,0,0.14),0px 1px 18px 0px rgba(0,0,0,0.12)",
    7: "0px 4px 5px -2px rgba(0,0,0,0.2),0px 7px 10px 1px rgba(0,0,0,0.14),0px 2px 16px 1px rgba(0,0,0,0.12)",
    8: "0px 5px 5px -3px rgba(0,0,0,0.2),0px 8px 10px 1px rgba(0,0,0,0.14),0px 3px 14px 2px rgba(0,0,0,0.12)",
    9: "0px 5px 6px -3px rgba(0,0,0,0.2),0px 9px 12px 1px rgba(0,0,0,0.14),0px 3px 16px 2px rgba(0,0,0,0.12)",
    10: "0px 6px 6px -3px rgba(0,0,0,0.2),0px 10px 14px 1px rgba(0,0,0,0.14),0px 4px 18px 3px rgba(0,0,0,0.12)",
    11: "0px 6px 7px -4px rgba(0,0,0,0.2),0px 11px 15px 1px rgba(0,0,0,0.14),0px 4px 20px 3px rgba(0,0,0,0.12)",
    12: "0px 7px 8px -4px rgba(0,0,0,0.2),0px 12px 17px 2px rgba(0,0,0,0.14),0px 5px 22px 4px rgba(0,0,0,0.12)",
    13: "0px 7px 8px -4px rgba(0,0,0,0.2),0px 13px 19px 2px rgba(0,0,0,0.14),0px 5px 24px 4px rgba(0,0,0,0.12)",
    14: "0px 7px 9px -4px rgba(0,0,0,0.2),0px 14px 21px 2px rgba(0,0,0,0.14),0px 5px 26px 4px rgba(0,0,0,0.12)",
    15: "0px 8px 9px -5px rgba(0,0,0,0.2),0px 15px 22px 2px rgba(0,0,0,0.14),0px 6px 28px 5px rgba(0,0,0,0.12)",
    16: "0px 8px 10px -5px rgba(0,0,0,0.2),0px 16px 24px 2px rgba(0,0,0,0.14),0px 6px 30px 5px rgba(0,0,0,0.12)",
    17: "0px 8px 11px -5px rgba(0,0,0,0.2),0px 17px 26px 2px rgba(0,0,0,0.14),0px 6px 32px 5px rgba(0,0,0,0.12)",
    18: "0px 9px 11px -5px rgba(0,0,0,0.2),0px 18px 28px 2px rgba(0,0,0,0.14),0px 7px 34px 6px rgba(0,0,0,0.12)",
    19: "0px 9px 12px -6px rgba(0,0,0,0.2),0px 19px 29px 2px rgba(0,0,0,0.14),0px 7px 36px 6px rgba(0,0,0,0.12)",
    20: "0px 10px 13px -6px rgba(0,0,0,0.2),0px 20px 31px 3px rgba(0,0,0,0.14),0px 8px 38px 7px rgba(0,0,0,0.12)",
    21: "0px 10px 13px -6px rgba(0,0,0,0.2),0px 21px 33px 3px rgba(0,0,0,0.14),0px 8px 40px 7px rgba(0,0,0,0.12)",
    22: "0px 10px 14px -6px rgba(0,0,0,0.2),0px 22px 35px 3px rgba(0,0,0,0.14),0px 8px 42px 7px rgba(0,0,0,0.12)",
    23: "0px 11px 14px -7px rgba(0,0,0,0.2),0px 23px 36px 3px rgba(0,0,0,0.14),0px 9px 44px 8px rgba(0,0,0,0.12)",
    24: "0px 11px 15px -7px rgba(0,0,0,0.2),0px 24px 38px 3px rgba(0,0,0,0.14),0px 9px 46px 8px rgba(0,0,0,0.12)"
  },
  shape: {
    borderRadius: {
      sm: "3px",
      md: "4px",
      lg: "6px",
      xl: "8px"
    }
  },
  spacing: function spacing(factor) {
    return 4 * factor;
  },
  transitions: {
    create: function create() {
      var properties = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      return properties.map(function (property) {
        return "".concat(property, " ").concat(options.duration || 300, "ms ").concat(options.easing || "cubic-bezier(0.4, 0, 0.2, 1)");
      }).join(", ");
    },
    duration: {
      shortest: 150,
      shorter: 200,
      "short": 250,
      standard: 300,
      complex: 375
    },
    easing: {
      easeInOut: "cubic-bezier(0.4, 0, 0.2, 1)",
      easeOut: "cubic-bezier(0.0, 0, 0.2, 1)",
      easeIn: "cubic-bezier(0.4, 0, 1, 1)",
      sharp: "cubic-bezier(0.4, 0, 0.6, 1)"
    }
  },
  typography: {
    body1: {
      fontFamily: "Roboto, Helvetica, Arial, sans-serif",
      fontWeight: 400,
      fontSize: "16px",
      lineHeight: "24px",
      letterSpacing: "0.00938em",
      mobile: {
        fontSize: "14px",
        lineHeight: "20px"
      }
    },
    body2: {
      fontFamily: "Roboto, Helvetica, Arial, sans-serif",
      fontWeight: 400,
      fontSize: "14px",
      lineHeight: "20px",
      letterSpacing: "0.01071em",
      mobile: {
        fontSize: "12px",
        lineHeight: "16px"
      }
    },
    body3: {
      fontFamily: "Roboto, Helvetica, Arial, sans-serif",
      fontWeight: 400,
      fontSize: "12px",
      lineHeight: "16px",
      letterSpacing: "0.01071em",
      mobile: {
        fontSize: "11px",
        lineHeight: "16px"
      }
    },
    button: {
      fontFamily: "Roboto, Helvetica, Arial, sans-serif",
      fontWeight: 500,
      fontSize: "13px",
      lineHeight: "20px",
      letterSpacing: "0.02857em",
      mobile: {
        fontSize: "12px",
        lineHeight: "16px"
      }
    },
    fontFamily: "Roboto, Helvetica, Arial, sans-serif",
    fontWeight: {
      bold: 700,
      light: 300,
      medium: 500,
      regular: 400
    },
    h1: {
      fontFamily: "Roboto, Helvetica, Arial, sans-serif",
      fontWeight: 500,
      fontSize: "40px",
      lineHeight: "56px",
      letterSpacing: "-0.01562em",
      mobile: {
        fontSize: "30px",
        lineHeight: "44px"
      }
    },
    h2: {
      fontFamily: "Roboto, Helvetica, Arial, sans-serif",
      fontWeight: 500,
      fontSize: "30px",
      lineHeight: "44px",
      letterSpacing: "-0.00833em",
      mobile: {
        fontSize: "22px",
        lineHeight: "32px"
      }
    },
    h3: {
      fontFamily: "Roboto, Helvetica, Arial, sans-serif",
      fontWeight: 500,
      fontSize: "22px",
      lineHeight: "32px",
      letterSpacing: "0em",
      mobile: {
        fontSize: "18px",
        lineHeight: "28px"
      }
    },
    h4: {
      fontFamily: "Roboto, Helvetica, Arial, sans-serif",
      fontWeight: 400,
      fontSize: "20px",
      lineHeight: "28px",
      letterSpacing: "-0.00735em",
      mobile: {
        fontSize: "16px",
        lineHeight: "24px"
      }
    },
    h5: {
      fontFamily: "Roboto, Helvetica, Arial, sans-serif",
      fontWeight: 400,
      fontSize: "16px",
      lineHeight: "24px",
      letterSpacing: "0rem",
      mobile: {
        fontSize: "14px",
        lineHeight: "20px"
      }
    }
  },
  zIndex: {
    zero: 0,
    lowest: 1,
    low: 2,
    middle: 3,
    high: 4,
    highest: 5,
    above: 6
  }
};
exports["default"] = _default;